/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AArch64PreLegalizerCombinerImpl Combiner Match Table                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AArch64PreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 193;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 144;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 143;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 198;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 89;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 192;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 88;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 196;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 197;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 94;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 212;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 187;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 131;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 206;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 145;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 189;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 175;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 132;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 127;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 173;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 174;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 161;	 // "commute_shift"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 69;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 124;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 205;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 125;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 172;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 171;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 204;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 207;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 85;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 159;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 170;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 91;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 106;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 54;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 105;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 160;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 68;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 152;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 62;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 142;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 83;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 129;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 58;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 61;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 60;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 59;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 63;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 55;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 188;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 121;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 71;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 90;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 110;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 168;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 153;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 81;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 149;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 123;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 150;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 72;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 128;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 86;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 146;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 135;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 134;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 147;	 // "expand_const_fpowi"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_global_offset", 16) != 0)
          break;
        return 216;	 // "fold_global_offset"
      case 'p':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "trunc_fpext_fold", 16) != 0)
          break;
        return 99;	 // "fptrunc_fpext_fold"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
            break;
          return 56;	 // "select_of_truncate"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
            break;
          return 118;	 // "sext_inreg_of_load"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "uffle_to_extract", 16) != 0)
          break;
        return 217;	 // "shuffle_to_extract"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 16 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 87;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 141;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 166;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 137;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 136;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xt", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "uaddv_to_uaddlv", 15) != 0)
          break;
        return 219;	 // "ext_uaddv_to_uaddlv"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "nd_through_phis", 15) != 0)
          break;
        return 102;	 // "extend_through_phis"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 64;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 211;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 108;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 107;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 84;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 122;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 103;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 194;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 76;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 177;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 98;	 // "bitcast_bitcast_fold"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_redundant_trunc", 19) != 0)
        break;
      return 215;	 // "icmp_redundant_trunc"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 210;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 119;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 126;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 77;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 209;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 195;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 169;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 138;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xt_addv_to_udot_addv", 20) != 0)
        break;
      return 218;	 // "ext_addv_to_udot_addv"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "constant_to_constant", 20) != 0)
        break;
      return 214;	 // "fconstant_to_constant"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'p':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ush_", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "dd_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 223;	 // "push_add_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 221;	 // "push_add_through_zext"
        }
        break;
      case 's':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "ub_through_", 11) != 0)
          break;
        switch (RuleIdentifier[17]) {
        default: break;
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 222;	 // "push_sub_through_sext"
        case 'z':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+18, "ext", 3) != 0)
            break;
          return 220;	 // "push_sub_through_zext"
        }
        break;
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 93;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 73;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 208;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 199;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 167;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 186;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 157;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 158;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 155;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 112;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 213;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 78;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 176;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 92;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 116;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 96;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 57;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 156;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 140;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 79;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 74;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 120;	 // "narrow_binop_feeding_and"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "f_sext_inreg", 12) != 0)
          break;
        return 53;	 // "sext_inreg_of_sext_inreg"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "o_zext_inreg", 12) != 0)
          break;
        return 130;	 // "sext_inreg_to_zext_inreg"
      }
      break;
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 148;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 164;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 95;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 200;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 66;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 117;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 101;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 75;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 191;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 154;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 100;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 202;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 190;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 114;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 115;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 97;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 203;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 113;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 133;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 80;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 151;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 165;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 70;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 201;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 111;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 162;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 178;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 182;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 67;	 // "extract_all_elts_from_build_vector"
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 180;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 65;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 82;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 183;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 104;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 179;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 184;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 181;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 185;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 224}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AArch64PreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AArch64PreLegalizerCombinerOption;
static cl::list<std::string> AArch64PreLegalizerCombinerDisableOption(
    "aarch64prelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AArch64PreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AArch64PreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AArch64PreLegalizerCombinerOnlyEnableOption(
    "aarch64prelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AArch64PreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AArch64PreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AArch64PreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AArch64PreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AArch64PreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AArch64PreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 1;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64PreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64PreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64PreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasDotProdBit = 0,
};

PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  return Features;
}

void AArch64PreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64PreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AArch64PreLegalizerCombinerImpl::ComplexMatcherMemFn
AArch64PreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool AArch64PreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64PreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
  GICXXPred_Simple_IsRule218Enabled,
  GICXXPred_Simple_IsRule219Enabled,
  GICXXPred_Simple_IsRule220Enabled,
  GICXXPred_Simple_IsRule221Enabled,
  GICXXPred_Simple_IsRule222Enabled,
  GICXXPred_Simple_IsRule223Enabled,
};

bool AArch64PreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AArch64PreLegalizerCombinerImpl::CustomRendererFn
AArch64PreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AArch64PreLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
  GICXXCustomAction_GICombiner155,
  GICXXCustomAction_GICombiner156,
  GICXXCustomAction_GICombiner157,
};
bool AArch64PreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    // Match Patterns
    if(![&](){return matchFConstantToConstant(*State.MIs[0], MRI);}()) {
      return false;
    }
    // Apply Patterns
    applyFConstantToConstant(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchICmpRedundantTrunc(*State.MIs[0], MRI, Helper.getValueTracking(), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyICmpRedundantTrunc(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    std::pair<uint64_t, uint64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchFoldGlobalOffset(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyFoldGlobalOffset(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    // Match Patterns
    if(![&](){return Helper.matchShuffleToExtract(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShuffleToExtract(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner155:{
    std::tuple<Register, Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtAddvToUdotAddv(*State.MIs[0], MRI, STI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtAddvToUdotAddv(*State.MIs[0], MRI, B, Observer, STI, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner156:{
    std::pair<Register, bool> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchExtUaddvToUaddlv(*State.MIs[0], MRI, GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyExtUaddvToUaddlv(*State.MIs[0], MRI, B, Observer, GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner157:{
    // Match Patterns
    if(![&](){return matchPushAddSubExt(*State.MIs[0], MRI, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());}()) {
      return false;
    }
    // Apply Patterns
    applyPushAddSubExt(*State.MIs[0], MRI, B, State.MIs[1]->getOpcode() == TargetOpcode::G_SEXT, State.MIs[0]->getOperand(0).getReg(), State.MIs[1]->getOperand(1).getReg(), State.MIs[2]->getOperand(1).getReg());
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64PreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(298), /*)*//*default:*//*Label 98*/ GIMT_Encode4(7343),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(1122), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(1134),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1749),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(2125),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2291),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2364),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2448),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2493), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2560),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2841),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(3086), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(3187), GIMT_Encode4(0),
     /*  210 */ /*TargetOpcode::G_GLOBAL_VALUE*//*Label 12*/ GIMT_Encode4(3199), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 13*/ GIMT_Encode4(3211), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 14*/ GIMT_Encode4(3278),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 15*/ GIMT_Encode4(3352),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 16*/ GIMT_Encode4(3400),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 17*/ GIMT_Encode4(3412),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 18*/ GIMT_Encode4(3424),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 19*/ GIMT_Encode4(3467),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 20*/ GIMT_Encode4(3500),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 21*/ GIMT_Encode4(3543), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 22*/ GIMT_Encode4(3607),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 23*/ GIMT_Encode4(3619),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 24*/ GIMT_Encode4(3631), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 25*/ GIMT_Encode4(3643), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 26*/ GIMT_Encode4(3655),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 27*/ GIMT_Encode4(3783), GIMT_Encode4(0),
     /*  474 */ /*TargetOpcode::G_FCONSTANT*//*Label 28*/ GIMT_Encode4(4141), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  486 */ /*TargetOpcode::G_SEXT*//*Label 29*/ GIMT_Encode4(4153),
     /*  490 */ /*TargetOpcode::G_SEXT_INREG*//*Label 30*/ GIMT_Encode4(4228),
     /*  494 */ /*TargetOpcode::G_ZEXT*//*Label 31*/ GIMT_Encode4(4294),
     /*  498 */ /*TargetOpcode::G_SHL*//*Label 32*/ GIMT_Encode4(4424),
     /*  502 */ /*TargetOpcode::G_LSHR*//*Label 33*/ GIMT_Encode4(4593),
     /*  506 */ /*TargetOpcode::G_ASHR*//*Label 34*/ GIMT_Encode4(4716),
     /*  510 */ /*TargetOpcode::G_FSHL*//*Label 35*/ GIMT_Encode4(4850),
     /*  514 */ /*TargetOpcode::G_FSHR*//*Label 36*/ GIMT_Encode4(4893),
     /*  518 */ /*TargetOpcode::G_ROTR*//*Label 37*/ GIMT_Encode4(4936),
     /*  522 */ /*TargetOpcode::G_ROTL*//*Label 38*/ GIMT_Encode4(4960),
     /*  526 */ /*TargetOpcode::G_ICMP*//*Label 39*/ GIMT_Encode4(4984),
     /*  530 */ /*TargetOpcode::G_FCMP*//*Label 40*/ GIMT_Encode4(5040), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  542 */ /*TargetOpcode::G_SELECT*//*Label 41*/ GIMT_Encode4(5052),
     /*  546 */ /*TargetOpcode::G_UADDO*//*Label 42*/ GIMT_Encode4(5147),
     /*  550 */ /*TargetOpcode::G_UADDE*//*Label 43*/ GIMT_Encode4(5170),
     /*  554 */ /*TargetOpcode::G_USUBO*//*Label 44*/ GIMT_Encode4(5182),
     /*  558 */ /*TargetOpcode::G_USUBE*//*Label 45*/ GIMT_Encode4(5194),
     /*  562 */ /*TargetOpcode::G_SADDO*//*Label 46*/ GIMT_Encode4(5206),
     /*  566 */ /*TargetOpcode::G_SADDE*//*Label 47*/ GIMT_Encode4(5229),
     /*  570 */ /*TargetOpcode::G_SSUBO*//*Label 48*/ GIMT_Encode4(5241),
     /*  574 */ /*TargetOpcode::G_SSUBE*//*Label 49*/ GIMT_Encode4(5253),
     /*  578 */ /*TargetOpcode::G_UMULO*//*Label 50*/ GIMT_Encode4(5265),
     /*  582 */ /*TargetOpcode::G_SMULO*//*Label 51*/ GIMT_Encode4(5299),
     /*  586 */ /*TargetOpcode::G_UMULH*//*Label 52*/ GIMT_Encode4(5333),
     /*  590 */ /*TargetOpcode::G_SMULH*//*Label 53*/ GIMT_Encode4(5356),
     /*  594 */ /*TargetOpcode::G_UADDSAT*//*Label 54*/ GIMT_Encode4(5368),
     /*  598 */ /*TargetOpcode::G_SADDSAT*//*Label 55*/ GIMT_Encode4(5380), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  610 */ /*TargetOpcode::G_USHLSAT*//*Label 56*/ GIMT_Encode4(5392),
     /*  614 */ /*TargetOpcode::G_SSHLSAT*//*Label 57*/ GIMT_Encode4(5415),
     /*  618 */ /*TargetOpcode::G_SMULFIX*//*Label 58*/ GIMT_Encode4(5438),
     /*  622 */ /*TargetOpcode::G_UMULFIX*//*Label 59*/ GIMT_Encode4(5450),
     /*  626 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 60*/ GIMT_Encode4(5462),
     /*  630 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 61*/ GIMT_Encode4(5474), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  650 */ /*TargetOpcode::G_FADD*//*Label 62*/ GIMT_Encode4(5486),
     /*  654 */ /*TargetOpcode::G_FSUB*//*Label 63*/ GIMT_Encode4(5598),
     /*  658 */ /*TargetOpcode::G_FMUL*//*Label 64*/ GIMT_Encode4(5687),
     /*  662 */ /*TargetOpcode::G_FMA*//*Label 65*/ GIMT_Encode4(5775),
     /*  666 */ /*TargetOpcode::G_FMAD*//*Label 66*/ GIMT_Encode4(5798),
     /*  670 */ /*TargetOpcode::G_FDIV*//*Label 67*/ GIMT_Encode4(5821),
     /*  674 */ /*TargetOpcode::G_FREM*//*Label 68*/ GIMT_Encode4(5855), GIMT_Encode4(0),
     /*  682 */ /*TargetOpcode::G_FPOWI*//*Label 69*/ GIMT_Encode4(5867), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  702 */ /*TargetOpcode::G_FLOG2*//*Label 70*/ GIMT_Encode4(5889), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FNEG*//*Label 71*/ GIMT_Encode4(5911), GIMT_Encode4(0),
     /*  726 */ /*TargetOpcode::G_FPTRUNC*//*Label 72*/ GIMT_Encode4(5962),
     /*  730 */ /*TargetOpcode::G_FPTOSI*//*Label 73*/ GIMT_Encode4(6005),
     /*  734 */ /*TargetOpcode::G_FPTOUI*//*Label 74*/ GIMT_Encode4(6027),
     /*  738 */ /*TargetOpcode::G_SITOFP*//*Label 75*/ GIMT_Encode4(6049),
     /*  742 */ /*TargetOpcode::G_UITOFP*//*Label 76*/ GIMT_Encode4(6076), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  754 */ /*TargetOpcode::G_FABS*//*Label 77*/ GIMT_Encode4(6103), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  766 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 78*/ GIMT_Encode4(6182),
     /*  770 */ /*TargetOpcode::G_FMINNUM*//*Label 79*/ GIMT_Encode4(6212),
     /*  774 */ /*TargetOpcode::G_FMAXNUM*//*Label 80*/ GIMT_Encode4(6246),
     /*  778 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 81*/ GIMT_Encode4(6280),
     /*  782 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 82*/ GIMT_Encode4(6292),
     /*  786 */ /*TargetOpcode::G_FMINIMUM*//*Label 83*/ GIMT_Encode4(6304),
     /*  790 */ /*TargetOpcode::G_FMAXIMUM*//*Label 84*/ GIMT_Encode4(6338), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  818 */ /*TargetOpcode::G_PTR_ADD*//*Label 85*/ GIMT_Encode4(6372), GIMT_Encode4(0),
     /*  826 */ /*TargetOpcode::G_SMIN*//*Label 86*/ GIMT_Encode4(6462),
     /*  830 */ /*TargetOpcode::G_SMAX*//*Label 87*/ GIMT_Encode4(6496),
     /*  834 */ /*TargetOpcode::G_UMIN*//*Label 88*/ GIMT_Encode4(6530),
     /*  838 */ /*TargetOpcode::G_UMAX*//*Label 89*/ GIMT_Encode4(6564),
     /*  842 */ /*TargetOpcode::G_ABS*//*Label 90*/ GIMT_Encode4(6598), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  854 */ /*TargetOpcode::G_BR*//*Label 91*/ GIMT_Encode4(6610), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  874 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(6622),
     /*  878 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 93*/ GIMT_Encode4(6752),
     /*  882 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 94*/ GIMT_Encode4(7129), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  922 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(7206), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  974 */ /*TargetOpcode::G_FSQRT*//*Label 96*/ GIMT_Encode4(7295), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 1118 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 97*/ GIMT_Encode4(7317),
     /* 1122 */ // Label 0: @1122
     /* 1122 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1133), // Rule ID 13 //
     /* 1127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 1130 */   // MIs[0] d
     /* 1130 */   // No operand predicates
     /* 1130 */   // MIs[0] s
     /* 1130 */   // No operand predicates
     /* 1130 */   // Combiner Rule #13: copy_prop
     /* 1130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 1133 */ // Label 99: @1133
     /* 1133 */ GIM_Reject,
     /* 1134 */ // Label 1: @1134
     /* 1134 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1145), // Rule ID 16 //
     /* 1139 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 1142 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 1142 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1145 */ // Label 100: @1145
     /* 1145 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1156), // Rule ID 94 //
     /* 1150 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1153 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1153 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1156 */ // Label 101: @1156
     /* 1156 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1167), // Rule ID 141 //
     /* 1161 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 1164 */   // Combiner Rule #103: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1164 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1167 */ // Label 102: @1167
     /* 1167 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1178), // Rule ID 231 //
     /* 1172 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1175 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1175 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1178 */ // Label 103: @1178
     /* 1178 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1189), // Rule ID 279 //
     /* 1183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1186 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1186 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1189 */ // Label 104: @1189
     /* 1189 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1200), // Rule ID 308 //
     /* 1194 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 1197 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1197 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1200 */ // Label 105: @1200
     /* 1200 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1234), // Rule ID 0 //
     /* 1205 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1208 */   // MIs[0] root
     /* 1208 */   // No operand predicates
     /* 1208 */   // MIs[0] sub
     /* 1208 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1216 */   // MIs[1] Operand 1
     /* 1216 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1220 */   // MIs[1] A
     /* 1220 */   // No operand predicates
     /* 1220 */   // MIs[0] B
     /* 1220 */   // No operand predicates
     /* 1220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1222 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1225 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1227 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1229 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1233 */   GIR_EraseRootFromParent_Done,
     /* 1234 */ // Label 106: @1234
     /* 1234 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1271), // Rule ID 12 //
     /* 1239 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1242 */   // MIs[0] root
     /* 1242 */   // No operand predicates
     /* 1242 */   // MIs[0] sub
     /* 1242 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1250 */   // MIs[1] A
     /* 1250 */   // No operand predicates
     /* 1250 */   // MIs[1] c1
     /* 1250 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1254 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1258 */   // MIs[2] imm1
     /* 1258 */   // No operand predicates
     /* 1258 */   // MIs[0] c2
     /* 1258 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1262 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1266 */   // MIs[3] imm2
     /* 1266 */   // No operand predicates
     /* 1266 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1268 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1268 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1271 */ // Label 107: @1271
     /* 1271 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1305), // Rule ID 3 //
     /* 1276 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1279 */   // MIs[0] root
     /* 1279 */   // No operand predicates
     /* 1279 */   // MIs[0] sub
     /* 1279 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1283 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1287 */   // MIs[1] B
     /* 1287 */   // No operand predicates
     /* 1287 */   // MIs[1] A
     /* 1287 */   // No operand predicates
     /* 1287 */   // MIs[0] A
     /* 1287 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1292 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1297 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1299 */   // Combiner Rule #3: BMinusAPlusA
     /* 1299 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1304 */   GIR_EraseRootFromParent_Done,
     /* 1305 */ // Label 108: @1305
     /* 1305 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1339), // Rule ID 131 //
     /* 1310 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1313 */   // MIs[0] dst
     /* 1313 */   // No operand predicates
     /* 1313 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1313 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1317 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1321 */   // MIs[1] src
     /* 1321 */   // No operand predicates
     /* 1321 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1321 */   // No operand predicates
     /* 1321 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1321 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1326 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1331 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1333 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1333 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1338 */   GIR_EraseRootFromParent_Done,
     /* 1339 */ // Label 109: @1339
     /* 1339 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1384), // Rule ID 5 //
     /* 1344 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1347 */   // MIs[0] root
     /* 1347 */   // No operand predicates
     /* 1347 */   // MIs[0] sub1
     /* 1347 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1355 */   // MIs[1] A
     /* 1355 */   // No operand predicates
     /* 1355 */   // MIs[1] B
     /* 1355 */   // No operand predicates
     /* 1355 */   // MIs[0] sub2
     /* 1355 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1359 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1363 */   // MIs[2] B
     /* 1363 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1368 */   // MIs[2] C
     /* 1368 */   // No operand predicates
     /* 1368 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1370 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1373 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1375 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1379 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1383 */   GIR_EraseRootFromParent_Done,
     /* 1384 */ // Label 110: @1384
     /* 1384 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1429), // Rule ID 4 //
     /* 1389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1392 */   // MIs[0] root
     /* 1392 */   // No operand predicates
     /* 1392 */   // MIs[0] sub1
     /* 1392 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1396 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1400 */   // MIs[1] A
     /* 1400 */   // No operand predicates
     /* 1400 */   // MIs[1] B
     /* 1400 */   // No operand predicates
     /* 1400 */   // MIs[0] sub2
     /* 1400 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1404 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1408 */   // MIs[2] C
     /* 1408 */   // No operand predicates
     /* 1408 */   // MIs[2] A
     /* 1408 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1413 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1415 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1418 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1420 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1424 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1428 */   GIR_EraseRootFromParent_Done,
     /* 1429 */ // Label 111: @1429
     /* 1429 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1458), // Rule ID 370 //
     /* 1434 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule223Enabled),
     /* 1437 */   // MIs[0] dst
     /* 1437 */   // No operand predicates
     /* 1437 */   // MIs[0] ext1
     /* 1437 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1441 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1445 */   // MIs[1] src1
     /* 1445 */   // No operand predicates
     /* 1445 */   // MIs[0] ext2
     /* 1445 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1449 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1453 */   // MIs[2] src2
     /* 1453 */   // No operand predicates
     /* 1453 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1455 */   // Combiner Rule #223: push_add_through_sext
     /* 1455 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1458 */ // Label 112: @1458
     /* 1458 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1493), // Rule ID 39 //
     /* 1463 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1466 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1472 */   // MIs[0] root
     /* 1472 */   // No operand predicates
     /* 1472 */   // MIs[0] left
     /* 1472 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1480 */   // MIs[1] imm1
     /* 1480 */   // No operand predicates
     /* 1480 */   // MIs[0] right
     /* 1480 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1484 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1488 */   // MIs[2] imm2
     /* 1488 */   // No operand predicates
     /* 1488 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1490 */   // Combiner Rule #37: add_of_vscale
     /* 1490 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1493 */ // Label 113: @1493
     /* 1493 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1522), // Rule ID 368 //
     /* 1498 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule221Enabled),
     /* 1501 */   // MIs[0] dst
     /* 1501 */   // No operand predicates
     /* 1501 */   // MIs[0] ext1
     /* 1501 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1505 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1509 */   // MIs[1] src1
     /* 1509 */   // No operand predicates
     /* 1509 */   // MIs[0] ext2
     /* 1509 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1513 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1517 */   // MIs[2] src2
     /* 1517 */   // No operand predicates
     /* 1517 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1519 */   // Combiner Rule #221: push_add_through_zext
     /* 1519 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1522 */ // Label 114: @1522
     /* 1522 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1556), // Rule ID 1 //
     /* 1527 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1530 */   // MIs[0] root
     /* 1530 */   // No operand predicates
     /* 1530 */   // MIs[0] A
     /* 1530 */   // No operand predicates
     /* 1530 */   // MIs[0] sub
     /* 1530 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1534 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1538 */   // MIs[1] Operand 1
     /* 1538 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1542 */   // MIs[1] B
     /* 1542 */   // No operand predicates
     /* 1542 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1544 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1547 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1549 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1551 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1555 */   GIR_EraseRootFromParent_Done,
     /* 1556 */ // Label 115: @1556
     /* 1556 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1590), // Rule ID 2 //
     /* 1561 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1564 */   // MIs[0] root
     /* 1564 */   // No operand predicates
     /* 1564 */   // MIs[0] A
     /* 1564 */   // No operand predicates
     /* 1564 */   // MIs[0] sub
     /* 1564 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1572 */   // MIs[1] B
     /* 1572 */   // No operand predicates
     /* 1572 */   // MIs[1] A
     /* 1572 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1577 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1582 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1584 */   // Combiner Rule #2: APlusBMinusB
     /* 1584 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1589 */   GIR_EraseRootFromParent_Done,
     /* 1590 */ // Label 116: @1590
     /* 1590 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1624), // Rule ID 130 //
     /* 1595 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1598 */   // MIs[0] dst
     /* 1598 */   // No operand predicates
     /* 1598 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1598 */   // No operand predicates
     /* 1598 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1598 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1606 */   // MIs[1] src
     /* 1606 */   // No operand predicates
     /* 1606 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1606 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1611 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1616 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1618 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1618 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1623 */   GIR_EraseRootFromParent_Done,
     /* 1624 */ // Label 117: @1624
     /* 1624 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1669), // Rule ID 6 //
     /* 1629 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1632 */   // MIs[0] root
     /* 1632 */   // No operand predicates
     /* 1632 */   // MIs[0] A
     /* 1632 */   // No operand predicates
     /* 1632 */   // MIs[0] sub1
     /* 1632 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1636 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1640 */   // MIs[1] B
     /* 1640 */   // No operand predicates
     /* 1640 */   // MIs[1] add1
     /* 1640 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1644 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1648 */   // MIs[2] A
     /* 1648 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1653 */   // MIs[2] C
     /* 1653 */   // No operand predicates
     /* 1653 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1655 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1658 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1660 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1664 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1668 */   GIR_EraseRootFromParent_Done,
     /* 1669 */ // Label 118: @1669
     /* 1669 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1714), // Rule ID 7 //
     /* 1674 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1677 */   // MIs[0] root
     /* 1677 */   // No operand predicates
     /* 1677 */   // MIs[0] A
     /* 1677 */   // No operand predicates
     /* 1677 */   // MIs[0] sub1
     /* 1677 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1685 */   // MIs[1] B
     /* 1685 */   // No operand predicates
     /* 1685 */   // MIs[1] add1
     /* 1685 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1689 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1693 */   // MIs[2] C
     /* 1693 */   // No operand predicates
     /* 1693 */   // MIs[2] A
     /* 1693 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1698 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1700 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1703 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1705 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1709 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1713 */   GIR_EraseRootFromParent_Done,
     /* 1714 */ // Label 119: @1714
     /* 1714 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1737), // Rule ID 105 //
     /* 1719 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1722 */   // MIs[0] dst
     /* 1722 */   // No operand predicates
     /* 1722 */   // MIs[0] lhs
     /* 1722 */   // No operand predicates
     /* 1722 */   // MIs[0] Operand 2
     /* 1722 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1726 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1731 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1731 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1736 */   GIR_EraseRootFromParent_Done,
     /* 1737 */ // Label 120: @1737
     /* 1737 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1748), // Rule ID 149 //
     /* 1742 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 1745 */   // MIs[0] root
     /* 1745 */   // No operand predicates
     /* 1745 */   // MIs[0] src1
     /* 1745 */   // No operand predicates
     /* 1745 */   // MIs[0] src2
     /* 1745 */   // No operand predicates
     /* 1745 */   // Combiner Rule #107: reassoc_comm_binops
     /* 1745 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1748 */ // Label 121: @1748
     /* 1748 */ GIM_Reject,
     /* 1749 */ // Label 2: @1749
     /* 1749 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1760), // Rule ID 95 //
     /* 1754 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1757 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1757 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1760 */ // Label 122: @1760
     /* 1760 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1771), // Rule ID 239 //
     /* 1765 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1768 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1768 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1771 */ // Label 123: @1771
     /* 1771 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1782), // Rule ID 280 //
     /* 1776 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1779 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1779 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1782 */ // Label 124: @1782
     /* 1782 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1793), // Rule ID 305 //
     /* 1787 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 1790 */   // Combiner Rule #187: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1790 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 1793 */ // Label 125: @1793
     /* 1793 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1804), // Rule ID 339 //
     /* 1798 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 1801 */   // Combiner Rule #194: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1801 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 1804 */ // Label 126: @1804
     /* 1804 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1841), // Rule ID 8 //
     /* 1809 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1812 */   // MIs[0] root
     /* 1812 */   // No operand predicates
     /* 1812 */   // MIs[0] add
     /* 1812 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1820 */   // MIs[1] A
     /* 1820 */   // No operand predicates
     /* 1820 */   // MIs[1] c1
     /* 1820 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1824 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1828 */   // MIs[2] imm1
     /* 1828 */   // No operand predicates
     /* 1828 */   // MIs[0] c2
     /* 1828 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1832 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1836 */   // MIs[3] imm2
     /* 1836 */   // No operand predicates
     /* 1836 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1838 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1838 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1841 */ // Label 127: @1841
     /* 1841 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1878), // Rule ID 11 //
     /* 1846 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1849 */   // MIs[0] root
     /* 1849 */   // No operand predicates
     /* 1849 */   // MIs[0] sub1
     /* 1849 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1853 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1857 */   // MIs[1] c1
     /* 1857 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1861 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1865 */   // MIs[2] imm1
     /* 1865 */   // No operand predicates
     /* 1865 */   // MIs[1] A
     /* 1865 */   // No operand predicates
     /* 1865 */   // MIs[0] c2
     /* 1865 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1869 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1873 */   // MIs[3] imm2
     /* 1873 */   // No operand predicates
     /* 1873 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1875 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1875 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1878 */ // Label 128: @1878
     /* 1878 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1915), // Rule ID 10 //
     /* 1883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1886 */   // MIs[0] root
     /* 1886 */   // No operand predicates
     /* 1886 */   // MIs[0] sub1
     /* 1886 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1890 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1894 */   // MIs[1] A
     /* 1894 */   // No operand predicates
     /* 1894 */   // MIs[1] c1
     /* 1894 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1898 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1902 */   // MIs[2] imm1
     /* 1902 */   // No operand predicates
     /* 1902 */   // MIs[0] c2
     /* 1902 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1906 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1910 */   // MIs[3] imm2
     /* 1910 */   // No operand predicates
     /* 1910 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1912 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1912 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1915 */ // Label 129: @1915
     /* 1915 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1944), // Rule ID 369 //
     /* 1920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule222Enabled),
     /* 1923 */   // MIs[0] dst
     /* 1923 */   // No operand predicates
     /* 1923 */   // MIs[0] ext1
     /* 1923 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1931 */   // MIs[1] src1
     /* 1931 */   // No operand predicates
     /* 1931 */   // MIs[0] ext2
     /* 1931 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1935 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 1939 */   // MIs[2] src2
     /* 1939 */   // No operand predicates
     /* 1939 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1941 */   // Combiner Rule #222: push_sub_through_sext
     /* 1941 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1944 */ // Label 130: @1944
     /* 1944 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1973), // Rule ID 367 //
     /* 1949 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule220Enabled),
     /* 1952 */   // MIs[0] dst
     /* 1952 */   // No operand predicates
     /* 1952 */   // MIs[0] ext1
     /* 1952 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1960 */   // MIs[1] src1
     /* 1960 */   // No operand predicates
     /* 1960 */   // MIs[0] ext2
     /* 1960 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1964 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 1968 */   // MIs[2] src2
     /* 1968 */   // No operand predicates
     /* 1968 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1970 */   // Combiner Rule #220: push_sub_through_zext
     /* 1970 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 1973 */ // Label 131: @1973
     /* 1973 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2016), // Rule ID 159 //
     /* 1978 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 1981 */   // MIs[0] dst
     /* 1981 */   // No operand predicates
     /* 1981 */   // MIs[0] Operand 1
     /* 1981 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 1985 */   // MIs[0] and
     /* 1985 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 1993 */   // MIs[1] x
     /* 1993 */   // No operand predicates
     /* 1993 */   // MIs[1] Operand 2
     /* 1993 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 1997 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 2001 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2003 */   // Combiner Rule #117: neg_and_one_to_sext_inreg
     /* 2003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2006 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2008 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 2012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2015 */   GIR_EraseRootFromParent_Done,
     /* 2016 */ // Label 132: @2016
     /* 2016 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2053), // Rule ID 9 //
     /* 2021 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 2024 */   // MIs[0] root
     /* 2024 */   // No operand predicates
     /* 2024 */   // MIs[0] c2
     /* 2024 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2032 */   // MIs[1] imm2
     /* 2032 */   // No operand predicates
     /* 2032 */   // MIs[0] add
     /* 2032 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2036 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 2040 */   // MIs[2] A
     /* 2040 */   // No operand predicates
     /* 2040 */   // MIs[2] c1
     /* 2040 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 2044 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2048 */   // MIs[3] imm1
     /* 2048 */   // No operand predicates
     /* 2048 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2050 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 2050 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 2053 */ // Label 133: @2053
     /* 2053 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2080), // Rule ID 42 //
     /* 2058 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 2061 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2067 */   // MIs[0] root
     /* 2067 */   // No operand predicates
     /* 2067 */   // MIs[0] x
     /* 2067 */   // No operand predicates
     /* 2067 */   // MIs[0] right
     /* 2067 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2075 */   // MIs[1] imm
     /* 2075 */   // No operand predicates
     /* 2075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2077 */   // Combiner Rule #40: sub_of_vscale
     /* 2077 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 2080 */ // Label 134: @2080
     /* 2080 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2103), // Rule ID 104 //
     /* 2085 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2088 */   // MIs[0] dst
     /* 2088 */   // No operand predicates
     /* 2088 */   // MIs[0] lhs
     /* 2088 */   // No operand predicates
     /* 2088 */   // MIs[0] Operand 2
     /* 2088 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2092 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2097 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 2097 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2102 */   GIR_EraseRootFromParent_Done,
     /* 2103 */ // Label 135: @2103
     /* 2103 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2124), // Rule ID 15 //
     /* 2108 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 2111 */   // MIs[0] d
     /* 2111 */   // No operand predicates
     /* 2111 */   // MIs[0] op1
     /* 2111 */   // No operand predicates
     /* 2111 */   // MIs[0] c
     /* 2111 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2119 */   // MIs[1] imm
     /* 2119 */   // No operand predicates
     /* 2119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2121 */   // Combiner Rule #15: sub_to_add
     /* 2121 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 2124 */ // Label 136: @2124
     /* 2124 */ GIM_Reject,
     /* 2125 */ // Label 3: @2125
     /* 2125 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2136), // Rule ID 78 //
     /* 2130 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2133 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 2133 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2136 */ // Label 137: @2136
     /* 2136 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2147), // Rule ID 236 //
     /* 2141 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2144 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 2144 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2147 */ // Label 138: @2147
     /* 2147 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2158), // Rule ID 309 //
     /* 2152 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2155 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 2155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2158 */ // Label 139: @2158
     /* 2158 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2198), // Rule ID 17 //
     /* 2163 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 2166 */   // MIs[0] dst
     /* 2166 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 2170 */   // MIs[0] x
     /* 2170 */   // No operand predicates
     /* 2170 */   // MIs[0] Operand 2
     /* 2170 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 2174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2177 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 2187 */   // Combiner Rule #17: mul_by_neg_one
     /* 2187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 2190 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 2192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 2197 */   GIR_EraseRootFromParent_Done,
     /* 2198 */ // Label 140: @2198
     /* 2198 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2233), // Rule ID 40 //
     /* 2203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 2206 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 2212 */   // MIs[0] root
     /* 2212 */   // No operand predicates
     /* 2212 */   // MIs[0] left
     /* 2212 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 2220 */   // MIs[1] scale
     /* 2220 */   // No operand predicates
     /* 2220 */   // MIs[0] x
     /* 2220 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228 */   // MIs[2] imm1
     /* 2228 */   // No operand predicates
     /* 2228 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230 */   // Combiner Rule #38: mul_of_vscale
     /* 2230 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 2233 */ // Label 141: @2233
     /* 2233 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2256), // Rule ID 123 //
     /* 2238 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 2241 */   // MIs[0] dst
     /* 2241 */   // No operand predicates
     /* 2241 */   // MIs[0] lhs
     /* 2241 */   // No operand predicates
     /* 2241 */   // MIs[0] zero
     /* 2241 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2245 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2250 */   // Combiner Rule #87: binop_right_to_zero
     /* 2250 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 2255 */   GIR_EraseRootFromParent_Done,
     /* 2256 */ // Label 142: @2256
     /* 2256 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2279), // Rule ID 128 //
     /* 2261 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 2264 */   // MIs[0] dst
     /* 2264 */   // No operand predicates
     /* 2264 */   // MIs[0] x
     /* 2264 */   // No operand predicates
     /* 2264 */   // MIs[0] Operand 2
     /* 2264 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2268 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2273 */   // Combiner Rule #92: right_identity_one_int
     /* 2273 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2278 */   GIR_EraseRootFromParent_Done,
     /* 2279 */ // Label 143: @2279
     /* 2279 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2290), // Rule ID 14 //
     /* 2284 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2287 */   // MIs[0] d
     /* 2287 */   // No operand predicates
     /* 2287 */   // MIs[0] op1
     /* 2287 */   // No operand predicates
     /* 2287 */   // MIs[0] op2
     /* 2287 */   // No operand predicates
     /* 2287 */   // Combiner Rule #14: mul_to_shl
     /* 2287 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2290 */ // Label 144: @2290
     /* 2290 */ GIM_Reject,
     /* 2291 */ // Label 4: @2291
     /* 2291 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2302), // Rule ID 119 //
     /* 2296 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2299 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2299 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2302 */ // Label 145: @2302
     /* 2302 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2313), // Rule ID 211 //
     /* 2307 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2310 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2310 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2313 */ // Label 146: @2313
     /* 2313 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2324), // Rule ID 242 //
     /* 2318 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2321 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2321 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2324 */ // Label 147: @2324
     /* 2324 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2335), // Rule ID 260 //
     /* 2329 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2332 */   // Combiner Rule #172: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2332 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2335 */ // Label 148: @2335
     /* 2335 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2346), // Rule ID 285 //
     /* 2340 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2343 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2343 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2346 */ // Label 149: @2346
     /* 2346 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2363), // Rule ID 261 //
     /* 2351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2354 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2360 */   // MIs[0] dst
     /* 2360 */   // No operand predicates
     /* 2360 */   // MIs[0] x
     /* 2360 */   // No operand predicates
     /* 2360 */   // MIs[0] y
     /* 2360 */   // No operand predicates
     /* 2360 */   // Combiner Rule #173: sdiv_by_pow2
     /* 2360 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2363 */ // Label 150: @2363
     /* 2363 */ GIM_Reject,
     /* 2364 */ // Label 5: @2364
     /* 2364 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2375), // Rule ID 81 //
     /* 2369 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2372 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2372 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2375 */ // Label 151: @2375
     /* 2375 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2386), // Rule ID 120 //
     /* 2380 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2383 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2383 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2386 */ // Label 152: @2386
     /* 2386 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2397), // Rule ID 212 //
     /* 2391 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2394 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2394 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2397 */ // Label 153: @2397
     /* 2397 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2408), // Rule ID 241 //
     /* 2402 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2405 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2405 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2408 */ // Label 154: @2408
     /* 2408 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2419), // Rule ID 259 //
     /* 2413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2416 */   // Combiner Rule #171: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2416 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2419 */ // Label 155: @2419
     /* 2419 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2430), // Rule ID 287 //
     /* 2424 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2427 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2427 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2430 */ // Label 156: @2430
     /* 2430 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2447), // Rule ID 262 //
     /* 2435 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 2438 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2444 */   // MIs[0] dst
     /* 2444 */   // No operand predicates
     /* 2444 */   // MIs[0] x
     /* 2444 */   // No operand predicates
     /* 2444 */   // MIs[0] y
     /* 2444 */   // No operand predicates
     /* 2444 */   // Combiner Rule #174: udiv_by_pow2
     /* 2444 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 2447 */ // Label 157: @2447
     /* 2447 */ GIM_Reject,
     /* 2448 */ // Label 6: @2448
     /* 2448 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2459), // Rule ID 121 //
     /* 2453 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2456 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2456 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2459 */ // Label 158: @2459
     /* 2459 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2470), // Rule ID 213 //
     /* 2464 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2467 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2467 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2470 */ // Label 159: @2470
     /* 2470 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2481), // Rule ID 244 //
     /* 2475 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2478 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2478 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2481 */ // Label 160: @2481
     /* 2481 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2492), // Rule ID 286 //
     /* 2486 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2489 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2489 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2492 */ // Label 161: @2492
     /* 2492 */ GIM_Reject,
     /* 2493 */ // Label 7: @2493
     /* 2493 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2504), // Rule ID 82 //
     /* 2498 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2501 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2501 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2504 */ // Label 162: @2504
     /* 2504 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2515), // Rule ID 122 //
     /* 2509 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2512 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2512 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2515 */ // Label 163: @2515
     /* 2515 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2526), // Rule ID 170 //
     /* 2520 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 2523 */   // Combiner Rule #128: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2523 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 2526 */ // Label 164: @2526
     /* 2526 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2537), // Rule ID 214 //
     /* 2531 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2534 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2534 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2537 */ // Label 165: @2537
     /* 2537 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2548), // Rule ID 243 //
     /* 2542 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2545 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2545 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2548 */ // Label 166: @2548
     /* 2548 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2559), // Rule ID 288 //
     /* 2553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2556 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2556 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2559 */ // Label 167: @2559
     /* 2559 */ GIM_Reject,
     /* 2560 */ // Label 8: @2560
     /* 2560 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2571), // Rule ID 73 //
     /* 2565 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 2568 */   // Combiner Rule #69: load_and_mask; wip_match_opcode 'G_AND'
     /* 2568 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 2571 */ // Label 168: @2571
     /* 2571 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2582), // Rule ID 77 //
     /* 2576 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2579 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2579 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2582 */ // Label 169: @2582
     /* 2582 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2593), // Rule ID 142 //
     /* 2587 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2590 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2590 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2593 */ // Label 170: @2593
     /* 2593 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2604), // Rule ID 162 //
     /* 2598 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 2601 */   // Combiner Rule #120: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2601 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 2604 */ // Label 171: @2604
     /* 2604 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2615), // Rule ID 167 //
     /* 2609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 2612 */   // Combiner Rule #125: redundant_and; wip_match_opcode 'G_AND'
     /* 2612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 2615 */ // Label 172: @2615
     /* 2615 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2626), // Rule ID 184 //
     /* 2620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 2623 */   // Combiner Rule #142: overlapping_and; wip_match_opcode 'G_AND'
     /* 2623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 2626 */ // Label 173: @2626
     /* 2626 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2637), // Rule ID 233 //
     /* 2631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2634 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2634 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2637 */ // Label 174: @2637
     /* 2637 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2648), // Rule ID 270 //
     /* 2642 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 2645 */   // Combiner Rule #177: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2645 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 2648 */ // Label 175: @2648
     /* 2648 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2659), // Rule ID 282 //
     /* 2653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2656 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2656 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2659 */ // Label 176: @2659
     /* 2659 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2670), // Rule ID 310 //
     /* 2664 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2667 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2667 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2670 */ // Label 177: @2670
     /* 2670 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2681), // Rule ID 337 //
     /* 2675 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 2678 */   // Combiner Rule #192: match_ands; wip_match_opcode 'G_AND'
     /* 2678 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2681 */ // Label 178: @2681
     /* 2681 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2779), // Rule ID 155 //
     /* 2686 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2689 */   // MIs[0] root
     /* 2689 */   // No operand predicates
     /* 2689 */   // MIs[0] d1
     /* 2689 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2697 */   // MIs[1] p
     /* 2697 */   // No operand predicates
     /* 2697 */   // MIs[1] s1
     /* 2697 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2701 */   // MIs[1] Operand 3
     /* 2701 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2705 */   // MIs[0] d2
     /* 2705 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2709 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2713 */   // MIs[2] p
     /* 2713 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2718 */   // MIs[2] s2
     /* 2718 */   // No operand predicates
     /* 2718 */   // MIs[2] Operand 3
     /* 2718 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2722 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2726 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2728 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2731 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2744 */   // Combiner Rule #113: double_icmp_zero_and_combine
     /* 2744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2747 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2752 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2756 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2764 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2768 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2772 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2778 */   GIR_EraseRootFromParent_Done,
     /* 2779 */ // Label 179: @2779
     /* 2779 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2816), // Rule ID 226 //
     /* 2784 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 2787 */   // MIs[0] root
     /* 2787 */   // No operand predicates
     /* 2787 */   // MIs[0] shift
     /* 2787 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2795 */   // MIs[1] x
     /* 2795 */   // No operand predicates
     /* 2795 */   // MIs[1] lsb
     /* 2795 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2799 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2803 */   // MIs[2] imm1
     /* 2803 */   // No operand predicates
     /* 2803 */   // MIs[0] mask
     /* 2803 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2807 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2811 */   // MIs[3] imm2
     /* 2811 */   // No operand predicates
     /* 2811 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2813 */   // Combiner Rule #163: bitfield_extract_from_and
     /* 2813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 2816 */ // Label 180: @2816
     /* 2816 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2840), // Rule ID 114 //
     /* 2821 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2824 */   // MIs[0] dst
     /* 2824 */   // No operand predicates
     /* 2824 */   // MIs[0] src
     /* 2824 */   // No operand predicates
     /* 2824 */   // MIs[0] src
     /* 2824 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2829 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2834 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2834 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2839 */   GIR_EraseRootFromParent_Done,
     /* 2840 */ // Label 181: @2840
     /* 2840 */ GIM_Reject,
     /* 2841 */ // Label 9: @2841
     /* 2841 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2852), // Rule ID 79 //
     /* 2846 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2849 */   // Combiner Rule #73: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2849 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2852 */ // Label 182: @2852
     /* 2852 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2863), // Rule ID 143 //
     /* 2857 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2860 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2860 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2863 */ // Label 183: @2863
     /* 2863 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2874), // Rule ID 169 //
     /* 2868 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2871 */   // Combiner Rule #127: redundant_or; wip_match_opcode 'G_OR'
     /* 2871 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2874 */ // Label 184: @2874
     /* 2874 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2885), // Rule ID 210 //
     /* 2879 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2882 */   // Combiner Rule #152: load_or_combine; wip_match_opcode 'G_OR'
     /* 2882 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2885 */ // Label 185: @2885
     /* 2885 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2896), // Rule ID 215 //
     /* 2890 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 2893 */   // Combiner Rule #154: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2893 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 2896 */ // Label 186: @2896
     /* 2896 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2907), // Rule ID 237 //
     /* 2901 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2904 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2904 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2907 */ // Label 187: @2907
     /* 2907 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2918), // Rule ID 283 //
     /* 2912 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2915 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2915 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2918 */ // Label 188: @2918
     /* 2918 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2929), // Rule ID 311 //
     /* 2923 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2926 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2926 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2929 */ // Label 189: @2929
     /* 2929 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2940), // Rule ID 338 //
     /* 2934 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 2937 */   // Combiner Rule #193: match_ors; wip_match_opcode 'G_OR'
     /* 2937 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 2940 */ // Label 190: @2940
     /* 2940 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3038), // Rule ID 156 //
     /* 2945 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 2948 */   // MIs[0] root
     /* 2948 */   // No operand predicates
     /* 2948 */   // MIs[0] d1
     /* 2948 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2952 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2956 */   // MIs[1] p
     /* 2956 */   // No operand predicates
     /* 2956 */   // MIs[1] s1
     /* 2956 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2960 */   // MIs[1] Operand 3
     /* 2960 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2964 */   // MIs[0] d2
     /* 2964 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2968 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2972 */   // MIs[2] p
     /* 2972 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2977 */   // MIs[2] s2
     /* 2977 */   // No operand predicates
     /* 2977 */   // MIs[2] Operand 3
     /* 2977 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2981 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2985 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2987 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2990 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 3000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 3003 */   // Combiner Rule #114: double_icmp_zero_or_combine
     /* 3003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 3006 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 3011 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 3015 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 3019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 3023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 3027 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 3031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 3034 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 3037 */   GIR_EraseRootFromParent_Done,
     /* 3038 */ // Label 191: @3038
     /* 3038 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3062), // Rule ID 115 //
     /* 3043 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 3046 */   // MIs[0] dst
     /* 3046 */   // No operand predicates
     /* 3046 */   // MIs[0] src
     /* 3046 */   // No operand predicates
     /* 3046 */   // MIs[0] src
     /* 3046 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 3051 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3056 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 3056 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3061 */   GIR_EraseRootFromParent_Done,
     /* 3062 */ // Label 192: @3062
     /* 3062 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3085), // Rule ID 106 //
     /* 3067 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 3070 */   // MIs[0] dst
     /* 3070 */   // No operand predicates
     /* 3070 */   // MIs[0] lhs
     /* 3070 */   // No operand predicates
     /* 3070 */   // MIs[0] Operand 2
     /* 3070 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3074 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3079 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 3079 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3084 */   GIR_EraseRootFromParent_Done,
     /* 3085 */ // Label 193: @3085
     /* 3085 */ GIM_Reject,
     /* 3086 */ // Label 10: @3086
     /* 3086 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3097), // Rule ID 96 //
     /* 3091 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 3094 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 3094 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 3097 */ // Label 194: @3097
     /* 3097 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3108), // Rule ID 144 //
     /* 3102 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 3105 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 3105 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 3108 */ // Label 195: @3108
     /* 3108 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3119), // Rule ID 174 //
     /* 3113 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 3116 */   // Combiner Rule #132: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 3116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 3119 */ // Label 196: @3119
     /* 3119 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3130), // Rule ID 198 //
     /* 3124 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 3127 */   // Combiner Rule #148: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 3127 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 3130 */ // Label 197: @3130
     /* 3130 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3141), // Rule ID 240 //
     /* 3135 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 3138 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 3138 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 3141 */ // Label 198: @3141
     /* 3141 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3152), // Rule ID 284 //
     /* 3146 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 3149 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 3149 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 3152 */ // Label 199: @3152
     /* 3152 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3163), // Rule ID 312 //
     /* 3157 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 3160 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 3160 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 3163 */ // Label 200: @3163
     /* 3163 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3186), // Rule ID 107 //
     /* 3168 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 3171 */   // MIs[0] dst
     /* 3171 */   // No operand predicates
     /* 3171 */   // MIs[0] lhs
     /* 3171 */   // No operand predicates
     /* 3171 */   // MIs[0] Operand 2
     /* 3171 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 3175 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3180 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 3180 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3185 */   GIR_EraseRootFromParent_Done,
     /* 3186 */ // Label 201: @3186
     /* 3186 */ GIM_Reject,
     /* 3187 */ // Label 11: @3187
     /* 3187 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3198), // Rule ID 140 //
     /* 3192 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 3195 */   // Combiner Rule #102: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 3195 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 3198 */ // Label 202: @3198
     /* 3198 */ GIM_Reject,
     /* 3199 */ // Label 12: @3199
     /* 3199 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3210), // Rule ID 363 //
     /* 3204 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 3207 */   // Combiner Rule #216: fold_global_offset; wip_match_opcode 'G_GLOBAL_VALUE'
     /* 3207 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 3210 */ // Label 203: @3210
     /* 3210 */ GIM_Reject,
     /* 3211 */ // Label 13: @3211
     /* 3211 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3222), // Rule ID 348 //
     /* 3216 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 3219 */   // Combiner Rule #203: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3219 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 3222 */ // Label 204: @3222
     /* 3222 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3233), // Rule ID 349 //
     /* 3227 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 3230 */   // Combiner Rule #204: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3230 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 3233 */ // Label 205: @3233
     /* 3233 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3244), // Rule ID 351 //
     /* 3238 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 3241 */   // Combiner Rule #206: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3241 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 3244 */ // Label 206: @3244
     /* 3244 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3255), // Rule ID 352 //
     /* 3249 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 3252 */   // Combiner Rule #207: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3252 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 3255 */ // Label 207: @3255
     /* 3255 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3266), // Rule ID 353 //
     /* 3260 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 3263 */   // Combiner Rule #208: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3263 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 3266 */ // Label 208: @3266
     /* 3266 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3277), // Rule ID 354 //
     /* 3271 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3274 */   // Combiner Rule #209: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3274 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3277 */ // Label 209: @3277
     /* 3277 */ GIM_Reject,
     /* 3278 */ // Label 14: @3278
     /* 3278 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3289), // Rule ID 350 //
     /* 3283 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 3286 */   // Combiner Rule #205: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3286 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 3289 */ // Label 210: @3289
     /* 3289 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3351),
     /* 3294 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3297 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3318), // Rule ID 355 //
     /* 3302 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3305 */     // MIs[0] root
     /* 3305 */     // No operand predicates
     /* 3305 */     // MIs[0] x
     /* 3305 */     // No operand predicates
     /* 3305 */     // MIs[0] undef
     /* 3305 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3315 */     // Combiner Rule #210: merge_of_x_and_undef
     /* 3315 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3318 */   // Label 212: @3318
     /* 3318 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3350), // Rule ID 356 //
     /* 3323 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 3326 */     // MIs[0] root
     /* 3326 */     // No operand predicates
     /* 3326 */     // MIs[0] x
     /* 3326 */     // No operand predicates
     /* 3326 */     // MIs[0] zero
     /* 3326 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3334 */     // MIs[1] Operand 1
     /* 3334 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3347 */     // Combiner Rule #211: merge_of_x_and_zero
     /* 3347 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 3350 */   // Label 213: @3350
     /* 3350 */   GIM_Reject,
     /* 3351 */ // Label 211: @3351
     /* 3351 */ GIM_Reject,
     /* 3352 */ // Label 15: @3352
     /* 3352 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3363), // Rule ID 69 //
     /* 3357 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3360 */   // Combiner Rule #67: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3360 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3363 */ // Label 214: @3363
     /* 3363 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3374), // Rule ID 98 //
     /* 3368 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 3371 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3371 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3374 */ // Label 215: @3374
     /* 3374 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3385), // Rule ID 133 //
     /* 3379 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3382 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3382 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3385 */ // Label 216: @3385
     /* 3385 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3399), // Rule ID 347 //
     /* 3390 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 3393 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3396 */   // MIs[0] dst
     /* 3396 */   // No operand predicates
     /* 3396 */   // MIs[0] unused
     /* 3396 */   // No operand predicates
     /* 3396 */   // Combiner Rule #202: combine_use_vector_truncate
     /* 3396 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 3399 */ // Label 217: @3399
     /* 3399 */ GIM_Reject,
     /* 3400 */ // Label 16: @3400
     /* 3400 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3411), // Rule ID 132 //
     /* 3405 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3408 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3408 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3411 */ // Label 218: @3411
     /* 3411 */ GIM_Reject,
     /* 3412 */ // Label 17: @3412
     /* 3412 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3423), // Rule ID 340 //
     /* 3417 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 3420 */   // Combiner Rule #195: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3420 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3423 */ // Label 219: @3423
     /* 3423 */ GIM_Reject,
     /* 3424 */ // Label 18: @3424
     /* 3424 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3445), // Rule ID 125 //
     /* 3429 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3432 */   // MIs[0] dst
     /* 3432 */   // No operand predicates
     /* 3432 */   // MIs[0] t
     /* 3432 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3440 */   // MIs[1] ptr
     /* 3440 */   // No operand predicates
     /* 3440 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3442 */   // Combiner Rule #89: i2p_to_p2i
     /* 3442 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3445 */ // Label 220: @3445
     /* 3445 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3466), // Rule ID 90 //
     /* 3450 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3453 */   // MIs[0] dst
     /* 3453 */   // No operand predicates
     /* 3453 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3453 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3461 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3463 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3463 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3466 */ // Label 221: @3466
     /* 3466 */ GIM_Reject,
     /* 3467 */ // Label 19: @3467
     /* 3467 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3478), // Rule ID 124 //
     /* 3472 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3475 */   // Combiner Rule #88: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3475 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3478 */ // Label 222: @3478
     /* 3478 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3499), // Rule ID 91 //
     /* 3483 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3486 */   // MIs[0] dst
     /* 3486 */   // No operand predicates
     /* 3486 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3486 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3496 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3496 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3499 */ // Label 223: @3499
     /* 3499 */ GIM_Reject,
     /* 3500 */ // Label 20: @3500
     /* 3500 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3521), // Rule ID 136 //
     /* 3505 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 3508 */   // MIs[0] dst
     /* 3508 */   // No operand predicates
     /* 3508 */   // MIs[0] src1
     /* 3508 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3512 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3516 */   // MIs[1] src0
     /* 3516 */   // No operand predicates
     /* 3516 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3518 */   // Combiner Rule #98: bitcast_bitcast_fold
     /* 3518 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 3521 */ // Label 224: @3521
     /* 3521 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3542), // Rule ID 88 //
     /* 3526 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3529 */   // MIs[0] dst
     /* 3529 */   // No operand predicates
     /* 3529 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3529 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3533 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3537 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3539 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3539 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3542 */ // Label 225: @3542
     /* 3542 */ GIM_Reject,
     /* 3543 */ // Label 21: @3543
     /* 3543 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3572), // Rule ID 18 //
     /* 3548 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3551 */   // MIs[0] dst
     /* 3551 */   // No operand predicates
     /* 3551 */   // MIs[0] src
     /* 3551 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3555 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3559 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3559 */   // No operand predicates
     /* 3559 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3564 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3566 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3566 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3571 */   GIR_EraseRootFromParent_Done,
     /* 3572 */ // Label 226: @3572
     /* 3572 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3595), // Rule ID 43 //
     /* 3577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3580 */   // MIs[0] root
     /* 3580 */   // No operand predicates
     /* 3580 */   // MIs[0] src
     /* 3580 */   // No operand predicates
     /* 3580 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3584 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3589 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3589 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3594 */   GIR_EraseRootFromParent_Done,
     /* 3595 */ // Label 227: @3595
     /* 3595 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3606), // Rule ID 44 //
     /* 3600 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3603 */   // MIs[0] dst
     /* 3603 */   // No operand predicates
     /* 3603 */   // MIs[0] src
     /* 3603 */   // No operand predicates
     /* 3603 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3603 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3606 */ // Label 228: @3606
     /* 3606 */ GIM_Reject,
     /* 3607 */ // Label 22: @3607
     /* 3607 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3618), // Rule ID 70 //
     /* 3612 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3615 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3615 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3618 */ // Label 229: @3618
     /* 3618 */ GIM_Reject,
     /* 3619 */ // Label 23: @3619
     /* 3619 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3630), // Rule ID 71 //
     /* 3624 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3627 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3627 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3630 */ // Label 230: @3630
     /* 3630 */ GIM_Reject,
     /* 3631 */ // Label 24: @3631
     /* 3631 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3642), // Rule ID 72 //
     /* 3636 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3639 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3639 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3642 */ // Label 231: @3642
     /* 3642 */ GIM_Reject,
     /* 3643 */ // Label 25: @3643
     /* 3643 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3654), // Rule ID 100 //
     /* 3648 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3651 */   // Combiner Rule #81: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3651 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 3654 */ // Label 232: @3654
     /* 3654 */ GIM_Reject,
     /* 3655 */ // Label 26: @3655
     /* 3655 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3666), // Rule ID 126 //
     /* 3660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 3663 */   // Combiner Rule #90: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3663 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3666 */ // Label 233: @3666
     /* 3666 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3677), // Rule ID 257 //
     /* 3671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3674 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3674 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3677 */ // Label 234: @3677
     /* 3677 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3698), // Rule ID 57 //
     /* 3682 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3685 */   // MIs[0] root
     /* 3685 */   // No operand predicates
     /* 3685 */   // MIs[0] select
     /* 3685 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3693 */   // MIs[1] cond
     /* 3693 */   // No operand predicates
     /* 3693 */   // MIs[1] true
     /* 3693 */   // No operand predicates
     /* 3693 */   // MIs[1] false
     /* 3693 */   // No operand predicates
     /* 3693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3695 */   // Combiner Rule #55: select_of_anyext
     /* 3695 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3698 */ // Label 235: @3698
     /* 3698 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3719), // Rule ID 52 //
     /* 3703 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3706 */   // MIs[0] root
     /* 3706 */   // No operand predicates
     /* 3706 */   // MIs[0] second
     /* 3706 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3714 */   // MIs[1] src
     /* 3714 */   // No operand predicates
     /* 3714 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3716 */   // Combiner Rule #50: anyext_of_anyext
     /* 3716 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3719 */ // Label 236: @3719
     /* 3719 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3740), // Rule ID 54 //
     /* 3724 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3727 */   // MIs[0] root
     /* 3727 */   // No operand predicates
     /* 3727 */   // MIs[0] second
     /* 3727 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3735 */   // MIs[1] src
     /* 3735 */   // No operand predicates
     /* 3735 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3737 */   // Combiner Rule #52: anyext_of_sext
     /* 3737 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3740 */ // Label 237: @3740
     /* 3740 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3761), // Rule ID 53 //
     /* 3745 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3748 */   // MIs[0] root
     /* 3748 */   // No operand predicates
     /* 3748 */   // MIs[0] second
     /* 3748 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3756 */   // MIs[1] src
     /* 3756 */   // No operand predicates
     /* 3756 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3758 */   // Combiner Rule #51: anyext_of_zext
     /* 3758 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3761 */ // Label 238: @3761
     /* 3761 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3782), // Rule ID 89 //
     /* 3766 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3769 */   // MIs[0] dst
     /* 3769 */   // No operand predicates
     /* 3769 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3769 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3779 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3779 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3782 */ // Label 239: @3782
     /* 3782 */ GIM_Reject,
     /* 3783 */ // Label 27: @3783
     /* 3783 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3794), // Rule ID 134 //
     /* 3788 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3791 */   // Combiner Rule #96: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3791 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3794 */ // Label 240: @3794
     /* 3794 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3805), // Rule ID 135 //
     /* 3799 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3802 */   // Combiner Rule #97: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3802 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3805 */ // Label 241: @3805
     /* 3805 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3816), // Rule ID 173 //
     /* 3810 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 3813 */   // Combiner Rule #131: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3813 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 3816 */ // Label 242: @3816
     /* 3816 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3837), // Rule ID 58 //
     /* 3821 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3824 */   // MIs[0] root
     /* 3824 */   // No operand predicates
     /* 3824 */   // MIs[0] select
     /* 3824 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3832 */   // MIs[1] cond
     /* 3832 */   // No operand predicates
     /* 3832 */   // MIs[1] true
     /* 3832 */   // No operand predicates
     /* 3832 */   // MIs[1] false
     /* 3832 */   // No operand predicates
     /* 3832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3834 */   // Combiner Rule #56: select_of_truncate
     /* 3834 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3837 */ // Label 243: @3837
     /* 3837 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3866), // Rule ID 60 //
     /* 3842 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3845 */   // MIs[0] root
     /* 3845 */   // No operand predicates
     /* 3845 */   // MIs[0] binop
     /* 3845 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3853 */   // MIs[1] x
     /* 3853 */   // No operand predicates
     /* 3853 */   // MIs[1] const
     /* 3853 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3857 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3861 */   // MIs[2] imm
     /* 3861 */   // No operand predicates
     /* 3861 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3863 */   // Combiner Rule #58: narrow_binop_add
     /* 3863 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3866 */ // Label 244: @3866
     /* 3866 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3895), // Rule ID 63 //
     /* 3871 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3874 */   // MIs[0] root
     /* 3874 */   // No operand predicates
     /* 3874 */   // MIs[0] binop
     /* 3874 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3882 */   // MIs[1] x
     /* 3882 */   // No operand predicates
     /* 3882 */   // MIs[1] const
     /* 3882 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3886 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3890 */   // MIs[2] imm
     /* 3890 */   // No operand predicates
     /* 3890 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3892 */   // Combiner Rule #61: narrow_binop_and
     /* 3892 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3895 */ // Label 245: @3895
     /* 3895 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3924), // Rule ID 62 //
     /* 3900 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3903 */   // MIs[0] root
     /* 3903 */   // No operand predicates
     /* 3903 */   // MIs[0] binop
     /* 3903 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3907 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3911 */   // MIs[1] x
     /* 3911 */   // No operand predicates
     /* 3911 */   // MIs[1] const
     /* 3911 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3915 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3919 */   // MIs[2] imm
     /* 3919 */   // No operand predicates
     /* 3919 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3921 */   // Combiner Rule #60: narrow_binop_mul
     /* 3921 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3924 */ // Label 246: @3924
     /* 3924 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3953), // Rule ID 64 //
     /* 3929 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3932 */   // MIs[0] root
     /* 3932 */   // No operand predicates
     /* 3932 */   // MIs[0] binop
     /* 3932 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3940 */   // MIs[1] x
     /* 3940 */   // No operand predicates
     /* 3940 */   // MIs[1] const
     /* 3940 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3944 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3948 */   // MIs[2] imm
     /* 3948 */   // No operand predicates
     /* 3948 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3950 */   // Combiner Rule #62: narrow_binop_or
     /* 3950 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3953 */ // Label 247: @3953
     /* 3953 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3982), // Rule ID 61 //
     /* 3958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3961 */   // MIs[0] root
     /* 3961 */   // No operand predicates
     /* 3961 */   // MIs[0] binop
     /* 3961 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3969 */   // MIs[1] x
     /* 3969 */   // No operand predicates
     /* 3969 */   // MIs[1] const
     /* 3969 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3973 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3977 */   // MIs[2] imm
     /* 3977 */   // No operand predicates
     /* 3977 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3979 */   // Combiner Rule #59: narrow_binop_sub
     /* 3979 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3982 */ // Label 248: @3982
     /* 3982 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(4011), // Rule ID 65 //
     /* 3987 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 3990 */   // MIs[0] root
     /* 3990 */   // No operand predicates
     /* 3990 */   // MIs[0] binop
     /* 3990 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3994 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3998 */   // MIs[1] x
     /* 3998 */   // No operand predicates
     /* 3998 */   // MIs[1] const
     /* 3998 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 4002 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4006 */   // MIs[2] imm
     /* 4006 */   // No operand predicates
     /* 4006 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4008 */   // Combiner Rule #63: narrow_binop_xor
     /* 4008 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 4011 */ // Label 249: @4011
     /* 4011 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4032), // Rule ID 47 //
     /* 4016 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 4019 */   // MIs[0] root
     /* 4019 */   // No operand predicates
     /* 4019 */   // MIs[0] ext
     /* 4019 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4023 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4027 */   // MIs[1] src
     /* 4027 */   // No operand predicates
     /* 4027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4029 */   // Combiner Rule #45: truncate_of_anyext
     /* 4029 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4032 */ // Label 250: @4032
     /* 4032 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4056), // Rule ID 59 //
     /* 4037 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 4040 */   // MIs[0] root
     /* 4040 */   // No operand predicates
     /* 4040 */   // MIs[0] bv
     /* 4040 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 4048 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 4051 */   // MIs[1] unused
     /* 4051 */   // No operand predicates
     /* 4051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4053 */   // Combiner Rule #57: buildvector_of_truncate
     /* 4053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 4056 */ // Label 251: @4056
     /* 4056 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4077), // Rule ID 46 //
     /* 4061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 4064 */   // MIs[0] root
     /* 4064 */   // No operand predicates
     /* 4064 */   // MIs[0] ext
     /* 4064 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4072 */   // MIs[1] src
     /* 4072 */   // No operand predicates
     /* 4072 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4074 */   // Combiner Rule #44: truncate_of_sext
     /* 4074 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4077 */ // Label 252: @4077
     /* 4077 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4098), // Rule ID 45 //
     /* 4082 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 4085 */   // MIs[0] root
     /* 4085 */   // No operand predicates
     /* 4085 */   // MIs[0] ext
     /* 4085 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4093 */   // MIs[1] src
     /* 4093 */   // No operand predicates
     /* 4093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4095 */   // Combiner Rule #43: truncate_of_zext
     /* 4095 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 4098 */ // Label 253: @4098
     /* 4098 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(4119), // Rule ID 87 //
     /* 4103 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 4106 */   // MIs[0] dst
     /* 4106 */   // No operand predicates
     /* 4106 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 4106 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4114 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4116 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 4116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 4119 */ // Label 254: @4119
     /* 4119 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(4140), // Rule ID 66 //
     /* 4124 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 4127 */   // MIs[0] root
     /* 4127 */   // No operand predicates
     /* 4127 */   // MIs[0] int
     /* 4127 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4135 */   // MIs[1] imm
     /* 4135 */   // No operand predicates
     /* 4135 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4137 */   // Combiner Rule #64: integer_of_truncate
     /* 4137 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 4140 */ // Label 255: @4140
     /* 4140 */ GIM_Reject,
     /* 4141 */ // Label 28: @4141
     /* 4141 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(4152), // Rule ID 361 //
     /* 4146 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 4149 */   // MIs[0] dst
     /* 4149 */   // No operand predicates
     /* 4149 */   // MIs[0] src
     /* 4149 */   // No operand predicates
     /* 4149 */   // Combiner Rule #214: fconstant_to_constant
     /* 4149 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 4152 */ // Label 256: @4152
     /* 4152 */ GIM_Reject,
     /* 4153 */ // Label 29: @4153
     /* 4153 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4164), // Rule ID 256 //
     /* 4158 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4161 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 4161 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4164 */ // Label 257: @4164
     /* 4164 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4185), // Rule ID 51 //
     /* 4169 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 4172 */   // MIs[0] root
     /* 4172 */   // No operand predicates
     /* 4172 */   // MIs[0] second
     /* 4172 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4180 */   // MIs[1] src
     /* 4180 */   // No operand predicates
     /* 4180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4182 */   // Combiner Rule #49: sext_of_anyext
     /* 4182 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4185 */ // Label 258: @4185
     /* 4185 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4206), // Rule ID 50 //
     /* 4190 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 4193 */   // MIs[0] root
     /* 4193 */   // No operand predicates
     /* 4193 */   // MIs[0] second
     /* 4193 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4197 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 4201 */   // MIs[1] src
     /* 4201 */   // No operand predicates
     /* 4201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4203 */   // Combiner Rule #48: sext_of_sext
     /* 4203 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4206 */ // Label 259: @4206
     /* 4206 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4227), // Rule ID 341 //
     /* 4211 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 4214 */   // MIs[0] root
     /* 4214 */   // No operand predicates
     /* 4214 */   // MIs[0] src
     /* 4214 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4218 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4222 */   // MIs[1] x
     /* 4222 */   // No operand predicates
     /* 4222 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4224 */   // Combiner Rule #196: sext_trunc
     /* 4224 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 4227 */ // Label 260: @4227
     /* 4227 */ GIM_Reject,
     /* 4228 */ // Label 30: @4228
     /* 4228 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4239), // Rule ID 160 //
     /* 4233 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 4236 */   // Combiner Rule #118: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 4236 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 4239 */ // Label 261: @4239
     /* 4239 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4250), // Rule ID 168 //
     /* 4244 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 4247 */   // Combiner Rule #126: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4247 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 4250 */ // Label 262: @4250
     /* 4250 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4261), // Rule ID 225 //
     /* 4255 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 4258 */   // Combiner Rule #162: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 4258 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 4261 */ // Label 263: @4261
     /* 4261 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4282), // Rule ID 55 //
     /* 4266 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 4269 */   // MIs[0] dst
     /* 4269 */   // No operand predicates
     /* 4269 */   // MIs[0] x
     /* 4269 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4273 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 4277 */   // MIs[1] src
     /* 4277 */   // No operand predicates
     /* 4277 */   // MIs[1] a
     /* 4277 */   // No operand predicates
     /* 4277 */   // MIs[0] b
     /* 4277 */   // No operand predicates
     /* 4277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4279 */   // Combiner Rule #53: sext_inreg_of_sext_inreg
     /* 4279 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 4282 */ // Label 264: @4282
     /* 4282 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4293), // Rule ID 172 //
     /* 4287 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 4290 */   // MIs[0] dst
     /* 4290 */   // No operand predicates
     /* 4290 */   // MIs[0] src
     /* 4290 */   // No operand predicates
     /* 4290 */   // MIs[0] imm
     /* 4290 */   // No operand predicates
     /* 4290 */   // Combiner Rule #130: sext_inreg_to_zext_inreg
     /* 4290 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 4293 */ // Label 265: @4293
     /* 4293 */ GIM_Reject,
     /* 4294 */ // Label 31: @4294
     /* 4294 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4305), // Rule ID 171 //
     /* 4299 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 4302 */   // Combiner Rule #129: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4302 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 4305 */ // Label 266: @4305
     /* 4305 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4316), // Rule ID 255 //
     /* 4310 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4313 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4313 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4316 */ // Label 267: @4316
     /* 4316 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4337), // Rule ID 56 //
     /* 4321 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 4324 */   // MIs[0] root
     /* 4324 */   // No operand predicates
     /* 4324 */   // MIs[0] select
     /* 4324 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4332 */   // MIs[1] cond
     /* 4332 */   // No operand predicates
     /* 4332 */   // MIs[1] true
     /* 4332 */   // No operand predicates
     /* 4332 */   // MIs[1] false
     /* 4332 */   // No operand predicates
     /* 4332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4334 */   // Combiner Rule #54: select_of_zext
     /* 4334 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 4337 */ // Label 268: @4337
     /* 4337 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4358), // Rule ID 49 //
     /* 4342 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4345 */   // MIs[0] root
     /* 4345 */   // No operand predicates
     /* 4345 */   // MIs[0] second
     /* 4345 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4353 */   // MIs[1] src
     /* 4353 */   // No operand predicates
     /* 4353 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4355 */   // Combiner Rule #47: zext_of_anyext
     /* 4355 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4358 */ // Label 269: @4358
     /* 4358 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4385), // Rule ID 342 //
     /* 4363 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 4366 */   // MIs[0] root
     /* 4366 */   // No operand predicates
     /* 4366 */   // MIs[0] src
     /* 4366 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4374 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4380 */   // MIs[1] x
     /* 4380 */   // No operand predicates
     /* 4380 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4382 */   // Combiner Rule #197: zext_trunc
     /* 4382 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4385 */ // Label 270: @4385
     /* 4385 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4406), // Rule ID 48 //
     /* 4390 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4393 */   // MIs[0] root
     /* 4393 */   // No operand predicates
     /* 4393 */   // MIs[0] second
     /* 4393 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4397 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4401 */   // MIs[1] src
     /* 4401 */   // No operand predicates
     /* 4401 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4403 */   // Combiner Rule #46: zext_of_zext
     /* 4403 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4406 */ // Label 271: @4406
     /* 4406 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4423), // Rule ID 343 //
     /* 4411 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 4414 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4420 */   // MIs[0] root
     /* 4420 */   // No operand predicates
     /* 4420 */   // MIs[0] x
     /* 4420 */   // No operand predicates
     /* 4420 */   // Combiner Rule #198: nneg_zext
     /* 4420 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 4423 */ // Label 272: @4423
     /* 4423 */ GIM_Reject,
     /* 4424 */ // Label 32: @4424
     /* 4424 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4435), // Rule ID 80 //
     /* 4429 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4432 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4432 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4435 */ // Label 273: @4435
     /* 4435 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4446), // Rule ID 83 //
     /* 4440 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4443 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4443 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4446 */ // Label 274: @4446
     /* 4446 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4457), // Rule ID 116 //
     /* 4451 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4454 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4454 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4457 */ // Label 275: @4457
     /* 4457 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4468), // Rule ID 200 //
     /* 4462 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4465 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4465 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4468 */ // Label 276: @4468
     /* 4468 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4479), // Rule ID 205 //
     /* 4473 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4476 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4476 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4479 */ // Label 277: @4479
     /* 4479 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4490), // Rule ID 224 //
     /* 4484 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 4487 */   // Combiner Rule #161: commute_shift; wip_match_opcode 'G_SHL'
     /* 4487 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 4490 */ // Label 278: @4490
     /* 4490 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4501), // Rule ID 238 //
     /* 4495 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4498 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4498 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4501 */ // Label 279: @4501
     /* 4501 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4512), // Rule ID 291 //
     /* 4506 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4509 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4509 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4512 */ // Label 280: @4512
     /* 4512 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4547), // Rule ID 41 //
     /* 4517 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4520 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4526 */   // MIs[0] root
     /* 4526 */   // No operand predicates
     /* 4526 */   // MIs[0] left
     /* 4526 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4534 */   // MIs[1] imm
     /* 4534 */   // No operand predicates
     /* 4534 */   // MIs[0] x
     /* 4534 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4538 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4542 */   // MIs[2] imm1
     /* 4542 */   // No operand predicates
     /* 4542 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4544 */   // Combiner Rule #39: shl_of_vscale
     /* 4544 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4547 */ // Label 281: @4547
     /* 4547 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4570), // Rule ID 108 //
     /* 4552 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4555 */   // MIs[0] dst
     /* 4555 */   // No operand predicates
     /* 4555 */   // MIs[0] lhs
     /* 4555 */   // No operand predicates
     /* 4555 */   // MIs[0] Operand 2
     /* 4555 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4559 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4564 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4564 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4569 */   GIR_EraseRootFromParent_Done,
     /* 4570 */ // Label 282: @4570
     /* 4570 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4581), // Rule ID 145 //
     /* 4575 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4578 */   // MIs[0] root
     /* 4578 */   // No operand predicates
     /* 4578 */   // MIs[0] mi.shifted
     /* 4578 */   // No operand predicates
     /* 4578 */   // MIs[0] mi.amt
     /* 4578 */   // No operand predicates
     /* 4578 */   // Combiner Rule #105: shifts_too_big @ [mi[0]]
     /* 4578 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4581 */ // Label 283: @4581
     /* 4581 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4592), // Rule ID 161 //
     /* 4586 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 4589 */   // MIs[0] dst
     /* 4589 */   // No operand predicates
     /* 4589 */   // MIs[0] src0
     /* 4589 */   // No operand predicates
     /* 4589 */   // MIs[0] src1
     /* 4589 */   // No operand predicates
     /* 4589 */   // Combiner Rule #119: reduce_shl_of_extend
     /* 4589 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 4592 */ // Label 284: @4592
     /* 4592 */ GIM_Reject,
     /* 4593 */ // Label 33: @4593
     /* 4593 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4604), // Rule ID 85 //
     /* 4598 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4601 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4601 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4604 */ // Label 285: @4604
     /* 4604 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4615), // Rule ID 117 //
     /* 4609 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4612 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4615 */ // Label 286: @4615
     /* 4615 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4626), // Rule ID 202 //
     /* 4620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4623 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4626 */ // Label 287: @4626
     /* 4626 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4637), // Rule ID 207 //
     /* 4631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4634 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4634 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4637 */ // Label 288: @4637
     /* 4637 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4648), // Rule ID 228 //
     /* 4642 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4645 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4645 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4648 */ // Label 289: @4648
     /* 4648 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4659), // Rule ID 230 //
     /* 4653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4656 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4656 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4659 */ // Label 290: @4659
     /* 4659 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4670), // Rule ID 235 //
     /* 4664 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4667 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4667 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4670 */ // Label 291: @4670
     /* 4670 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4681), // Rule ID 289 //
     /* 4675 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4678 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4678 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4681 */ // Label 292: @4681
     /* 4681 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4704), // Rule ID 110 //
     /* 4686 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4689 */   // MIs[0] dst
     /* 4689 */   // No operand predicates
     /* 4689 */   // MIs[0] lhs
     /* 4689 */   // No operand predicates
     /* 4689 */   // MIs[0] Operand 2
     /* 4689 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4693 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4698 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4698 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4703 */   GIR_EraseRootFromParent_Done,
     /* 4704 */ // Label 293: @4704
     /* 4704 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4715), // Rule ID 147 //
     /* 4709 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4712 */   // MIs[0] root
     /* 4712 */   // No operand predicates
     /* 4712 */   // MIs[0] mi.shifted
     /* 4712 */   // No operand predicates
     /* 4712 */   // MIs[0] mi.amt
     /* 4712 */   // No operand predicates
     /* 4712 */   // Combiner Rule #105: shifts_too_big @ [mi[2]]
     /* 4712 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4715 */ // Label 294: @4715
     /* 4715 */ GIM_Reject,
     /* 4716 */ // Label 34: @4716
     /* 4716 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4727), // Rule ID 84 //
     /* 4721 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4724 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4724 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4727 */ // Label 295: @4727
     /* 4727 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4738), // Rule ID 118 //
     /* 4732 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4735 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4735 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4738 */ // Label 296: @4738
     /* 4738 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4749), // Rule ID 158 //
     /* 4743 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 4746 */   // Combiner Rule #116: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4746 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 4749 */ // Label 297: @4749
     /* 4749 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4760), // Rule ID 201 //
     /* 4754 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4757 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4757 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4760 */ // Label 298: @4760
     /* 4760 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4771), // Rule ID 206 //
     /* 4765 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4768 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4768 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4771 */ // Label 299: @4771
     /* 4771 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4782), // Rule ID 227 //
     /* 4776 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4779 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4779 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4782 */ // Label 300: @4782
     /* 4782 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4793), // Rule ID 229 //
     /* 4787 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4790 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4790 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4793 */ // Label 301: @4793
     /* 4793 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4804), // Rule ID 234 //
     /* 4798 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4801 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4801 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4804 */ // Label 302: @4804
     /* 4804 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4815), // Rule ID 290 //
     /* 4809 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4812 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4812 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4815 */ // Label 303: @4815
     /* 4815 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4838), // Rule ID 109 //
     /* 4820 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4823 */   // MIs[0] dst
     /* 4823 */   // No operand predicates
     /* 4823 */   // MIs[0] lhs
     /* 4823 */   // No operand predicates
     /* 4823 */   // MIs[0] Operand 2
     /* 4823 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4827 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4832 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4832 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4837 */   GIR_EraseRootFromParent_Done,
     /* 4838 */ // Label 304: @4838
     /* 4838 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4849), // Rule ID 146 //
     /* 4843 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4846 */   // MIs[0] root
     /* 4846 */   // No operand predicates
     /* 4846 */   // MIs[0] mi.shifted
     /* 4846 */   // No operand predicates
     /* 4846 */   // MIs[0] mi.amt
     /* 4846 */   // No operand predicates
     /* 4846 */   // Combiner Rule #105: shifts_too_big @ [mi[1]]
     /* 4846 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4849 */ // Label 305: @4849
     /* 4849 */ GIM_Reject,
     /* 4850 */ // Label 35: @4850
     /* 4850 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4861), // Rule ID 216 //
     /* 4855 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4858 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4858 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4861 */ // Label 306: @4861
     /* 4861 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4872), // Rule ID 220 //
     /* 4866 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4869 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4869 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4872 */ // Label 307: @4872
     /* 4872 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4892), // Rule ID 219 //
     /* 4877 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4880 */   // MIs[0] x
     /* 4880 */   // No operand predicates
     /* 4880 */   // MIs[0] y
     /* 4880 */   // No operand predicates
     /* 4880 */   // MIs[0] z
     /* 4880 */   // No operand predicates
     /* 4880 */   // MIs[0] Operand 3
     /* 4880 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4884 */   // Combiner Rule #157: funnel_shift_left_zero
     /* 4884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4887 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4889 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4891 */   GIR_EraseRootFromParent_Done,
     /* 4892 */ // Label 308: @4892
     /* 4892 */ GIM_Reject,
     /* 4893 */ // Label 36: @4893
     /* 4893 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4904), // Rule ID 217 //
     /* 4898 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4901 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4901 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4904 */ // Label 309: @4904
     /* 4904 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4915), // Rule ID 221 //
     /* 4909 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4912 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4912 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4915 */ // Label 310: @4915
     /* 4915 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4935), // Rule ID 218 //
     /* 4920 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4923 */   // MIs[0] x
     /* 4923 */   // No operand predicates
     /* 4923 */   // MIs[0] y
     /* 4923 */   // No operand predicates
     /* 4923 */   // MIs[0] z
     /* 4923 */   // No operand predicates
     /* 4923 */   // MIs[0] Operand 3
     /* 4923 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4927 */   // Combiner Rule #156: funnel_shift_right_zero
     /* 4927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4930 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4932 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4934 */   GIR_EraseRootFromParent_Done,
     /* 4935 */ // Label 311: @4935
     /* 4935 */ GIM_Reject,
     /* 4936 */ // Label 37: @4936
     /* 4936 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4959), // Rule ID 113 //
     /* 4941 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4944 */   // MIs[0] dst
     /* 4944 */   // No operand predicates
     /* 4944 */   // MIs[0] lhs
     /* 4944 */   // No operand predicates
     /* 4944 */   // MIs[0] Operand 2
     /* 4944 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4948 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4953 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4953 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4958 */   GIR_EraseRootFromParent_Done,
     /* 4959 */ // Label 312: @4959
     /* 4959 */ GIM_Reject,
     /* 4960 */ // Label 38: @4960
     /* 4960 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4983), // Rule ID 112 //
     /* 4965 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4968 */   // MIs[0] dst
     /* 4968 */   // No operand predicates
     /* 4968 */   // MIs[0] lhs
     /* 4968 */   // No operand predicates
     /* 4968 */   // MIs[0] Operand 2
     /* 4968 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4972 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4977 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4977 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4982 */   GIR_EraseRootFromParent_Done,
     /* 4983 */ // Label 313: @4983
     /* 4983 */ GIM_Reject,
     /* 4984 */ // Label 39: @4984
     /* 4984 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(4995), // Rule ID 153 //
     /* 4989 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 4992 */   // Combiner Rule #111: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 4992 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 4995 */ // Label 314: @4995
     /* 4995 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(5006), // Rule ID 154 //
     /* 5000 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 5003 */   // Combiner Rule #112: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 5003 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 5006 */ // Label 315: @5006
     /* 5006 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(5017), // Rule ID 157 //
     /* 5011 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 5014 */   // Combiner Rule #115: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 5014 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 5017 */ // Label 316: @5017
     /* 5017 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(5028), // Rule ID 151 //
     /* 5022 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 5025 */   // MIs[0] root
     /* 5025 */   // No operand predicates
     /* 5025 */   // MIs[0] pred
     /* 5025 */   // No operand predicates
     /* 5025 */   // MIs[0] lhs
     /* 5025 */   // No operand predicates
     /* 5025 */   // MIs[0] rhs
     /* 5025 */   // No operand predicates
     /* 5025 */   // Combiner Rule #109: canonicalize_icmp
     /* 5025 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 5028 */ // Label 317: @5028
     /* 5028 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(5039), // Rule ID 362 //
     /* 5033 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 5036 */   // MIs[0] dst
     /* 5036 */   // No operand predicates
     /* 5036 */   // MIs[0] tst
     /* 5036 */   // No operand predicates
     /* 5036 */   // MIs[0] src1
     /* 5036 */   // No operand predicates
     /* 5036 */   // MIs[0] src2
     /* 5036 */   // No operand predicates
     /* 5036 */   // Combiner Rule #215: icmp_redundant_trunc
     /* 5036 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 5039 */ // Label 318: @5039
     /* 5039 */ GIM_Reject,
     /* 5040 */ // Label 40: @5040
     /* 5040 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(5051), // Rule ID 152 //
     /* 5045 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 5048 */   // MIs[0] root
     /* 5048 */   // No operand predicates
     /* 5048 */   // MIs[0] pred
     /* 5048 */   // No operand predicates
     /* 5048 */   // MIs[0] lhs
     /* 5048 */   // No operand predicates
     /* 5048 */   // MIs[0] rhs
     /* 5048 */   // No operand predicates
     /* 5048 */   // Combiner Rule #110: canonicalize_fcmp
     /* 5048 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 5051 */ // Label 319: @5051
     /* 5051 */ GIM_Reject,
     /* 5052 */ // Label 41: @5052
     /* 5052 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(5063), // Rule ID 103 //
     /* 5057 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 5060 */   // Combiner Rule #83: select_same_val; wip_match_opcode 'G_SELECT'
     /* 5060 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 5063 */ // Label 320: @5063
     /* 5063 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(5074), // Rule ID 164 //
     /* 5068 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 5071 */   // Combiner Rule #122: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 5071 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 5074 */ // Label 321: @5074
     /* 5074 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(5085), // Rule ID 166 //
     /* 5079 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 5082 */   // Combiner Rule #124: match_selects; wip_match_opcode 'G_SELECT'
     /* 5082 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 5085 */ // Label 322: @5085
     /* 5085 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(5096), // Rule ID 306 //
     /* 5090 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 5093 */   // Combiner Rule #188: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 5093 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 5096 */ // Label 323: @5096
     /* 5096 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(5117), // Rule ID 165 //
     /* 5101 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 5104 */   // MIs[0] root
     /* 5104 */   // No operand predicates
     /* 5104 */   // MIs[0] tst
     /* 5104 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5108 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 5112 */   // MIs[1] tst1
     /* 5112 */   // No operand predicates
     /* 5112 */   // MIs[1] a
     /* 5112 */   // No operand predicates
     /* 5112 */   // MIs[1] b
     /* 5112 */   // No operand predicates
     /* 5112 */   // MIs[0] x
     /* 5112 */   // No operand predicates
     /* 5112 */   // MIs[0] y
     /* 5112 */   // No operand predicates
     /* 5112 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5114 */   // Combiner Rule #123: select_to_iminmax
     /* 5114 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 5117 */ // Label 324: @5117
     /* 5117 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(5146), // Rule ID 163 //
     /* 5122 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 5125 */   // MIs[0] dst
     /* 5125 */   // No operand predicates
     /* 5125 */   // MIs[0] undef
     /* 5125 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5129 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5133 */   // MIs[0] x
     /* 5133 */   // No operand predicates
     /* 5133 */   // MIs[0] y
     /* 5133 */   // No operand predicates
     /* 5133 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5138 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5140 */   // Combiner Rule #121: select_undef_cmp
     /* 5140 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 5145 */   GIR_EraseRootFromParent_Done,
     /* 5146 */ // Label 325: @5146
     /* 5146 */ GIM_Reject,
     /* 5147 */ // Label 42: @5147
     /* 5147 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(5158), // Rule ID 317 //
     /* 5152 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5155 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 5155 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5158 */ // Label 326: @5158
     /* 5158 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(5169), // Rule ID 358 //
     /* 5163 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 5166 */   // Combiner Rule #212: match_addos; wip_match_opcode 'G_UADDO'
     /* 5166 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5169 */ // Label 327: @5169
     /* 5169 */ GIM_Reject,
     /* 5170 */ // Label 43: @5170
     /* 5170 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(5181), // Rule ID 189 //
     /* 5175 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5178 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 5178 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5181 */ // Label 328: @5181
     /* 5181 */ GIM_Reject,
     /* 5182 */ // Label 44: @5182
     /* 5182 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(5193), // Rule ID 360 //
     /* 5187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 5190 */   // Combiner Rule #213: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 5190 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5193 */ // Label 329: @5193
     /* 5193 */ GIM_Reject,
     /* 5194 */ // Label 45: @5194
     /* 5194 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5205), // Rule ID 191 //
     /* 5199 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5202 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 5202 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5205 */ // Label 330: @5205
     /* 5205 */ GIM_Reject,
     /* 5206 */ // Label 46: @5206
     /* 5206 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5217), // Rule ID 318 //
     /* 5211 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5214 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 5214 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5217 */ // Label 331: @5217
     /* 5217 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5228), // Rule ID 357 //
     /* 5222 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 5225 */   // Combiner Rule #212: match_addos; wip_match_opcode 'G_SADDO'
     /* 5225 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 5228 */ // Label 332: @5228
     /* 5228 */ GIM_Reject,
     /* 5229 */ // Label 47: @5229
     /* 5229 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5240), // Rule ID 190 //
     /* 5234 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5237 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 5237 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5240 */ // Label 333: @5240
     /* 5240 */ GIM_Reject,
     /* 5241 */ // Label 48: @5241
     /* 5241 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5252), // Rule ID 359 //
     /* 5246 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 5249 */   // Combiner Rule #213: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 5249 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 5252 */ // Label 334: @5252
     /* 5252 */ GIM_Reject,
     /* 5253 */ // Label 49: @5253
     /* 5253 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5264), // Rule ID 192 //
     /* 5258 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 5261 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 5261 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 5264 */ // Label 335: @5264
     /* 5264 */ GIM_Reject,
     /* 5265 */ // Label 50: @5265
     /* 5265 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5276), // Rule ID 185 //
     /* 5270 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5273 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 5273 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5276 */ // Label 336: @5276
     /* 5276 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5287), // Rule ID 187 //
     /* 5281 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5284 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 5284 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5287 */ // Label 337: @5287
     /* 5287 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5298), // Rule ID 319 //
     /* 5292 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5295 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 5295 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5298 */ // Label 338: @5298
     /* 5298 */ GIM_Reject,
     /* 5299 */ // Label 51: @5299
     /* 5299 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5310), // Rule ID 186 //
     /* 5304 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5307 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 5307 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5310 */ // Label 339: @5310
     /* 5310 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5321), // Rule ID 188 //
     /* 5315 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5318 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5318 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5321 */ // Label 340: @5321
     /* 5321 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5332), // Rule ID 320 //
     /* 5326 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5329 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5329 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5332 */ // Label 341: @5332
     /* 5332 */ GIM_Reject,
     /* 5333 */ // Label 52: @5333
     /* 5333 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5344), // Rule ID 263 //
     /* 5338 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5341 */   // Combiner Rule #175: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5341 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5344 */ // Label 342: @5344
     /* 5344 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5355), // Rule ID 321 //
     /* 5349 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5352 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5355 */ // Label 343: @5355
     /* 5355 */ GIM_Reject,
     /* 5356 */ // Label 53: @5356
     /* 5356 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5367), // Rule ID 322 //
     /* 5361 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5364 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5364 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5367 */ // Label 344: @5367
     /* 5367 */ GIM_Reject,
     /* 5368 */ // Label 54: @5368
     /* 5368 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5379), // Rule ID 323 //
     /* 5373 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5376 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5376 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5379 */ // Label 345: @5379
     /* 5379 */ GIM_Reject,
     /* 5380 */ // Label 55: @5380
     /* 5380 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5391), // Rule ID 324 //
     /* 5385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5388 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5391 */ // Label 346: @5391
     /* 5391 */ GIM_Reject,
     /* 5392 */ // Label 56: @5392
     /* 5392 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5403), // Rule ID 204 //
     /* 5397 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5400 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5400 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5403 */ // Label 347: @5403
     /* 5403 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5414), // Rule ID 208 //
     /* 5408 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5411 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5411 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5414 */ // Label 348: @5414
     /* 5414 */ GIM_Reject,
     /* 5415 */ // Label 57: @5415
     /* 5415 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5426), // Rule ID 203 //
     /* 5420 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5423 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5423 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5426 */ // Label 349: @5426
     /* 5426 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5437), // Rule ID 209 //
     /* 5431 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5434 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5434 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5437 */ // Label 350: @5437
     /* 5437 */ GIM_Reject,
     /* 5438 */ // Label 58: @5438
     /* 5438 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5449), // Rule ID 325 //
     /* 5443 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5446 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5446 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5449 */ // Label 351: @5449
     /* 5449 */ GIM_Reject,
     /* 5450 */ // Label 59: @5450
     /* 5450 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5461), // Rule ID 326 //
     /* 5455 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5458 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5458 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5461 */ // Label 352: @5461
     /* 5461 */ GIM_Reject,
     /* 5462 */ // Label 60: @5462
     /* 5462 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5473), // Rule ID 327 //
     /* 5467 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5470 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5470 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5473 */ // Label 353: @5473
     /* 5473 */ GIM_Reject,
     /* 5474 */ // Label 61: @5474
     /* 5474 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5485), // Rule ID 328 //
     /* 5479 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5482 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5482 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5485 */ // Label 354: @5485
     /* 5485 */ GIM_Reject,
     /* 5486 */ // Label 62: @5486
     /* 5486 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5497), // Rule ID 249 //
     /* 5491 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5494 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5494 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5497 */ // Label 355: @5497
     /* 5497 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5508), // Rule ID 264 //
     /* 5502 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5505 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5505 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5508 */ // Label 356: @5508
     /* 5508 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5519), // Rule ID 271 //
     /* 5513 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5516 */   // Combiner Rule #178: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5516 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5519 */ // Label 357: @5519
     /* 5519 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5530), // Rule ID 272 //
     /* 5524 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5527 */   // Combiner Rule #179: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5527 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5530 */ // Label 358: @5530
     /* 5530 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5541), // Rule ID 273 //
     /* 5535 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5538 */   // Combiner Rule #180: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5538 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5541 */ // Label 359: @5541
     /* 5541 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5552), // Rule ID 274 //
     /* 5546 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5549 */   // Combiner Rule #181: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5549 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5552 */ // Label 360: @5552
     /* 5552 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5563), // Rule ID 297 //
     /* 5557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5560 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5560 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5563 */ // Label 361: @5563
     /* 5563 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5574), // Rule ID 329 //
     /* 5568 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5571 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5571 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5574 */ // Label 362: @5574
     /* 5574 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5597), // Rule ID 138 //
     /* 5579 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5582 */   // MIs[0] dst
     /* 5582 */   // No operand predicates
     /* 5582 */   // MIs[0] x
     /* 5582 */   // No operand predicates
     /* 5582 */   // MIs[0] y
     /* 5582 */   // No operand predicates
     /* 5582 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5586 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5591 */   // Combiner Rule #100: right_identity_neg_zero_fp
     /* 5591 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5596 */   GIR_EraseRootFromParent_Done,
     /* 5597 */ // Label 363: @5597
     /* 5597 */ GIM_Reject,
     /* 5598 */ // Label 63: @5598
     /* 5598 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5609), // Rule ID 250 //
     /* 5603 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5606 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5606 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5609 */ // Label 364: @5609
     /* 5609 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5620), // Rule ID 265 //
     /* 5614 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5617 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5617 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5620 */ // Label 365: @5620
     /* 5620 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5631), // Rule ID 275 //
     /* 5625 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5628 */   // Combiner Rule #182: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5628 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5631 */ // Label 366: @5631
     /* 5631 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5642), // Rule ID 276 //
     /* 5636 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5639 */   // Combiner Rule #183: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5639 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5642 */ // Label 367: @5642
     /* 5642 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5653), // Rule ID 277 //
     /* 5647 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5650 */   // Combiner Rule #184: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5650 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5653 */ // Label 368: @5653
     /* 5653 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5664), // Rule ID 278 //
     /* 5658 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5661 */   // Combiner Rule #185: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5661 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5664 */ // Label 369: @5664
     /* 5664 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5675), // Rule ID 298 //
     /* 5669 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5672 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5672 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5675 */ // Label 370: @5675
     /* 5675 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5686), // Rule ID 307 //
     /* 5680 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5683 */   // Combiner Rule #189: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5683 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5686 */ // Label 371: @5686
     /* 5686 */ GIM_Reject,
     /* 5687 */ // Label 64: @5687
     /* 5687 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5698), // Rule ID 251 //
     /* 5692 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5695 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5695 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5698 */ // Label 372: @5698
     /* 5698 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5709), // Rule ID 266 //
     /* 5703 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5706 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5706 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5709 */ // Label 373: @5709
     /* 5709 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5720), // Rule ID 296 //
     /* 5714 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5717 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5717 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5720 */ // Label 374: @5720
     /* 5720 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5731), // Rule ID 330 //
     /* 5725 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5728 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5728 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5731 */ // Label 375: @5731
     /* 5731 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5754), // Rule ID 129 //
     /* 5736 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 5739 */   // MIs[0] dst
     /* 5739 */   // No operand predicates
     /* 5739 */   // MIs[0] x
     /* 5739 */   // No operand predicates
     /* 5739 */   // MIs[0] y
     /* 5739 */   // No operand predicates
     /* 5739 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5743 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5748 */   // Combiner Rule #93: right_identity_one_fp
     /* 5748 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5753 */   GIR_EraseRootFromParent_Done,
     /* 5754 */ // Label 376: @5754
     /* 5754 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5774), // Rule ID 139 //
     /* 5759 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 5762 */   // MIs[0] dst
     /* 5762 */   // No operand predicates
     /* 5762 */   // MIs[0] x
     /* 5762 */   // No operand predicates
     /* 5762 */   // MIs[0] y
     /* 5762 */   // No operand predicates
     /* 5762 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5766 */   // Combiner Rule #101: right_identity_neg_one_fp
     /* 5766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5769 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5771 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5773 */   GIR_EraseRootFromParent_Done,
     /* 5774 */ // Label 377: @5774
     /* 5774 */ GIM_Reject,
     /* 5775 */ // Label 65: @5775
     /* 5775 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5786), // Rule ID 254 //
     /* 5780 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5783 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5783 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5786 */ // Label 378: @5786
     /* 5786 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5797), // Rule ID 269 //
     /* 5791 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5794 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5794 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5797 */ // Label 379: @5797
     /* 5797 */ GIM_Reject,
     /* 5798 */ // Label 66: @5798
     /* 5798 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5809), // Rule ID 253 //
     /* 5803 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5806 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5806 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5809 */ // Label 380: @5809
     /* 5809 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5820), // Rule ID 268 //
     /* 5814 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5817 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5817 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5820 */ // Label 381: @5820
     /* 5820 */ GIM_Reject,
     /* 5821 */ // Label 67: @5821
     /* 5821 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5832), // Rule ID 252 //
     /* 5826 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5829 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5829 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5832 */ // Label 382: @5832
     /* 5832 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5843), // Rule ID 267 //
     /* 5837 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5840 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5840 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5843 */ // Label 383: @5843
     /* 5843 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5854), // Rule ID 299 //
     /* 5848 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5851 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5851 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5854 */ // Label 384: @5854
     /* 5854 */ GIM_Reject,
     /* 5855 */ // Label 68: @5855
     /* 5855 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5866), // Rule ID 300 //
     /* 5860 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5863 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5863 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5866 */ // Label 385: @5866
     /* 5866 */ GIM_Reject,
     /* 5867 */ // Label 69: @5867
     /* 5867 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5888), // Rule ID 197 //
     /* 5872 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 5875 */   // MIs[0] dst
     /* 5875 */   // No operand predicates
     /* 5875 */   // MIs[0] float
     /* 5875 */   // No operand predicates
     /* 5875 */   // MIs[0] int
     /* 5875 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5883 */   // MIs[1] imm
     /* 5883 */   // No operand predicates
     /* 5883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5885 */   // Combiner Rule #147: expand_const_fpowi
     /* 5885 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 5888 */ // Label 386: @5888
     /* 5888 */ GIM_Reject,
     /* 5889 */ // Label 70: @5889
     /* 5889 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5910), // Rule ID 179 //
     /* 5894 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5897 */   // MIs[0] dst
     /* 5897 */   // No operand predicates
     /* 5897 */   // MIs[0] src0
     /* 5897 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5901 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5905 */   // MIs[1] cst
     /* 5905 */   // No operand predicates
     /* 5905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5907 */   // Combiner Rule #137: constant_fold_flog2
     /* 5907 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5910 */ // Label 387: @5910
     /* 5910 */ GIM_Reject,
     /* 5911 */ // Label 71: @5911
     /* 5911 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5932), // Rule ID 176 //
     /* 5916 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 5919 */   // MIs[0] dst
     /* 5919 */   // No operand predicates
     /* 5919 */   // MIs[0] src0
     /* 5919 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5927 */   // MIs[1] cst
     /* 5927 */   // No operand predicates
     /* 5927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5929 */   // Combiner Rule #134: constant_fold_fneg
     /* 5929 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5932 */ // Label 388: @5932
     /* 5932 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5961), // Rule ID 127 //
     /* 5937 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 5940 */   // MIs[0] dst
     /* 5940 */   // No operand predicates
     /* 5940 */   // MIs[0] t
     /* 5940 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5948 */   // MIs[1] src
     /* 5948 */   // No operand predicates
     /* 5948 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5953 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5955 */   // Combiner Rule #91: fneg_fneg_fold
     /* 5955 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5960 */   GIR_EraseRootFromParent_Done,
     /* 5961 */ // Label 389: @5961
     /* 5961 */ GIM_Reject,
     /* 5962 */ // Label 72: @5962
     /* 5962 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5983), // Rule ID 180 //
     /* 5967 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 5970 */   // MIs[0] dst
     /* 5970 */   // No operand predicates
     /* 5970 */   // MIs[0] src0
     /* 5970 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5974 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5978 */   // MIs[1] cst
     /* 5978 */   // No operand predicates
     /* 5978 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5980 */   // Combiner Rule #138: constant_fold_fptrunc
     /* 5980 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5983 */ // Label 390: @5983
     /* 5983 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(6004), // Rule ID 137 //
     /* 5988 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5991 */   // MIs[0] dst
     /* 5991 */   // No operand predicates
     /* 5991 */   // MIs[0] src1
     /* 5991 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 5999 */   // MIs[1] src0
     /* 5999 */   // No operand predicates
     /* 5999 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6001 */   // Combiner Rule #99: fptrunc_fpext_fold
     /* 6001 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 6004 */ // Label 391: @6004
     /* 6004 */ GIM_Reject,
     /* 6005 */ // Label 73: @6005
     /* 6005 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(6026), // Rule ID 92 //
     /* 6010 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 6013 */   // MIs[0] dst
     /* 6013 */   // No operand predicates
     /* 6013 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 6013 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6021 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6023 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 6023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 6026 */ // Label 392: @6026
     /* 6026 */ GIM_Reject,
     /* 6027 */ // Label 74: @6027
     /* 6027 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(6048), // Rule ID 93 //
     /* 6032 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 6035 */   // MIs[0] dst
     /* 6035 */   // No operand predicates
     /* 6035 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 6035 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6045 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 6045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 6048 */ // Label 393: @6048
     /* 6048 */ GIM_Reject,
     /* 6049 */ // Label 75: @6049
     /* 6049 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(6060), // Rule ID 76 //
     /* 6054 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 6057 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 6057 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 6060 */ // Label 394: @6060
     /* 6060 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(6075), // Rule ID 181 //
     /* 6065 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 6068 */   // MIs[0] dst
     /* 6068 */   // No operand predicates
     /* 6068 */   // MIs[0] Operand 1
     /* 6068 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6072 */   // Combiner Rule #139: itof_const_zero_fold_si
     /* 6072 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6075 */ // Label 395: @6075
     /* 6075 */ GIM_Reject,
     /* 6076 */ // Label 76: @6076
     /* 6076 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(6087), // Rule ID 75 //
     /* 6081 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 6084 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 6084 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 6087 */ // Label 396: @6087
     /* 6087 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(6102), // Rule ID 182 //
     /* 6092 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 6095 */   // MIs[0] dst
     /* 6095 */   // No operand predicates
     /* 6095 */   // MIs[0] Operand 1
     /* 6095 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 6099 */   // Combiner Rule #140: itof_const_zero_fold_ui
     /* 6099 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 6102 */ // Label 397: @6102
     /* 6102 */ GIM_Reject,
     /* 6103 */ // Label 77: @6103
     /* 6103 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(6132), // Rule ID 19 //
     /* 6108 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6111 */   // MIs[0] dst
     /* 6111 */   // No operand predicates
     /* 6111 */   // MIs[0] src
     /* 6111 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6115 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6119 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6119 */   // No operand predicates
     /* 6119 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6126 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 6126 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6131 */   GIR_EraseRootFromParent_Done,
     /* 6132 */ // Label 398: @6132
     /* 6132 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(6153), // Rule ID 177 //
     /* 6137 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 6140 */   // MIs[0] dst
     /* 6140 */   // No operand predicates
     /* 6140 */   // MIs[0] src0
     /* 6140 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6144 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 6148 */   // MIs[1] cst
     /* 6148 */   // No operand predicates
     /* 6148 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6150 */   // Combiner Rule #135: constant_fold_fabs
     /* 6150 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 6153 */ // Label 399: @6153
     /* 6153 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6181), // Rule ID 258 //
     /* 6158 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 6161 */   // MIs[0] dst
     /* 6161 */   // No operand predicates
     /* 6161 */   // MIs[0] tmp
     /* 6161 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6165 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 6169 */   // MIs[1] x
     /* 6169 */   // No operand predicates
     /* 6169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6171 */   // Combiner Rule #170: fabs_fneg_fold
     /* 6171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 6174 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 6176 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 6180 */   GIR_EraseRootFromParent_Done,
     /* 6181 */ // Label 400: @6181
     /* 6181 */ GIM_Reject,
     /* 6182 */ // Label 78: @6182
     /* 6182 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6211), // Rule ID 20 //
     /* 6187 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 6190 */   // MIs[0] dst
     /* 6190 */   // No operand predicates
     /* 6190 */   // MIs[0] src
     /* 6190 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6194 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 6198 */   // MIs[1] __idempotent_prop_match_0.x
     /* 6198 */   // No operand predicates
     /* 6198 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6203 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6205 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 6205 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6210 */   GIR_EraseRootFromParent_Done,
     /* 6211 */ // Label 401: @6211
     /* 6211 */ GIM_Reject,
     /* 6212 */ // Label 79: @6212
     /* 6212 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6223), // Rule ID 193 //
     /* 6217 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6220 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 6220 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6223 */ // Label 402: @6223
     /* 6223 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6234), // Rule ID 301 //
     /* 6228 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6231 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 6231 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6234 */ // Label 403: @6234
     /* 6234 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6245), // Rule ID 331 //
     /* 6239 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6242 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 6242 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6245 */ // Label 404: @6245
     /* 6245 */ GIM_Reject,
     /* 6246 */ // Label 80: @6246
     /* 6246 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6257), // Rule ID 194 //
     /* 6251 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6254 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 6254 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6257 */ // Label 405: @6257
     /* 6257 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6268), // Rule ID 302 //
     /* 6262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6265 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 6265 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6268 */ // Label 406: @6268
     /* 6268 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6279), // Rule ID 332 //
     /* 6273 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6276 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 6276 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6279 */ // Label 407: @6279
     /* 6279 */ GIM_Reject,
     /* 6280 */ // Label 81: @6280
     /* 6280 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6291), // Rule ID 333 //
     /* 6285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6288 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 6288 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6291 */ // Label 408: @6291
     /* 6291 */ GIM_Reject,
     /* 6292 */ // Label 82: @6292
     /* 6292 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6303), // Rule ID 334 //
     /* 6297 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6300 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6300 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6303 */ // Label 409: @6303
     /* 6303 */ GIM_Reject,
     /* 6304 */ // Label 83: @6304
     /* 6304 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6315), // Rule ID 195 //
     /* 6309 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6312 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6312 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6315 */ // Label 410: @6315
     /* 6315 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6326), // Rule ID 303 //
     /* 6320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6323 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6326 */ // Label 411: @6326
     /* 6326 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6337), // Rule ID 335 //
     /* 6331 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6334 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6334 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6337 */ // Label 412: @6337
     /* 6337 */ GIM_Reject,
     /* 6338 */ // Label 84: @6338
     /* 6338 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6349), // Rule ID 196 //
     /* 6343 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6346 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6346 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6349 */ // Label 413: @6349
     /* 6349 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6360), // Rule ID 304 //
     /* 6354 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6357 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6357 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6360 */ // Label 414: @6360
     /* 6360 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6371), // Rule ID 336 //
     /* 6365 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6368 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6368 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6371 */ // Label 415: @6371
     /* 6371 */ GIM_Reject,
     /* 6372 */ // Label 85: @6372
     /* 6372 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6383), // Rule ID 148 //
     /* 6377 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 6380 */   // Combiner Rule #106: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6380 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 6383 */ // Label 416: @6383
     /* 6383 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6394), // Rule ID 150 //
     /* 6388 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 6391 */   // Combiner Rule #108: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6391 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 6394 */ // Label 417: @6394
     /* 6394 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6405), // Rule ID 183 //
     /* 6399 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 6402 */   // Combiner Rule #141: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6402 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 6405 */ // Label 418: @6405
     /* 6405 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6416), // Rule ID 199 //
     /* 6410 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 6413 */   // Combiner Rule #149: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6413 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 6416 */ // Label 419: @6416
     /* 6416 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6427), // Rule ID 232 //
     /* 6421 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6424 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6424 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6427 */ // Label 420: @6427
     /* 6427 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6438), // Rule ID 281 //
     /* 6432 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6435 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6435 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6438 */ // Label 421: @6438
     /* 6438 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6461), // Rule ID 111 //
     /* 6443 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 6446 */   // MIs[0] dst
     /* 6446 */   // No operand predicates
     /* 6446 */   // MIs[0] lhs
     /* 6446 */   // No operand predicates
     /* 6446 */   // MIs[0] Operand 2
     /* 6446 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6450 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6455 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6455 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6460 */   GIR_EraseRootFromParent_Done,
     /* 6461 */ // Label 422: @6461
     /* 6461 */ GIM_Reject,
     /* 6462 */ // Label 86: @6462
     /* 6462 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6473), // Rule ID 245 //
     /* 6467 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6470 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6470 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6473 */ // Label 423: @6473
     /* 6473 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6484), // Rule ID 292 //
     /* 6478 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6481 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6481 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6484 */ // Label 424: @6484
     /* 6484 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6495), // Rule ID 313 //
     /* 6489 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6492 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6492 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6495 */ // Label 425: @6495
     /* 6495 */ GIM_Reject,
     /* 6496 */ // Label 87: @6496
     /* 6496 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6507), // Rule ID 246 //
     /* 6501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6504 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6507 */ // Label 426: @6507
     /* 6507 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6518), // Rule ID 293 //
     /* 6512 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6515 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6515 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6518 */ // Label 427: @6518
     /* 6518 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6529), // Rule ID 314 //
     /* 6523 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6526 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6526 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6529 */ // Label 428: @6529
     /* 6529 */ GIM_Reject,
     /* 6530 */ // Label 88: @6530
     /* 6530 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6541), // Rule ID 247 //
     /* 6535 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6538 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6538 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6541 */ // Label 429: @6541
     /* 6541 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6552), // Rule ID 294 //
     /* 6546 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6549 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6549 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6552 */ // Label 430: @6552
     /* 6552 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6563), // Rule ID 315 //
     /* 6557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6560 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6560 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6563 */ // Label 431: @6563
     /* 6563 */ GIM_Reject,
     /* 6564 */ // Label 89: @6564
     /* 6564 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6575), // Rule ID 248 //
     /* 6569 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6572 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6572 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6575 */ // Label 432: @6575
     /* 6575 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6586), // Rule ID 295 //
     /* 6580 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6583 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6583 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6586 */ // Label 433: @6586
     /* 6586 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6597), // Rule ID 316 //
     /* 6591 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6594 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6594 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6597 */ // Label 434: @6597
     /* 6597 */ GIM_Reject,
     /* 6598 */ // Label 90: @6598
     /* 6598 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6609), // Rule ID 86 //
     /* 6603 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 6606 */   // Combiner Rule #76: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6606 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 6609 */ // Label 435: @6609
     /* 6609 */ GIM_Reject,
     /* 6610 */ // Label 91: @6610
     /* 6610 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6621), // Rule ID 175 //
     /* 6615 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 6618 */   // Combiner Rule #133: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6618 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6621 */ // Label 436: @6621
     /* 6621 */ GIM_Reject,
     /* 6622 */ // Label 92: @6622
     /* 6622 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6633), // Rule ID 26 //
     /* 6627 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6630 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6630 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6633 */ // Label 437: @6633
     /* 6633 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6644), // Rule ID 67 //
     /* 6638 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6641 */   // Combiner Rule #65: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6641 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6644 */ // Label 438: @6644
     /* 6644 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6655), // Rule ID 101 //
     /* 6649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6652 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6652 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6655 */ // Label 439: @6655
     /* 6655 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6694), // Rule ID 38 //
     /* 6660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6663 */   // MIs[0] root
     /* 6663 */   // No operand predicates
     /* 6663 */   // MIs[0] src
     /* 6663 */   // No operand predicates
     /* 6663 */   // MIs[0] elt
     /* 6663 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6671 */   // MIs[1] src
     /* 6671 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6676 */   // MIs[1] idx
     /* 6676 */   // No operand predicates
     /* 6676 */   // MIs[0] idx
     /* 6676 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6681 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6686 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6688 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6688 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6693 */   GIR_EraseRootFromParent_Done,
     /* 6694 */ // Label 440: @6694
     /* 6694 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6727), // Rule ID 24 //
     /* 6699 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6702 */   // MIs[0] root
     /* 6702 */   // No operand predicates
     /* 6702 */   // MIs[0] src
     /* 6702 */   // No operand predicates
     /* 6702 */   // MIs[0] elt
     /* 6702 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6710 */   // MIs[0] idx
     /* 6710 */   // No operand predicates
     /* 6710 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6714 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6721 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6721 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6726 */   GIR_EraseRootFromParent_Done,
     /* 6727 */ // Label 441: @6727
     /* 6727 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6751), // Rule ID 23 //
     /* 6732 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6735 */   // MIs[0] root
     /* 6735 */   // No operand predicates
     /* 6735 */   // MIs[0] src
     /* 6735 */   // No operand predicates
     /* 6735 */   // MIs[0] elt
     /* 6735 */   // No operand predicates
     /* 6735 */   // MIs[0] idx
     /* 6735 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6743 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6745 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6748 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6750 */   GIR_EraseRootFromParent_Done,
     /* 6751 */ // Label 442: @6751
     /* 6751 */ GIM_Reject,
     /* 6752 */ // Label 93: @6752
     /* 6752 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6763), // Rule ID 25 //
     /* 6757 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6760 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6760 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6763 */ // Label 443: @6763
     /* 6763 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6774), // Rule ID 68 //
     /* 6768 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 6771 */   // Combiner Rule #66: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6771 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 6774 */ // Label 444: @6774
     /* 6774 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6785), // Rule ID 74 //
     /* 6779 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6782 */   // Combiner Rule #70: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6782 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6785 */ // Label 445: @6785
     /* 6785 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6796), // Rule ID 102 //
     /* 6790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6793 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6793 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6796 */ // Label 446: @6796
     /* 6796 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6820), // Rule ID 36 //
     /* 6801 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6804 */   // MIs[0] root
     /* 6804 */   // No operand predicates
     /* 6804 */   // MIs[0] src
     /* 6804 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6812 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6815 */   // MIs[1] x
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] y
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] z
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] a
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] b
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] c
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] d
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[1] e
     /* 6815 */   // No operand predicates
     /* 6815 */   // MIs[0] idx
     /* 6815 */   // No operand predicates
     /* 6815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6817 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6817 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6820 */ // Label 447: @6820
     /* 6820 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6844), // Rule ID 35 //
     /* 6825 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6828 */   // MIs[0] root
     /* 6828 */   // No operand predicates
     /* 6828 */   // MIs[0] src
     /* 6828 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6836 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6839 */   // MIs[1] x
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[1] y
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[1] z
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[1] a
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[1] b
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[1] c
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[1] d
     /* 6839 */   // No operand predicates
     /* 6839 */   // MIs[0] idx
     /* 6839 */   // No operand predicates
     /* 6839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6841 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6841 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6844 */ // Label 448: @6844
     /* 6844 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6868), // Rule ID 34 //
     /* 6849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6852 */   // MIs[0] root
     /* 6852 */   // No operand predicates
     /* 6852 */   // MIs[0] src
     /* 6852 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6860 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6863 */   // MIs[1] x
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[1] y
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[1] z
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[1] a
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[1] b
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[1] c
     /* 6863 */   // No operand predicates
     /* 6863 */   // MIs[0] idx
     /* 6863 */   // No operand predicates
     /* 6863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6865 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6868 */ // Label 449: @6868
     /* 6868 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6892), // Rule ID 33 //
     /* 6873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6876 */   // MIs[0] root
     /* 6876 */   // No operand predicates
     /* 6876 */   // MIs[0] src
     /* 6876 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6884 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6887 */   // MIs[1] x
     /* 6887 */   // No operand predicates
     /* 6887 */   // MIs[1] y
     /* 6887 */   // No operand predicates
     /* 6887 */   // MIs[1] z
     /* 6887 */   // No operand predicates
     /* 6887 */   // MIs[1] a
     /* 6887 */   // No operand predicates
     /* 6887 */   // MIs[1] b
     /* 6887 */   // No operand predicates
     /* 6887 */   // MIs[0] idx
     /* 6887 */   // No operand predicates
     /* 6887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6889 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6889 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6892 */ // Label 450: @6892
     /* 6892 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6916), // Rule ID 32 //
     /* 6897 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6900 */   // MIs[0] root
     /* 6900 */   // No operand predicates
     /* 6900 */   // MIs[0] src
     /* 6900 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6908 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6911 */   // MIs[1] x
     /* 6911 */   // No operand predicates
     /* 6911 */   // MIs[1] y
     /* 6911 */   // No operand predicates
     /* 6911 */   // MIs[1] z
     /* 6911 */   // No operand predicates
     /* 6911 */   // MIs[1] a
     /* 6911 */   // No operand predicates
     /* 6911 */   // MIs[0] idx
     /* 6911 */   // No operand predicates
     /* 6911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6913 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6913 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6916 */ // Label 451: @6916
     /* 6916 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6940), // Rule ID 31 //
     /* 6921 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6924 */   // MIs[0] root
     /* 6924 */   // No operand predicates
     /* 6924 */   // MIs[0] src
     /* 6924 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6928 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6932 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6935 */   // MIs[1] x
     /* 6935 */   // No operand predicates
     /* 6935 */   // MIs[1] y
     /* 6935 */   // No operand predicates
     /* 6935 */   // MIs[1] z
     /* 6935 */   // No operand predicates
     /* 6935 */   // MIs[0] idx
     /* 6935 */   // No operand predicates
     /* 6935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6937 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6937 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6940 */ // Label 452: @6940
     /* 6940 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6974), // Rule ID 27 //
     /* 6945 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6948 */   // MIs[0] root
     /* 6948 */   // No operand predicates
     /* 6948 */   // MIs[0] src
     /* 6948 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6952 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6956 */   // MIs[1] x
     /* 6956 */   // No operand predicates
     /* 6956 */   // MIs[1] value
     /* 6956 */   // No operand predicates
     /* 6956 */   // MIs[1] idx
     /* 6956 */   // No operand predicates
     /* 6956 */   // MIs[0] idx
     /* 6956 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6961 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6968 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6968 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6973 */   GIR_EraseRootFromParent_Done,
     /* 6974 */ // Label 453: @6974
     /* 6974 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(6995), // Rule ID 28 //
     /* 6979 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6982 */   // MIs[0] root
     /* 6982 */   // No operand predicates
     /* 6982 */   // MIs[0] src
     /* 6982 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6990 */   // MIs[1] x
     /* 6990 */   // No operand predicates
     /* 6990 */   // MIs[1] value
     /* 6990 */   // No operand predicates
     /* 6990 */   // MIs[1] idx2
     /* 6990 */   // No operand predicates
     /* 6990 */   // MIs[0] idx1
     /* 6990 */   // No operand predicates
     /* 6990 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6992 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 6992 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 6995 */ // Label 454: @6995
     /* 6995 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(7024), // Rule ID 37 //
     /* 7000 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 7003 */   // MIs[0] root
     /* 7003 */   // No operand predicates
     /* 7003 */   // MIs[0] src
     /* 7003 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 7011 */   // MIs[1] src1
     /* 7011 */   // No operand predicates
     /* 7011 */   // MIs[1] src2
     /* 7011 */   // No operand predicates
     /* 7011 */   // MIs[1] mask
     /* 7011 */   // No operand predicates
     /* 7011 */   // MIs[0] idx
     /* 7011 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 7015 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7019 */   // MIs[2] imm
     /* 7019 */   // No operand predicates
     /* 7019 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7021 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 7021 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 7024 */ // Label 455: @7024
     /* 7024 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(7048), // Rule ID 30 //
     /* 7029 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 7032 */   // MIs[0] root
     /* 7032 */   // No operand predicates
     /* 7032 */   // MIs[0] src
     /* 7032 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 7040 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 7043 */   // MIs[1] x
     /* 7043 */   // No operand predicates
     /* 7043 */   // MIs[1] y
     /* 7043 */   // No operand predicates
     /* 7043 */   // MIs[0] idx
     /* 7043 */   // No operand predicates
     /* 7043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7045 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 7045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 7048 */ // Label 456: @7048
     /* 7048 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(7080), // Rule ID 29 //
     /* 7053 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 7056 */   // MIs[0] root
     /* 7056 */   // No operand predicates
     /* 7056 */   // MIs[0] src
     /* 7056 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 7064 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 7067 */   // MIs[1] unused
     /* 7067 */   // No operand predicates
     /* 7067 */   // MIs[0] idx
     /* 7067 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 7071 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 7075 */   // MIs[2] imm
     /* 7075 */   // No operand predicates
     /* 7075 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7077 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 7077 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 7080 */ // Label 457: @7080
     /* 7080 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(7104), // Rule ID 21 //
     /* 7085 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 7088 */   // MIs[0] root
     /* 7088 */   // No operand predicates
     /* 7088 */   // MIs[0] vector
     /* 7088 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7096 */   // MIs[0] idx
     /* 7096 */   // No operand predicates
     /* 7096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7098 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 7098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7101 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7103 */   GIR_EraseRootFromParent_Done,
     /* 7104 */ // Label 458: @7104
     /* 7104 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(7128), // Rule ID 22 //
     /* 7109 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 7112 */   // MIs[0] root
     /* 7112 */   // No operand predicates
     /* 7112 */   // MIs[0] vector
     /* 7112 */   // No operand predicates
     /* 7112 */   // MIs[0] idx
     /* 7112 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7120 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7122 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 7122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7125 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 7127 */   GIR_EraseRootFromParent_Done,
     /* 7128 */ // Label 459: @7128
     /* 7128 */ GIM_Reject,
     /* 7129 */ // Label 94: @7129
     /* 7129 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(7140), // Rule ID 97 //
     /* 7134 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 7137 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7137 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 7140 */ // Label 460: @7140
     /* 7140 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(7151), // Rule ID 99 //
     /* 7145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 7148 */   // Combiner Rule #80: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7148 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 7151 */ // Label 461: @7151
     /* 7151 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(7162), // Rule ID 344 //
     /* 7156 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 7159 */   // Combiner Rule #199: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7159 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 7162 */ // Label 462: @7162
     /* 7162 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(7173), // Rule ID 346 //
     /* 7167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 7170 */   // Combiner Rule #201: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7170 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 7173 */ // Label 463: @7173
     /* 7173 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(7184), // Rule ID 364 //
     /* 7178 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 7181 */   // Combiner Rule #217: shuffle_to_extract; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 7181 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 7184 */ // Label 464: @7184
     /* 7184 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(7205), // Rule ID 345 //
     /* 7189 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 7192 */   // MIs[0] root
     /* 7192 */   // No operand predicates
     /* 7192 */   // MIs[0] src1
     /* 7192 */   // No operand predicates
     /* 7192 */   // MIs[0] undef
     /* 7192 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 7196 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 7200 */   // MIs[0] mask
     /* 7200 */   // No operand predicates
     /* 7200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7202 */   // Combiner Rule #200: combine_shuffle_undef_rhs
     /* 7202 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 7205 */ // Label 465: @7205
     /* 7205 */ GIM_Reject,
     /* 7206 */ // Label 95: @7206
     /* 7206 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(7250), // Rule ID 223 //
     /* 7211 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 7214 */   // MIs[0] d
     /* 7214 */   // No operand predicates
     /* 7214 */   // MIs[0] src
     /* 7214 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7218 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7222 */   // MIs[1] rev
     /* 7222 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7226 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7230 */   // MIs[2] val
     /* 7230 */   // No operand predicates
     /* 7230 */   // MIs[1] amt
     /* 7230 */   // No operand predicates
     /* 7230 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 7234 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7236 */   // Combiner Rule #160: bitreverse_lshr
     /* 7236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7239 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7241 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7245 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7249 */   GIR_EraseRootFromParent_Done,
     /* 7250 */ // Label 466: @7250
     /* 7250 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(7294), // Rule ID 222 //
     /* 7255 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 7258 */   // MIs[0] d
     /* 7258 */   // No operand predicates
     /* 7258 */   // MIs[0] src
     /* 7258 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 7266 */   // MIs[1] rev
     /* 7266 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 7270 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 7274 */   // MIs[2] val
     /* 7274 */   // No operand predicates
     /* 7274 */   // MIs[1] amt
     /* 7274 */   // No operand predicates
     /* 7274 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 7278 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 7280 */   // Combiner Rule #159: bitreverse_shl
     /* 7280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 7283 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 7285 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 7289 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 7293 */   GIR_EraseRootFromParent_Done,
     /* 7294 */ // Label 467: @7294
     /* 7294 */ GIM_Reject,
     /* 7295 */ // Label 96: @7295
     /* 7295 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(7316), // Rule ID 178 //
     /* 7300 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 7303 */   // MIs[0] dst
     /* 7303 */   // No operand predicates
     /* 7303 */   // MIs[0] src0
     /* 7303 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7311 */   // MIs[1] cst
     /* 7311 */   // No operand predicates
     /* 7311 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7313 */   // Combiner Rule #136: constant_fold_fsqrt
     /* 7313 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 7316 */ // Label 468: @7316
     /* 7316 */ GIM_Reject,
     /* 7317 */ // Label 97: @7317
     /* 7317 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(7331), // Rule ID 365 //
     /* 7322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 7325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 7328 */   // Combiner Rule #218: ext_addv_to_udot_addv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 7331 */ // Label 469: @7331
     /* 7331 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(7342), // Rule ID 366 //
     /* 7336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 7339 */   // Combiner Rule #219: ext_uaddv_to_uaddlv; wip_match_opcode 'G_VECREDUCE_ADD'
     /* 7339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 7342 */ // Label 470: @7342
     /* 7342 */ GIM_Reject,
     /* 7343 */ // Label 98: @7343
     /* 7343 */ GIM_Reject,
     /* 7344 */ }; // Size: 7344 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

