/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* RISCVPreLegalizerCombinerImpl Combiner Match Table                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct RISCVPreLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 193;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 144;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 143;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 198;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 89;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 192;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 88;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 196;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 197;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 94;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 212;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 187;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 131;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 206;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 145;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 189;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 175;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 132;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 127;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 173;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 174;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 161;	 // "commute_shift"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 69;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 124;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 205;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 125;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 172;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 171;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 204;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 207;	 // "unmerge_undef"
        }
        break;
      }
      break;
    }
    break;
  case 14:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 85;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 159;	 // "bitreverse_shl"
      }
      break;
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 170;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 91;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 106;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 54;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 105;	 // "shifts_too_big"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 160;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 68;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 152;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 62;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 142;	 // "overlapping_and"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 83;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 129;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 58;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 61;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 60;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 59;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 63;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 55;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 188;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 121;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 71;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 90;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 110;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 168;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 153;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 81;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 149;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 123;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 150;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 72;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 128;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 86;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 146;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 135;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 134;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 147;	 // "expand_const_fpowi"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 99;	 // "fptrunc_fpext_fold"
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
          break;
        return 56;	 // "select_of_truncate"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
          break;
        return 118;	 // "sext_inreg_of_load"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 87;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 141;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 166;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 137;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 136;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtend_through_phis", 18) != 0)
        break;
      return 102;	 // "extend_through_phis"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 64;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 211;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 108;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 107;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 84;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 122;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 103;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 194;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 76;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 177;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 98;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 210;	 // "merge_of_x_and_undef"
    case 'r':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "edu", 3) != 0)
        break;
      switch (RuleIdentifier[4]) {
      default: break;
      case 'c':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
          break;
        return 119;	 // "reduce_shl_of_extend"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
          break;
        return 126;	 // "redundant_sext_inreg"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 77;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 209;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 195;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 169;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 138;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 93;	 // "right_identity_one_fp"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 73;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 208;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 199;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 167;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 186;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 157;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 158;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 155;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 112;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 213;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 78;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 176;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 92;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 116;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 96;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 57;	 // "buildvector_of_truncate"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_right_zero", 22) != 0)
        break;
      return 156;	 // "funnel_shift_right_zero"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 140;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 79;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 74;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 120;	 // "narrow_binop_feeding_and"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "f_sext_inreg", 12) != 0)
          break;
        return 53;	 // "sext_inreg_of_sext_inreg"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "o_zext_inreg", 12) != 0)
          break;
        return 130;	 // "sext_inreg_to_zext_inreg"
      }
      break;
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 148;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 164;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 95;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 200;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 66;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 117;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 101;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 75;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 191;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 154;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 100;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 202;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 190;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 114;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 115;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 97;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 203;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 113;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 133;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 80;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 151;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 165;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 70;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 201;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 111;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_", 22) != 0)
      break;
    switch (RuleIdentifier[22]) {
    default: break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
        break;
      return 22;	 // "insert_vector_element_elt_undef"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
        break;
      return 21;	 // "insert_vector_element_idx_undef"
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 162;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 178;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 182;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_all_elts_from_build_vector", 34) != 0)
      break;
    return 67;	 // "extract_all_elts_from_build_vector"
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 180;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 65;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 82;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 183;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 104;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 179;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 184;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 181;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 185;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 214}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool RISCVPreLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool RISCVPreLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> RISCVPreLegalizerCombinerOption;
static cl::list<std::string> RISCVPreLegalizerCombinerDisableOption(
    "riscvprelegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the RISCVPreLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      RISCVPreLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> RISCVPreLegalizerCombinerOnlyEnableOption(
    "riscvprelegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the RISCVPreLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      RISCVPreLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        RISCVPreLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool RISCVPreLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool RISCVPreLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : RISCVPreLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 0;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVPreLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVPreLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVPreLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVPreLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s1,
};
const static size_t NumTypeObjects = 1;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
};

PredicateBitset RISCVPreLegalizerCombinerImpl::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  return Features;
}

void RISCVPreLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVPreLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

RISCVPreLegalizerCombinerImpl::ComplexMatcherMemFn
RISCVPreLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool RISCVPreLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVPreLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
};

bool RISCVPreLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
RISCVPreLegalizerCombinerImpl::CustomRendererFn
RISCVPreLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool RISCVPreLegalizerCombinerImpl::tryCombineAll(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
};
bool RISCVPreLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    SmallVector<Register, 4> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchUDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    SmallVector<Register, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVPreLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(262), /*)*//*default:*//*Label 95*/ GIMT_Encode4(7011),
     /*   10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(978), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(990),
     /*  146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(1547),
     /*  150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(1865),
     /*  154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(2031),
     /*  158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(2104),
     /*  162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(2188),
     /*  166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(2233), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(2300),
     /*  182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(2581),
     /*  186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(2826), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(2927), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 12*/ GIMT_Encode4(2939), GIMT_Encode4(0),
     /*  234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 13*/ GIMT_Encode4(3006),
     /*  238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 14*/ GIMT_Encode4(3080),
     /*  242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 15*/ GIMT_Encode4(3128),
     /*  246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 16*/ GIMT_Encode4(3140),
     /*  250 */ /*TargetOpcode::G_PTRTOINT*//*Label 17*/ GIMT_Encode4(3152),
     /*  254 */ /*TargetOpcode::G_INTTOPTR*//*Label 18*/ GIMT_Encode4(3195),
     /*  258 */ /*TargetOpcode::G_BITCAST*//*Label 19*/ GIMT_Encode4(3228),
     /*  262 */ /*TargetOpcode::G_FREEZE*//*Label 20*/ GIMT_Encode4(3271), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  302 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(3335),
     /*  306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(3347),
     /*  310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(3359), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  326 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(3371), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  462 */ /*TargetOpcode::G_ANYEXT*//*Label 25*/ GIMT_Encode4(3383),
     /*  466 */ /*TargetOpcode::G_TRUNC*//*Label 26*/ GIMT_Encode4(3511), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  486 */ /*TargetOpcode::G_SEXT*//*Label 27*/ GIMT_Encode4(3869),
     /*  490 */ /*TargetOpcode::G_SEXT_INREG*//*Label 28*/ GIMT_Encode4(3944),
     /*  494 */ /*TargetOpcode::G_ZEXT*//*Label 29*/ GIMT_Encode4(4010),
     /*  498 */ /*TargetOpcode::G_SHL*//*Label 30*/ GIMT_Encode4(4140),
     /*  502 */ /*TargetOpcode::G_LSHR*//*Label 31*/ GIMT_Encode4(4309),
     /*  506 */ /*TargetOpcode::G_ASHR*//*Label 32*/ GIMT_Encode4(4432),
     /*  510 */ /*TargetOpcode::G_FSHL*//*Label 33*/ GIMT_Encode4(4566),
     /*  514 */ /*TargetOpcode::G_FSHR*//*Label 34*/ GIMT_Encode4(4609),
     /*  518 */ /*TargetOpcode::G_ROTR*//*Label 35*/ GIMT_Encode4(4652),
     /*  522 */ /*TargetOpcode::G_ROTL*//*Label 36*/ GIMT_Encode4(4676),
     /*  526 */ /*TargetOpcode::G_ICMP*//*Label 37*/ GIMT_Encode4(4700),
     /*  530 */ /*TargetOpcode::G_FCMP*//*Label 38*/ GIMT_Encode4(4745), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  542 */ /*TargetOpcode::G_SELECT*//*Label 39*/ GIMT_Encode4(4757),
     /*  546 */ /*TargetOpcode::G_UADDO*//*Label 40*/ GIMT_Encode4(4852),
     /*  550 */ /*TargetOpcode::G_UADDE*//*Label 41*/ GIMT_Encode4(4875),
     /*  554 */ /*TargetOpcode::G_USUBO*//*Label 42*/ GIMT_Encode4(4887),
     /*  558 */ /*TargetOpcode::G_USUBE*//*Label 43*/ GIMT_Encode4(4899),
     /*  562 */ /*TargetOpcode::G_SADDO*//*Label 44*/ GIMT_Encode4(4911),
     /*  566 */ /*TargetOpcode::G_SADDE*//*Label 45*/ GIMT_Encode4(4934),
     /*  570 */ /*TargetOpcode::G_SSUBO*//*Label 46*/ GIMT_Encode4(4946),
     /*  574 */ /*TargetOpcode::G_SSUBE*//*Label 47*/ GIMT_Encode4(4958),
     /*  578 */ /*TargetOpcode::G_UMULO*//*Label 48*/ GIMT_Encode4(4970),
     /*  582 */ /*TargetOpcode::G_SMULO*//*Label 49*/ GIMT_Encode4(5004),
     /*  586 */ /*TargetOpcode::G_UMULH*//*Label 50*/ GIMT_Encode4(5038),
     /*  590 */ /*TargetOpcode::G_SMULH*//*Label 51*/ GIMT_Encode4(5061),
     /*  594 */ /*TargetOpcode::G_UADDSAT*//*Label 52*/ GIMT_Encode4(5073),
     /*  598 */ /*TargetOpcode::G_SADDSAT*//*Label 53*/ GIMT_Encode4(5085), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  610 */ /*TargetOpcode::G_USHLSAT*//*Label 54*/ GIMT_Encode4(5097),
     /*  614 */ /*TargetOpcode::G_SSHLSAT*//*Label 55*/ GIMT_Encode4(5120),
     /*  618 */ /*TargetOpcode::G_SMULFIX*//*Label 56*/ GIMT_Encode4(5143),
     /*  622 */ /*TargetOpcode::G_UMULFIX*//*Label 57*/ GIMT_Encode4(5155),
     /*  626 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 58*/ GIMT_Encode4(5167),
     /*  630 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 59*/ GIMT_Encode4(5179), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  650 */ /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(5191),
     /*  654 */ /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(5303),
     /*  658 */ /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(5392),
     /*  662 */ /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(5480),
     /*  666 */ /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(5503),
     /*  670 */ /*TargetOpcode::G_FDIV*//*Label 65*/ GIMT_Encode4(5526),
     /*  674 */ /*TargetOpcode::G_FREM*//*Label 66*/ GIMT_Encode4(5560), GIMT_Encode4(0),
     /*  682 */ /*TargetOpcode::G_FPOWI*//*Label 67*/ GIMT_Encode4(5572), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  702 */ /*TargetOpcode::G_FLOG2*//*Label 68*/ GIMT_Encode4(5594), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  718 */ /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(5616), GIMT_Encode4(0),
     /*  726 */ /*TargetOpcode::G_FPTRUNC*//*Label 70*/ GIMT_Encode4(5667),
     /*  730 */ /*TargetOpcode::G_FPTOSI*//*Label 71*/ GIMT_Encode4(5710),
     /*  734 */ /*TargetOpcode::G_FPTOUI*//*Label 72*/ GIMT_Encode4(5732),
     /*  738 */ /*TargetOpcode::G_SITOFP*//*Label 73*/ GIMT_Encode4(5754),
     /*  742 */ /*TargetOpcode::G_UITOFP*//*Label 74*/ GIMT_Encode4(5781), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  754 */ /*TargetOpcode::G_FABS*//*Label 75*/ GIMT_Encode4(5808), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  766 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 76*/ GIMT_Encode4(5887),
     /*  770 */ /*TargetOpcode::G_FMINNUM*//*Label 77*/ GIMT_Encode4(5917),
     /*  774 */ /*TargetOpcode::G_FMAXNUM*//*Label 78*/ GIMT_Encode4(5951),
     /*  778 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 79*/ GIMT_Encode4(5985),
     /*  782 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 80*/ GIMT_Encode4(5997),
     /*  786 */ /*TargetOpcode::G_FMINIMUM*//*Label 81*/ GIMT_Encode4(6009),
     /*  790 */ /*TargetOpcode::G_FMAXIMUM*//*Label 82*/ GIMT_Encode4(6043), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  818 */ /*TargetOpcode::G_PTR_ADD*//*Label 83*/ GIMT_Encode4(6077), GIMT_Encode4(0),
     /*  826 */ /*TargetOpcode::G_SMIN*//*Label 84*/ GIMT_Encode4(6167),
     /*  830 */ /*TargetOpcode::G_SMAX*//*Label 85*/ GIMT_Encode4(6201),
     /*  834 */ /*TargetOpcode::G_UMIN*//*Label 86*/ GIMT_Encode4(6235),
     /*  838 */ /*TargetOpcode::G_UMAX*//*Label 87*/ GIMT_Encode4(6269),
     /*  842 */ /*TargetOpcode::G_ABS*//*Label 88*/ GIMT_Encode4(6303), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  854 */ /*TargetOpcode::G_BR*//*Label 89*/ GIMT_Encode4(6315), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  874 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(6327),
     /*  878 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(6457),
     /*  882 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 92*/ GIMT_Encode4(6834), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  922 */ /*TargetOpcode::G_BITREVERSE*//*Label 93*/ GIMT_Encode4(6900), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  974 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(6989),
     /*  978 */ // Label 0: @978
     /*  978 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(989), // Rule ID 13 //
     /*  983 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /*  986 */   // MIs[0] d
     /*  986 */   // No operand predicates
     /*  986 */   // MIs[0] s
     /*  986 */   // No operand predicates
     /*  986 */   // Combiner Rule #13: copy_prop
     /*  986 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /*  989 */ // Label 96: @989
     /*  989 */ GIM_Reject,
     /*  990 */ // Label 1: @990
     /*  990 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1001), // Rule ID 16 //
     /*  995 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /*  998 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /*  998 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 1001 */ // Label 97: @1001
     /* 1001 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1012), // Rule ID 94 //
     /* 1006 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1009 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 1009 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1012 */ // Label 98: @1012
     /* 1012 */ GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1023), // Rule ID 141 //
     /* 1017 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 1020 */   // Combiner Rule #103: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 1020 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 1023 */ // Label 99: @1023
     /* 1023 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1034), // Rule ID 231 //
     /* 1028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1031 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 1031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1034 */ // Label 100: @1034
     /* 1034 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1045), // Rule ID 279 //
     /* 1039 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1042 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 1042 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1045 */ // Label 101: @1045
     /* 1045 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1056), // Rule ID 308 //
     /* 1050 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 1053 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 1053 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1056 */ // Label 102: @1056
     /* 1056 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1090), // Rule ID 0 //
     /* 1061 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 1064 */   // MIs[0] root
     /* 1064 */   // No operand predicates
     /* 1064 */   // MIs[0] sub
     /* 1064 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1072 */   // MIs[1] Operand 1
     /* 1072 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1076 */   // MIs[1] A
     /* 1076 */   // No operand predicates
     /* 1076 */   // MIs[0] B
     /* 1076 */   // No operand predicates
     /* 1076 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1078 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 1078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1081 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1083 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 1085 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 1089 */   GIR_EraseRootFromParent_Done,
     /* 1090 */ // Label 103: @1090
     /* 1090 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1127), // Rule ID 12 //
     /* 1095 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 1098 */   // MIs[0] root
     /* 1098 */   // No operand predicates
     /* 1098 */   // MIs[0] sub
     /* 1098 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1106 */   // MIs[1] A
     /* 1106 */   // No operand predicates
     /* 1106 */   // MIs[1] c1
     /* 1106 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1110 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1114 */   // MIs[2] imm1
     /* 1114 */   // No operand predicates
     /* 1114 */   // MIs[0] c2
     /* 1114 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1118 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1122 */   // MIs[3] imm2
     /* 1122 */   // No operand predicates
     /* 1122 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1124 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 1124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 1127 */ // Label 104: @1127
     /* 1127 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1161), // Rule ID 3 //
     /* 1132 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 1135 */   // MIs[0] root
     /* 1135 */   // No operand predicates
     /* 1135 */   // MIs[0] sub
     /* 1135 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1143 */   // MIs[1] B
     /* 1143 */   // No operand predicates
     /* 1143 */   // MIs[1] A
     /* 1143 */   // No operand predicates
     /* 1143 */   // MIs[0] A
     /* 1143 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1148 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1155 */   // Combiner Rule #3: BMinusAPlusA
     /* 1155 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1160 */   GIR_EraseRootFromParent_Done,
     /* 1161 */ // Label 105: @1161
     /* 1161 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1195), // Rule ID 131 //
     /* 1166 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1169 */   // MIs[0] dst
     /* 1169 */   // No operand predicates
     /* 1169 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1169 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1177 */   // MIs[1] src
     /* 1177 */   // No operand predicates
     /* 1177 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1177 */   // No operand predicates
     /* 1177 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1177 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1182 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1187 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1189 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 1189 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1194 */   GIR_EraseRootFromParent_Done,
     /* 1195 */ // Label 106: @1195
     /* 1195 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1240), // Rule ID 5 //
     /* 1200 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 1203 */   // MIs[0] root
     /* 1203 */   // No operand predicates
     /* 1203 */   // MIs[0] sub1
     /* 1203 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1207 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1211 */   // MIs[1] A
     /* 1211 */   // No operand predicates
     /* 1211 */   // MIs[1] B
     /* 1211 */   // No operand predicates
     /* 1211 */   // MIs[0] sub2
     /* 1211 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1215 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1219 */   // MIs[2] B
     /* 1219 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 1224 */   // MIs[2] C
     /* 1224 */   // No operand predicates
     /* 1224 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1226 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 1226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1229 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1231 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 1235 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1239 */   GIR_EraseRootFromParent_Done,
     /* 1240 */ // Label 107: @1240
     /* 1240 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1285), // Rule ID 4 //
     /* 1245 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 1248 */   // MIs[0] root
     /* 1248 */   // No operand predicates
     /* 1248 */   // MIs[0] sub1
     /* 1248 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1256 */   // MIs[1] A
     /* 1256 */   // No operand predicates
     /* 1256 */   // MIs[1] B
     /* 1256 */   // No operand predicates
     /* 1256 */   // MIs[0] sub2
     /* 1256 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1260 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1264 */   // MIs[2] C
     /* 1264 */   // No operand predicates
     /* 1264 */   // MIs[2] A
     /* 1264 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 1269 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1271 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 1271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1274 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1276 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1280 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1284 */   GIR_EraseRootFromParent_Done,
     /* 1285 */ // Label 108: @1285
     /* 1285 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1320), // Rule ID 39 //
     /* 1290 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 1293 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1299 */   // MIs[0] root
     /* 1299 */   // No operand predicates
     /* 1299 */   // MIs[0] left
     /* 1299 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1307 */   // MIs[1] imm1
     /* 1307 */   // No operand predicates
     /* 1307 */   // MIs[0] right
     /* 1307 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1311 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1315 */   // MIs[2] imm2
     /* 1315 */   // No operand predicates
     /* 1315 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1317 */   // Combiner Rule #37: add_of_vscale
     /* 1317 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 1320 */ // Label 109: @1320
     /* 1320 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1354), // Rule ID 1 //
     /* 1325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 1328 */   // MIs[0] root
     /* 1328 */   // No operand predicates
     /* 1328 */   // MIs[0] A
     /* 1328 */   // No operand predicates
     /* 1328 */   // MIs[0] sub
     /* 1328 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1336 */   // MIs[1] Operand 1
     /* 1336 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 1340 */   // MIs[1] B
     /* 1340 */   // No operand predicates
     /* 1340 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1342 */   // Combiner Rule #1: APlusZeroMinusB
     /* 1342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1345 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1347 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 1349 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 1353 */   GIR_EraseRootFromParent_Done,
     /* 1354 */ // Label 110: @1354
     /* 1354 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1388), // Rule ID 2 //
     /* 1359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 1362 */   // MIs[0] root
     /* 1362 */   // No operand predicates
     /* 1362 */   // MIs[0] A
     /* 1362 */   // No operand predicates
     /* 1362 */   // MIs[0] sub
     /* 1362 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1370 */   // MIs[1] B
     /* 1370 */   // No operand predicates
     /* 1370 */   // MIs[1] A
     /* 1370 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1375 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1380 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1382 */   // Combiner Rule #2: APlusBMinusB
     /* 1382 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1387 */   GIR_EraseRootFromParent_Done,
     /* 1388 */ // Label 111: @1388
     /* 1388 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1422), // Rule ID 130 //
     /* 1393 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 1396 */   // MIs[0] dst
     /* 1396 */   // No operand predicates
     /* 1396 */   // MIs[0] __add_sub_reg_match_0.x
     /* 1396 */   // No operand predicates
     /* 1396 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 1396 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1404 */   // MIs[1] src
     /* 1404 */   // No operand predicates
     /* 1404 */   // MIs[1] __add_sub_reg_match_0.x
     /* 1404 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1409 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 1416 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 1421 */   GIR_EraseRootFromParent_Done,
     /* 1422 */ // Label 112: @1422
     /* 1422 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1467), // Rule ID 6 //
     /* 1427 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 1430 */   // MIs[0] root
     /* 1430 */   // No operand predicates
     /* 1430 */   // MIs[0] A
     /* 1430 */   // No operand predicates
     /* 1430 */   // MIs[0] sub1
     /* 1430 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1434 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1438 */   // MIs[1] B
     /* 1438 */   // No operand predicates
     /* 1438 */   // MIs[1] add1
     /* 1438 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1442 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1446 */   // MIs[2] A
     /* 1446 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1451 */   // MIs[2] C
     /* 1451 */   // No operand predicates
     /* 1451 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1453 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 1453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1456 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1458 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1462 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 1466 */   GIR_EraseRootFromParent_Done,
     /* 1467 */ // Label 113: @1467
     /* 1467 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(1512), // Rule ID 7 //
     /* 1472 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 1475 */   // MIs[0] root
     /* 1475 */   // No operand predicates
     /* 1475 */   // MIs[0] A
     /* 1475 */   // No operand predicates
     /* 1475 */   // MIs[0] sub1
     /* 1475 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1483 */   // MIs[1] B
     /* 1483 */   // No operand predicates
     /* 1483 */   // MIs[1] add1
     /* 1483 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1487 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1491 */   // MIs[2] C
     /* 1491 */   // No operand predicates
     /* 1491 */   // MIs[2] A
     /* 1491 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 1496 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1498 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 1498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1501 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 1503 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 1507 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 1511 */   GIR_EraseRootFromParent_Done,
     /* 1512 */ // Label 114: @1512
     /* 1512 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(1535), // Rule ID 105 //
     /* 1517 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1520 */   // MIs[0] dst
     /* 1520 */   // No operand predicates
     /* 1520 */   // MIs[0] lhs
     /* 1520 */   // No operand predicates
     /* 1520 */   // MIs[0] Operand 2
     /* 1520 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1524 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1529 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 1529 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1534 */   GIR_EraseRootFromParent_Done,
     /* 1535 */ // Label 115: @1535
     /* 1535 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(1546), // Rule ID 149 //
     /* 1540 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 1543 */   // MIs[0] root
     /* 1543 */   // No operand predicates
     /* 1543 */   // MIs[0] src1
     /* 1543 */   // No operand predicates
     /* 1543 */   // MIs[0] src2
     /* 1543 */   // No operand predicates
     /* 1543 */   // Combiner Rule #107: reassoc_comm_binops
     /* 1543 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 1546 */ // Label 116: @1546
     /* 1546 */ GIM_Reject,
     /* 1547 */ // Label 2: @1547
     /* 1547 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1558), // Rule ID 95 //
     /* 1552 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 1555 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 1555 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 1558 */ // Label 117: @1558
     /* 1558 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1569), // Rule ID 239 //
     /* 1563 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1566 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 1566 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1569 */ // Label 118: @1569
     /* 1569 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1580), // Rule ID 280 //
     /* 1574 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 1577 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 1577 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 1580 */ // Label 119: @1580
     /* 1580 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1591), // Rule ID 305 //
     /* 1585 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 1588 */   // Combiner Rule #187: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 1588 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 1591 */ // Label 120: @1591
     /* 1591 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1602), // Rule ID 339 //
     /* 1596 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 1599 */   // Combiner Rule #194: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 1599 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 1602 */ // Label 121: @1602
     /* 1602 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1639), // Rule ID 8 //
     /* 1607 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 1610 */   // MIs[0] root
     /* 1610 */   // No operand predicates
     /* 1610 */   // MIs[0] add
     /* 1610 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1618 */   // MIs[1] A
     /* 1618 */   // No operand predicates
     /* 1618 */   // MIs[1] c1
     /* 1618 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1622 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1626 */   // MIs[2] imm1
     /* 1626 */   // No operand predicates
     /* 1626 */   // MIs[0] c2
     /* 1626 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1630 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1634 */   // MIs[3] imm2
     /* 1634 */   // No operand predicates
     /* 1634 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1636 */   // Combiner Rule #8: APlusC1MinusC2
     /* 1636 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 1639 */ // Label 122: @1639
     /* 1639 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1676), // Rule ID 11 //
     /* 1644 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 1647 */   // MIs[0] root
     /* 1647 */   // No operand predicates
     /* 1647 */   // MIs[0] sub1
     /* 1647 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1655 */   // MIs[1] c1
     /* 1655 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 1659 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1663 */   // MIs[2] imm1
     /* 1663 */   // No operand predicates
     /* 1663 */   // MIs[1] A
     /* 1663 */   // No operand predicates
     /* 1663 */   // MIs[0] c2
     /* 1663 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1667 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1671 */   // MIs[3] imm2
     /* 1671 */   // No operand predicates
     /* 1671 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1673 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 1673 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 1676 */ // Label 123: @1676
     /* 1676 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1713), // Rule ID 10 //
     /* 1681 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 1684 */   // MIs[0] root
     /* 1684 */   // No operand predicates
     /* 1684 */   // MIs[0] sub1
     /* 1684 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1692 */   // MIs[1] A
     /* 1692 */   // No operand predicates
     /* 1692 */   // MIs[1] c1
     /* 1692 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 1696 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1700 */   // MIs[2] imm1
     /* 1700 */   // No operand predicates
     /* 1700 */   // MIs[0] c2
     /* 1700 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 1704 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1708 */   // MIs[3] imm2
     /* 1708 */   // No operand predicates
     /* 1708 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1710 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 1710 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 1713 */ // Label 124: @1713
     /* 1713 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1756), // Rule ID 159 //
     /* 1718 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 1721 */   // MIs[0] dst
     /* 1721 */   // No operand predicates
     /* 1721 */   // MIs[0] Operand 1
     /* 1721 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 1725 */   // MIs[0] and
     /* 1725 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1729 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 1733 */   // MIs[1] x
     /* 1733 */   // No operand predicates
     /* 1733 */   // MIs[1] Operand 2
     /* 1733 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 1737 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 1741 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1743 */   // Combiner Rule #117: neg_and_one_to_sext_inreg
     /* 1743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 1746 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1748 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 1752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1755 */   GIR_EraseRootFromParent_Done,
     /* 1756 */ // Label 125: @1756
     /* 1756 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1793), // Rule ID 9 //
     /* 1761 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 1764 */   // MIs[0] root
     /* 1764 */   // No operand predicates
     /* 1764 */   // MIs[0] c2
     /* 1764 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1772 */   // MIs[1] imm2
     /* 1772 */   // No operand predicates
     /* 1772 */   // MIs[0] add
     /* 1772 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1776 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 1780 */   // MIs[2] A
     /* 1780 */   // No operand predicates
     /* 1780 */   // MIs[2] c1
     /* 1780 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 1784 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1788 */   // MIs[3] imm1
     /* 1788 */   // No operand predicates
     /* 1788 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 1790 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 1790 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 1793 */ // Label 126: @1793
     /* 1793 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1820), // Rule ID 42 //
     /* 1798 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 1801 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1807 */   // MIs[0] root
     /* 1807 */   // No operand predicates
     /* 1807 */   // MIs[0] x
     /* 1807 */   // No operand predicates
     /* 1807 */   // MIs[0] right
     /* 1807 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1815 */   // MIs[1] imm
     /* 1815 */   // No operand predicates
     /* 1815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1817 */   // Combiner Rule #40: sub_of_vscale
     /* 1817 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 1820 */ // Label 127: @1820
     /* 1820 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1843), // Rule ID 104 //
     /* 1825 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 1828 */   // MIs[0] dst
     /* 1828 */   // No operand predicates
     /* 1828 */   // MIs[0] lhs
     /* 1828 */   // No operand predicates
     /* 1828 */   // MIs[0] Operand 2
     /* 1828 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1832 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1837 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 1837 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 1842 */   GIR_EraseRootFromParent_Done,
     /* 1843 */ // Label 128: @1843
     /* 1843 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1864), // Rule ID 15 //
     /* 1848 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 1851 */   // MIs[0] d
     /* 1851 */   // No operand predicates
     /* 1851 */   // MIs[0] op1
     /* 1851 */   // No operand predicates
     /* 1851 */   // MIs[0] c
     /* 1851 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1855 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1859 */   // MIs[1] imm
     /* 1859 */   // No operand predicates
     /* 1859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1861 */   // Combiner Rule #15: sub_to_add
     /* 1861 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 1864 */ // Label 129: @1864
     /* 1864 */ GIM_Reject,
     /* 1865 */ // Label 3: @1865
     /* 1865 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1876), // Rule ID 78 //
     /* 1870 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 1873 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 1873 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 1876 */ // Label 130: @1876
     /* 1876 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1887), // Rule ID 236 //
     /* 1881 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 1884 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 1884 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 1887 */ // Label 131: @1887
     /* 1887 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1898), // Rule ID 309 //
     /* 1892 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 1895 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 1895 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 1898 */ // Label 132: @1898
     /* 1898 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1938), // Rule ID 17 //
     /* 1903 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 1906 */   // MIs[0] dst
     /* 1906 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 1910 */   // MIs[0] x
     /* 1910 */   // No operand predicates
     /* 1910 */   // MIs[0] Operand 2
     /* 1910 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 1914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 1917 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 1927 */   // Combiner Rule #17: mul_by_neg_one
     /* 1927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 1930 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 1932 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1935 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 1937 */   GIR_EraseRootFromParent_Done,
     /* 1938 */ // Label 133: @1938
     /* 1938 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1973), // Rule ID 40 //
     /* 1943 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 1946 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 1952 */   // MIs[0] root
     /* 1952 */   // No operand predicates
     /* 1952 */   // MIs[0] left
     /* 1952 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 1956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 1960 */   // MIs[1] scale
     /* 1960 */   // No operand predicates
     /* 1960 */   // MIs[0] x
     /* 1960 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 1964 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1968 */   // MIs[2] imm1
     /* 1968 */   // No operand predicates
     /* 1968 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1970 */   // Combiner Rule #38: mul_of_vscale
     /* 1970 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 1973 */ // Label 134: @1973
     /* 1973 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(1996), // Rule ID 123 //
     /* 1978 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 1981 */   // MIs[0] dst
     /* 1981 */   // No operand predicates
     /* 1981 */   // MIs[0] lhs
     /* 1981 */   // No operand predicates
     /* 1981 */   // MIs[0] zero
     /* 1981 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 1985 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1990 */   // Combiner Rule #87: binop_right_to_zero
     /* 1990 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 1995 */   GIR_EraseRootFromParent_Done,
     /* 1996 */ // Label 135: @1996
     /* 1996 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2019), // Rule ID 128 //
     /* 2001 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 2004 */   // MIs[0] dst
     /* 2004 */   // No operand predicates
     /* 2004 */   // MIs[0] x
     /* 2004 */   // No operand predicates
     /* 2004 */   // MIs[0] Operand 2
     /* 2004 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 2008 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2013 */   // Combiner Rule #92: right_identity_one_int
     /* 2013 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2018 */   GIR_EraseRootFromParent_Done,
     /* 2019 */ // Label 136: @2019
     /* 2019 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2030), // Rule ID 14 //
     /* 2024 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 2027 */   // MIs[0] d
     /* 2027 */   // No operand predicates
     /* 2027 */   // MIs[0] op1
     /* 2027 */   // No operand predicates
     /* 2027 */   // MIs[0] op2
     /* 2027 */   // No operand predicates
     /* 2027 */   // Combiner Rule #14: mul_to_shl
     /* 2027 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 2030 */ // Label 137: @2030
     /* 2030 */ GIM_Reject,
     /* 2031 */ // Label 4: @2031
     /* 2031 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2042), // Rule ID 119 //
     /* 2036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2039 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 2039 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2042 */ // Label 138: @2042
     /* 2042 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2053), // Rule ID 211 //
     /* 2047 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2050 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 2050 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2053 */ // Label 139: @2053
     /* 2053 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2064), // Rule ID 242 //
     /* 2058 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2061 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 2061 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2064 */ // Label 140: @2064
     /* 2064 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2075), // Rule ID 260 //
     /* 2069 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 2072 */   // Combiner Rule #172: sdiv_by_const; wip_match_opcode 'G_SDIV'
     /* 2072 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 2075 */ // Label 141: @2075
     /* 2075 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2086), // Rule ID 285 //
     /* 2080 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2083 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 2083 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2086 */ // Label 142: @2086
     /* 2086 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2103), // Rule ID 261 //
     /* 2091 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 2094 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2100 */   // MIs[0] dst
     /* 2100 */   // No operand predicates
     /* 2100 */   // MIs[0] x
     /* 2100 */   // No operand predicates
     /* 2100 */   // MIs[0] y
     /* 2100 */   // No operand predicates
     /* 2100 */   // Combiner Rule #173: sdiv_by_pow2
     /* 2100 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 2103 */ // Label 143: @2103
     /* 2103 */ GIM_Reject,
     /* 2104 */ // Label 5: @2104
     /* 2104 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2115), // Rule ID 81 //
     /* 2109 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2112 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 2112 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2115 */ // Label 144: @2115
     /* 2115 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2126), // Rule ID 120 //
     /* 2120 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2123 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 2123 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2126 */ // Label 145: @2126
     /* 2126 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2137), // Rule ID 212 //
     /* 2131 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2134 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 2134 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2137 */ // Label 146: @2137
     /* 2137 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2148), // Rule ID 241 //
     /* 2142 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2145 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 2145 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2148 */ // Label 147: @2148
     /* 2148 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2159), // Rule ID 259 //
     /* 2153 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 2156 */   // Combiner Rule #171: udiv_by_const; wip_match_opcode 'G_UDIV'
     /* 2156 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 2159 */ // Label 148: @2159
     /* 2159 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2170), // Rule ID 287 //
     /* 2164 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2167 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 2167 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2170 */ // Label 149: @2170
     /* 2170 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2187), // Rule ID 262 //
     /* 2175 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 2178 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 2184 */   // MIs[0] dst
     /* 2184 */   // No operand predicates
     /* 2184 */   // MIs[0] x
     /* 2184 */   // No operand predicates
     /* 2184 */   // MIs[0] y
     /* 2184 */   // No operand predicates
     /* 2184 */   // Combiner Rule #174: udiv_by_pow2
     /* 2184 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 2187 */ // Label 150: @2187
     /* 2187 */ GIM_Reject,
     /* 2188 */ // Label 6: @2188
     /* 2188 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2199), // Rule ID 121 //
     /* 2193 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2196 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 2196 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2199 */ // Label 151: @2199
     /* 2199 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2210), // Rule ID 213 //
     /* 2204 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2207 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 2207 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2210 */ // Label 152: @2210
     /* 2210 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(2221), // Rule ID 244 //
     /* 2215 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2218 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 2218 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2221 */ // Label 153: @2221
     /* 2221 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(2232), // Rule ID 286 //
     /* 2226 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2229 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 2229 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2232 */ // Label 154: @2232
     /* 2232 */ GIM_Reject,
     /* 2233 */ // Label 7: @2233
     /* 2233 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(2244), // Rule ID 82 //
     /* 2238 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 2241 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 2241 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 2244 */ // Label 155: @2244
     /* 2244 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(2255), // Rule ID 122 //
     /* 2249 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 2252 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 2252 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 2255 */ // Label 156: @2255
     /* 2255 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(2266), // Rule ID 170 //
     /* 2260 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 2263 */   // Combiner Rule #128: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 2263 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 2266 */ // Label 157: @2266
     /* 2266 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2277), // Rule ID 214 //
     /* 2271 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 2274 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 2274 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 2277 */ // Label 158: @2277
     /* 2277 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2288), // Rule ID 243 //
     /* 2282 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2285 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 2285 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2288 */ // Label 159: @2288
     /* 2288 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2299), // Rule ID 288 //
     /* 2293 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2296 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 2296 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2299 */ // Label 160: @2299
     /* 2299 */ GIM_Reject,
     /* 2300 */ // Label 8: @2300
     /* 2300 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2311), // Rule ID 73 //
     /* 2305 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 2308 */   // Combiner Rule #69: load_and_mask; wip_match_opcode 'G_AND'
     /* 2308 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 2311 */ // Label 161: @2311
     /* 2311 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2322), // Rule ID 77 //
     /* 2316 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 2319 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 2319 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 2322 */ // Label 162: @2322
     /* 2322 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(2333), // Rule ID 142 //
     /* 2327 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2330 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 2330 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2333 */ // Label 163: @2333
     /* 2333 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(2344), // Rule ID 162 //
     /* 2338 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 2341 */   // Combiner Rule #120: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 2341 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 2344 */ // Label 164: @2344
     /* 2344 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2355), // Rule ID 167 //
     /* 2349 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 2352 */   // Combiner Rule #125: redundant_and; wip_match_opcode 'G_AND'
     /* 2352 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 2355 */ // Label 165: @2355
     /* 2355 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2366), // Rule ID 184 //
     /* 2360 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 2363 */   // Combiner Rule #142: overlapping_and; wip_match_opcode 'G_AND'
     /* 2363 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 2366 */ // Label 166: @2366
     /* 2366 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2377), // Rule ID 233 //
     /* 2371 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2374 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 2374 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2377 */ // Label 167: @2377
     /* 2377 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2388), // Rule ID 270 //
     /* 2382 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 2385 */   // Combiner Rule #177: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 2385 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 2388 */ // Label 168: @2388
     /* 2388 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2399), // Rule ID 282 //
     /* 2393 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2396 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 2396 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2399 */ // Label 169: @2399
     /* 2399 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2410), // Rule ID 310 //
     /* 2404 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2407 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 2407 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2410 */ // Label 170: @2410
     /* 2410 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2421), // Rule ID 337 //
     /* 2415 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 2418 */   // Combiner Rule #192: match_ands; wip_match_opcode 'G_AND'
     /* 2418 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 2421 */ // Label 171: @2421
     /* 2421 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2519), // Rule ID 155 //
     /* 2426 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 2429 */   // MIs[0] root
     /* 2429 */   // No operand predicates
     /* 2429 */   // MIs[0] d1
     /* 2429 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2433 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2437 */   // MIs[1] p
     /* 2437 */   // No operand predicates
     /* 2437 */   // MIs[1] s1
     /* 2437 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2441 */   // MIs[1] Operand 3
     /* 2441 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2445 */   // MIs[0] d2
     /* 2445 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2449 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2453 */   // MIs[2] p
     /* 2453 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2458 */   // MIs[2] s2
     /* 2458 */   // No operand predicates
     /* 2458 */   // MIs[2] Operand 3
     /* 2458 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2462 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 2466 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2468 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2471 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2484 */   // Combiner Rule #113: double_icmp_zero_and_combine
     /* 2484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2487 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2492 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2496 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2504 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2508 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2512 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2515 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2518 */   GIR_EraseRootFromParent_Done,
     /* 2519 */ // Label 172: @2519
     /* 2519 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2556), // Rule ID 226 //
     /* 2524 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 2527 */   // MIs[0] root
     /* 2527 */   // No operand predicates
     /* 2527 */   // MIs[0] shift
     /* 2527 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 2535 */   // MIs[1] x
     /* 2535 */   // No operand predicates
     /* 2535 */   // MIs[1] lsb
     /* 2535 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 2539 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2543 */   // MIs[2] imm1
     /* 2543 */   // No operand predicates
     /* 2543 */   // MIs[0] mask
     /* 2543 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 2547 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2551 */   // MIs[3] imm2
     /* 2551 */   // No operand predicates
     /* 2551 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 2553 */   // Combiner Rule #163: bitfield_extract_from_and
     /* 2553 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 2556 */ // Label 173: @2556
     /* 2556 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2580), // Rule ID 114 //
     /* 2561 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2564 */   // MIs[0] dst
     /* 2564 */   // No operand predicates
     /* 2564 */   // MIs[0] src
     /* 2564 */   // No operand predicates
     /* 2564 */   // MIs[0] src
     /* 2564 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2569 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2574 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 2574 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2579 */   GIR_EraseRootFromParent_Done,
     /* 2580 */ // Label 174: @2580
     /* 2580 */ GIM_Reject,
     /* 2581 */ // Label 9: @2581
     /* 2581 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2592), // Rule ID 79 //
     /* 2586 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 2589 */   // Combiner Rule #73: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 2589 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 2592 */ // Label 175: @2592
     /* 2592 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2603), // Rule ID 143 //
     /* 2597 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2600 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 2600 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2603 */ // Label 176: @2603
     /* 2603 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2614), // Rule ID 169 //
     /* 2608 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 2611 */   // Combiner Rule #127: redundant_or; wip_match_opcode 'G_OR'
     /* 2611 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 2614 */ // Label 177: @2614
     /* 2614 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2625), // Rule ID 210 //
     /* 2619 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 2622 */   // Combiner Rule #152: load_or_combine; wip_match_opcode 'G_OR'
     /* 2622 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 2625 */ // Label 178: @2625
     /* 2625 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2636), // Rule ID 215 //
     /* 2630 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 2633 */   // Combiner Rule #154: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 2633 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 2636 */ // Label 179: @2636
     /* 2636 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2647), // Rule ID 237 //
     /* 2641 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2644 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 2644 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2647 */ // Label 180: @2647
     /* 2647 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2658), // Rule ID 283 //
     /* 2652 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2655 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 2655 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2658 */ // Label 181: @2658
     /* 2658 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2669), // Rule ID 311 //
     /* 2663 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2666 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 2666 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2669 */ // Label 182: @2669
     /* 2669 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2680), // Rule ID 338 //
     /* 2674 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 2677 */   // Combiner Rule #193: match_ors; wip_match_opcode 'G_OR'
     /* 2677 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 2680 */ // Label 183: @2680
     /* 2680 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2778), // Rule ID 156 //
     /* 2685 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 2688 */   // MIs[0] root
     /* 2688 */   // No operand predicates
     /* 2688 */   // MIs[0] d1
     /* 2688 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2696 */   // MIs[1] p
     /* 2696 */   // No operand predicates
     /* 2696 */   // MIs[1] s1
     /* 2696 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 2700 */   // MIs[1] Operand 3
     /* 2700 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 2704 */   // MIs[0] d2
     /* 2704 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2708 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2712 */   // MIs[2] p
     /* 2712 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 2717 */   // MIs[2] s2
     /* 2717 */   // No operand predicates
     /* 2717 */   // MIs[2] Operand 3
     /* 2717 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 2721 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 2725 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2727 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 2730 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 2740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 2743 */   // Combiner Rule #114: double_icmp_zero_or_combine
     /* 2743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 2746 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2751 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 2755 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 2759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2763 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 2767 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 2771 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 2774 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2777 */   GIR_EraseRootFromParent_Done,
     /* 2778 */ // Label 184: @2778
     /* 2778 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(2802), // Rule ID 115 //
     /* 2783 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 2786 */   // MIs[0] dst
     /* 2786 */   // No operand predicates
     /* 2786 */   // MIs[0] src
     /* 2786 */   // No operand predicates
     /* 2786 */   // MIs[0] src
     /* 2786 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 2791 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2796 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 2796 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2801 */   GIR_EraseRootFromParent_Done,
     /* 2802 */ // Label 185: @2802
     /* 2802 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(2825), // Rule ID 106 //
     /* 2807 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2810 */   // MIs[0] dst
     /* 2810 */   // No operand predicates
     /* 2810 */   // MIs[0] lhs
     /* 2810 */   // No operand predicates
     /* 2810 */   // MIs[0] Operand 2
     /* 2810 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2814 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2819 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 2819 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2824 */   GIR_EraseRootFromParent_Done,
     /* 2825 */ // Label 186: @2825
     /* 2825 */ GIM_Reject,
     /* 2826 */ // Label 10: @2826
     /* 2826 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(2837), // Rule ID 96 //
     /* 2831 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 2834 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 2834 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 2837 */ // Label 187: @2837
     /* 2837 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(2848), // Rule ID 144 //
     /* 2842 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 2845 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 2845 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 2848 */ // Label 188: @2848
     /* 2848 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(2859), // Rule ID 174 //
     /* 2853 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 2856 */   // Combiner Rule #132: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 2856 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 2859 */ // Label 189: @2859
     /* 2859 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(2870), // Rule ID 198 //
     /* 2864 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 2867 */   // Combiner Rule #148: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 2867 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 2870 */ // Label 190: @2870
     /* 2870 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2881), // Rule ID 240 //
     /* 2875 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 2878 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 2878 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 2881 */ // Label 191: @2881
     /* 2881 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2892), // Rule ID 284 //
     /* 2886 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 2889 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 2889 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 2892 */ // Label 192: @2892
     /* 2892 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2903), // Rule ID 312 //
     /* 2897 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 2900 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 2900 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 2903 */ // Label 193: @2903
     /* 2903 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2926), // Rule ID 107 //
     /* 2908 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 2911 */   // MIs[0] dst
     /* 2911 */   // No operand predicates
     /* 2911 */   // MIs[0] lhs
     /* 2911 */   // No operand predicates
     /* 2911 */   // MIs[0] Operand 2
     /* 2911 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2915 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2920 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 2920 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 2925 */   GIR_EraseRootFromParent_Done,
     /* 2926 */ // Label 194: @2926
     /* 2926 */ GIM_Reject,
     /* 2927 */ // Label 11: @2927
     /* 2927 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2938), // Rule ID 140 //
     /* 2932 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 2935 */   // Combiner Rule #102: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 2935 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 2938 */ // Label 195: @2938
     /* 2938 */ GIM_Reject,
     /* 2939 */ // Label 12: @2939
     /* 2939 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(2950), // Rule ID 348 //
     /* 2944 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 2947 */   // Combiner Rule #203: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2947 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 2950 */ // Label 196: @2950
     /* 2950 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(2961), // Rule ID 349 //
     /* 2955 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 2958 */   // Combiner Rule #204: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2958 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 2961 */ // Label 197: @2961
     /* 2961 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(2972), // Rule ID 351 //
     /* 2966 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 2969 */   // Combiner Rule #206: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2969 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 2972 */ // Label 198: @2972
     /* 2972 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(2983), // Rule ID 352 //
     /* 2977 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 2980 */   // Combiner Rule #207: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2980 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 2983 */ // Label 199: @2983
     /* 2983 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(2994), // Rule ID 353 //
     /* 2988 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 2991 */   // Combiner Rule #208: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 2991 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 2994 */ // Label 200: @2994
     /* 2994 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3005), // Rule ID 354 //
     /* 2999 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 3002 */   // Combiner Rule #209: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 3002 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 3005 */ // Label 201: @3005
     /* 3005 */ GIM_Reject,
     /* 3006 */ // Label 13: @3006
     /* 3006 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3017), // Rule ID 350 //
     /* 3011 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 3014 */   // Combiner Rule #205: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 3014 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 3017 */ // Label 202: @3017
     /* 3017 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3079),
     /* 3022 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 3025 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3046), // Rule ID 355 //
     /* 3030 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 3033 */     // MIs[0] root
     /* 3033 */     // No operand predicates
     /* 3033 */     // MIs[0] x
     /* 3033 */     // No operand predicates
     /* 3033 */     // MIs[0] undef
     /* 3033 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3043 */     // Combiner Rule #210: merge_of_x_and_undef
     /* 3043 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 3046 */   // Label 204: @3046
     /* 3046 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(3078), // Rule ID 356 //
     /* 3051 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 3054 */     // MIs[0] root
     /* 3054 */     // No operand predicates
     /* 3054 */     // MIs[0] x
     /* 3054 */     // No operand predicates
     /* 3054 */     // MIs[0] zero
     /* 3054 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 3058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3062 */     // MIs[1] Operand 1
     /* 3062 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 3073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3075 */     // Combiner Rule #211: merge_of_x_and_zero
     /* 3075 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 3078 */   // Label 205: @3078
     /* 3078 */   GIM_Reject,
     /* 3079 */ // Label 203: @3079
     /* 3079 */ GIM_Reject,
     /* 3080 */ // Label 14: @3080
     /* 3080 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(3091), // Rule ID 69 //
     /* 3085 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 3088 */   // Combiner Rule #67: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3088 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 3091 */ // Label 206: @3091
     /* 3091 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(3102), // Rule ID 98 //
     /* 3096 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 3099 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3099 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 3102 */ // Label 207: @3102
     /* 3102 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(3113), // Rule ID 133 //
     /* 3107 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3110 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 3110 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3113 */ // Label 208: @3113
     /* 3113 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3127), // Rule ID 347 //
     /* 3118 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 3121 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 3124 */   // MIs[0] dst
     /* 3124 */   // No operand predicates
     /* 3124 */   // MIs[0] unused
     /* 3124 */   // No operand predicates
     /* 3124 */   // Combiner Rule #202: combine_use_vector_truncate
     /* 3124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 3127 */ // Label 209: @3127
     /* 3127 */ GIM_Reject,
     /* 3128 */ // Label 15: @3128
     /* 3128 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3139), // Rule ID 132 //
     /* 3133 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 3136 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 3136 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 3139 */ // Label 210: @3139
     /* 3139 */ GIM_Reject,
     /* 3140 */ // Label 16: @3140
     /* 3140 */ GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3151), // Rule ID 340 //
     /* 3145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 3148 */   // Combiner Rule #195: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 3148 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 3151 */ // Label 211: @3151
     /* 3151 */ GIM_Reject,
     /* 3152 */ // Label 17: @3152
     /* 3152 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3173), // Rule ID 125 //
     /* 3157 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 3160 */   // MIs[0] dst
     /* 3160 */   // No operand predicates
     /* 3160 */   // MIs[0] t
     /* 3160 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3164 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 3168 */   // MIs[1] ptr
     /* 3168 */   // No operand predicates
     /* 3168 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3170 */   // Combiner Rule #89: i2p_to_p2i
     /* 3170 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 3173 */ // Label 212: @3173
     /* 3173 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(3194), // Rule ID 90 //
     /* 3178 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3181 */   // MIs[0] dst
     /* 3181 */   // No operand predicates
     /* 3181 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3181 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3191 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 3191 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3194 */ // Label 213: @3194
     /* 3194 */ GIM_Reject,
     /* 3195 */ // Label 18: @3195
     /* 3195 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3206), // Rule ID 124 //
     /* 3200 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 3203 */   // Combiner Rule #88: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 3203 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 3206 */ // Label 214: @3206
     /* 3206 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3227), // Rule ID 91 //
     /* 3211 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3214 */   // MIs[0] dst
     /* 3214 */   // No operand predicates
     /* 3214 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3214 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3218 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3222 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3224 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 3224 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3227 */ // Label 215: @3227
     /* 3227 */ GIM_Reject,
     /* 3228 */ // Label 19: @3228
     /* 3228 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3249), // Rule ID 136 //
     /* 3233 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 3236 */   // MIs[0] dst
     /* 3236 */   // No operand predicates
     /* 3236 */   // MIs[0] src1
     /* 3236 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3240 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 3244 */   // MIs[1] src0
     /* 3244 */   // No operand predicates
     /* 3244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3246 */   // Combiner Rule #98: bitcast_bitcast_fold
     /* 3246 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 3249 */ // Label 216: @3249
     /* 3249 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3270), // Rule ID 88 //
     /* 3254 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3257 */   // MIs[0] dst
     /* 3257 */   // No operand predicates
     /* 3257 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3257 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3265 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3267 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 3267 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3270 */ // Label 217: @3270
     /* 3270 */ GIM_Reject,
     /* 3271 */ // Label 20: @3271
     /* 3271 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3300), // Rule ID 18 //
     /* 3276 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 3279 */   // MIs[0] dst
     /* 3279 */   // No operand predicates
     /* 3279 */   // MIs[0] src
     /* 3279 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3283 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 3287 */   // MIs[1] __idempotent_prop_match_0.x
     /* 3287 */   // No operand predicates
     /* 3287 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3292 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3294 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 3294 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3299 */   GIR_EraseRootFromParent_Done,
     /* 3300 */ // Label 218: @3300
     /* 3300 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3323), // Rule ID 43 //
     /* 3305 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 3308 */   // MIs[0] root
     /* 3308 */   // No operand predicates
     /* 3308 */   // MIs[0] src
     /* 3308 */   // No operand predicates
     /* 3308 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 3312 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3317 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 3317 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 3322 */   GIR_EraseRootFromParent_Done,
     /* 3323 */ // Label 219: @3323
     /* 3323 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3334), // Rule ID 44 //
     /* 3328 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 3331 */   // MIs[0] dst
     /* 3331 */   // No operand predicates
     /* 3331 */   // MIs[0] src
     /* 3331 */   // No operand predicates
     /* 3331 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 3331 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 3334 */ // Label 220: @3334
     /* 3334 */ GIM_Reject,
     /* 3335 */ // Label 21: @3335
     /* 3335 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3346), // Rule ID 70 //
     /* 3340 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3343 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_LOAD'
     /* 3343 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3346 */ // Label 221: @3346
     /* 3346 */ GIM_Reject,
     /* 3347 */ // Label 22: @3347
     /* 3347 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3358), // Rule ID 71 //
     /* 3352 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3355 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 3355 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3358 */ // Label 222: @3358
     /* 3358 */ GIM_Reject,
     /* 3359 */ // Label 23: @3359
     /* 3359 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3370), // Rule ID 72 //
     /* 3364 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 3367 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 3367 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 3370 */ // Label 223: @3370
     /* 3370 */ GIM_Reject,
     /* 3371 */ // Label 24: @3371
     /* 3371 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3382), // Rule ID 100 //
     /* 3376 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 3379 */   // Combiner Rule #81: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 3379 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 3382 */ // Label 224: @3382
     /* 3382 */ GIM_Reject,
     /* 3383 */ // Label 25: @3383
     /* 3383 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(3394), // Rule ID 126 //
     /* 3388 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 3391 */   // Combiner Rule #90: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 3391 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 3394 */ // Label 225: @3394
     /* 3394 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(3405), // Rule ID 257 //
     /* 3399 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3402 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 3402 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3405 */ // Label 226: @3405
     /* 3405 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(3426), // Rule ID 57 //
     /* 3410 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 3413 */   // MIs[0] root
     /* 3413 */   // No operand predicates
     /* 3413 */   // MIs[0] select
     /* 3413 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3421 */   // MIs[1] cond
     /* 3421 */   // No operand predicates
     /* 3421 */   // MIs[1] true
     /* 3421 */   // No operand predicates
     /* 3421 */   // MIs[1] false
     /* 3421 */   // No operand predicates
     /* 3421 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3423 */   // Combiner Rule #55: select_of_anyext
     /* 3423 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3426 */ // Label 227: @3426
     /* 3426 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(3447), // Rule ID 52 //
     /* 3431 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 3434 */   // MIs[0] root
     /* 3434 */   // No operand predicates
     /* 3434 */   // MIs[0] second
     /* 3434 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3442 */   // MIs[1] src
     /* 3442 */   // No operand predicates
     /* 3442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3444 */   // Combiner Rule #50: anyext_of_anyext
     /* 3444 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3447 */ // Label 228: @3447
     /* 3447 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(3468), // Rule ID 54 //
     /* 3452 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 3455 */   // MIs[0] root
     /* 3455 */   // No operand predicates
     /* 3455 */   // MIs[0] second
     /* 3455 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3459 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3463 */   // MIs[1] src
     /* 3463 */   // No operand predicates
     /* 3463 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3465 */   // Combiner Rule #52: anyext_of_sext
     /* 3465 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3468 */ // Label 229: @3468
     /* 3468 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(3489), // Rule ID 53 //
     /* 3473 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 3476 */   // MIs[0] root
     /* 3476 */   // No operand predicates
     /* 3476 */   // MIs[0] second
     /* 3476 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3484 */   // MIs[1] src
     /* 3484 */   // No operand predicates
     /* 3484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3486 */   // Combiner Rule #51: anyext_of_zext
     /* 3486 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3489 */ // Label 230: @3489
     /* 3489 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(3510), // Rule ID 89 //
     /* 3494 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3497 */   // MIs[0] dst
     /* 3497 */   // No operand predicates
     /* 3497 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3497 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3507 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 3507 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3510 */ // Label 231: @3510
     /* 3510 */ GIM_Reject,
     /* 3511 */ // Label 26: @3511
     /* 3511 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(3522), // Rule ID 134 //
     /* 3516 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 3519 */   // Combiner Rule #96: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3519 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 3522 */ // Label 232: @3522
     /* 3522 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(3533), // Rule ID 135 //
     /* 3527 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 3530 */   // Combiner Rule #97: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 3530 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 3533 */ // Label 233: @3533
     /* 3533 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(3544), // Rule ID 173 //
     /* 3538 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 3541 */   // Combiner Rule #131: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 3541 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 3544 */ // Label 234: @3544
     /* 3544 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(3565), // Rule ID 58 //
     /* 3549 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 3552 */   // MIs[0] root
     /* 3552 */   // No operand predicates
     /* 3552 */   // MIs[0] select
     /* 3552 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 3560 */   // MIs[1] cond
     /* 3560 */   // No operand predicates
     /* 3560 */   // MIs[1] true
     /* 3560 */   // No operand predicates
     /* 3560 */   // MIs[1] false
     /* 3560 */   // No operand predicates
     /* 3560 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3562 */   // Combiner Rule #56: select_of_truncate
     /* 3562 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 3565 */ // Label 235: @3565
     /* 3565 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(3594), // Rule ID 60 //
     /* 3570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 3573 */   // MIs[0] root
     /* 3573 */   // No operand predicates
     /* 3573 */   // MIs[0] binop
     /* 3573 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 3581 */   // MIs[1] x
     /* 3581 */   // No operand predicates
     /* 3581 */   // MIs[1] const
     /* 3581 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3585 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3589 */   // MIs[2] imm
     /* 3589 */   // No operand predicates
     /* 3589 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3591 */   // Combiner Rule #58: narrow_binop_add
     /* 3591 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3594 */ // Label 236: @3594
     /* 3594 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(3623), // Rule ID 63 //
     /* 3599 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 3602 */   // MIs[0] root
     /* 3602 */   // No operand predicates
     /* 3602 */   // MIs[0] binop
     /* 3602 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 3610 */   // MIs[1] x
     /* 3610 */   // No operand predicates
     /* 3610 */   // MIs[1] const
     /* 3610 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3614 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3618 */   // MIs[2] imm
     /* 3618 */   // No operand predicates
     /* 3618 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3620 */   // Combiner Rule #61: narrow_binop_and
     /* 3620 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3623 */ // Label 237: @3623
     /* 3623 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(3652), // Rule ID 62 //
     /* 3628 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 3631 */   // MIs[0] root
     /* 3631 */   // No operand predicates
     /* 3631 */   // MIs[0] binop
     /* 3631 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 3639 */   // MIs[1] x
     /* 3639 */   // No operand predicates
     /* 3639 */   // MIs[1] const
     /* 3639 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3643 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3647 */   // MIs[2] imm
     /* 3647 */   // No operand predicates
     /* 3647 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3649 */   // Combiner Rule #60: narrow_binop_mul
     /* 3649 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3652 */ // Label 238: @3652
     /* 3652 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(3681), // Rule ID 64 //
     /* 3657 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 3660 */   // MIs[0] root
     /* 3660 */   // No operand predicates
     /* 3660 */   // MIs[0] binop
     /* 3660 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 3668 */   // MIs[1] x
     /* 3668 */   // No operand predicates
     /* 3668 */   // MIs[1] const
     /* 3668 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3672 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3676 */   // MIs[2] imm
     /* 3676 */   // No operand predicates
     /* 3676 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3678 */   // Combiner Rule #62: narrow_binop_or
     /* 3678 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3681 */ // Label 239: @3681
     /* 3681 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(3710), // Rule ID 61 //
     /* 3686 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 3689 */   // MIs[0] root
     /* 3689 */   // No operand predicates
     /* 3689 */   // MIs[0] binop
     /* 3689 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 3697 */   // MIs[1] x
     /* 3697 */   // No operand predicates
     /* 3697 */   // MIs[1] const
     /* 3697 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3701 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3705 */   // MIs[2] imm
     /* 3705 */   // No operand predicates
     /* 3705 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3707 */   // Combiner Rule #59: narrow_binop_sub
     /* 3707 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3710 */ // Label 240: @3710
     /* 3710 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(3739), // Rule ID 65 //
     /* 3715 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 3718 */   // MIs[0] root
     /* 3718 */   // No operand predicates
     /* 3718 */   // MIs[0] binop
     /* 3718 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 3726 */   // MIs[1] x
     /* 3726 */   // No operand predicates
     /* 3726 */   // MIs[1] const
     /* 3726 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 3730 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3734 */   // MIs[2] imm
     /* 3734 */   // No operand predicates
     /* 3734 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 3736 */   // Combiner Rule #63: narrow_binop_xor
     /* 3736 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 3739 */ // Label 241: @3739
     /* 3739 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(3760), // Rule ID 47 //
     /* 3744 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 3747 */   // MIs[0] root
     /* 3747 */   // No operand predicates
     /* 3747 */   // MIs[0] ext
     /* 3747 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3755 */   // MIs[1] src
     /* 3755 */   // No operand predicates
     /* 3755 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3757 */   // Combiner Rule #45: truncate_of_anyext
     /* 3757 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3760 */ // Label 242: @3760
     /* 3760 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(3784), // Rule ID 59 //
     /* 3765 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 3768 */   // MIs[0] root
     /* 3768 */   // No operand predicates
     /* 3768 */   // MIs[0] bv
     /* 3768 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 3776 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 3779 */   // MIs[1] unused
     /* 3779 */   // No operand predicates
     /* 3779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3781 */   // Combiner Rule #57: buildvector_of_truncate
     /* 3781 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 3784 */ // Label 243: @3784
     /* 3784 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(3805), // Rule ID 46 //
     /* 3789 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 3792 */   // MIs[0] root
     /* 3792 */   // No operand predicates
     /* 3792 */   // MIs[0] ext
     /* 3792 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3796 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3800 */   // MIs[1] src
     /* 3800 */   // No operand predicates
     /* 3800 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3802 */   // Combiner Rule #44: truncate_of_sext
     /* 3802 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3805 */ // Label 244: @3805
     /* 3805 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(3826), // Rule ID 45 //
     /* 3810 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 3813 */   // MIs[0] root
     /* 3813 */   // No operand predicates
     /* 3813 */   // MIs[0] ext
     /* 3813 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 3821 */   // MIs[1] src
     /* 3821 */   // No operand predicates
     /* 3821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3823 */   // Combiner Rule #43: truncate_of_zext
     /* 3823 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 3826 */ // Label 245: @3826
     /* 3826 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(3847), // Rule ID 87 //
     /* 3831 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 3834 */   // MIs[0] dst
     /* 3834 */   // No operand predicates
     /* 3834 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 3834 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 3842 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3844 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 3844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 3847 */ // Label 246: @3847
     /* 3847 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(3868), // Rule ID 66 //
     /* 3852 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 3855 */   // MIs[0] root
     /* 3855 */   // No operand predicates
     /* 3855 */   // MIs[0] int
     /* 3855 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 3863 */   // MIs[1] imm
     /* 3863 */   // No operand predicates
     /* 3863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3865 */   // Combiner Rule #64: integer_of_truncate
     /* 3865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 3868 */ // Label 247: @3868
     /* 3868 */ GIM_Reject,
     /* 3869 */ // Label 27: @3869
     /* 3869 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(3880), // Rule ID 256 //
     /* 3874 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 3877 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 3877 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 3880 */ // Label 248: @3880
     /* 3880 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(3901), // Rule ID 51 //
     /* 3885 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 3888 */   // MIs[0] root
     /* 3888 */   // No operand predicates
     /* 3888 */   // MIs[0] second
     /* 3888 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3892 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 3896 */   // MIs[1] src
     /* 3896 */   // No operand predicates
     /* 3896 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3898 */   // Combiner Rule #49: sext_of_anyext
     /* 3898 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3901 */ // Label 249: @3901
     /* 3901 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(3922), // Rule ID 50 //
     /* 3906 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 3909 */   // MIs[0] root
     /* 3909 */   // No operand predicates
     /* 3909 */   // MIs[0] second
     /* 3909 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 3917 */   // MIs[1] src
     /* 3917 */   // No operand predicates
     /* 3917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3919 */   // Combiner Rule #48: sext_of_sext
     /* 3919 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 3922 */ // Label 250: @3922
     /* 3922 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(3943), // Rule ID 341 //
     /* 3927 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 3930 */   // MIs[0] root
     /* 3930 */   // No operand predicates
     /* 3930 */   // MIs[0] src
     /* 3930 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3934 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 3938 */   // MIs[1] x
     /* 3938 */   // No operand predicates
     /* 3938 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3940 */   // Combiner Rule #196: sext_trunc
     /* 3940 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 3943 */ // Label 251: @3943
     /* 3943 */ GIM_Reject,
     /* 3944 */ // Label 28: @3944
     /* 3944 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(3955), // Rule ID 160 //
     /* 3949 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 3952 */   // Combiner Rule #118: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 3952 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 3955 */ // Label 252: @3955
     /* 3955 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(3966), // Rule ID 168 //
     /* 3960 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 3963 */   // Combiner Rule #126: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3963 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 3966 */ // Label 253: @3966
     /* 3966 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(3977), // Rule ID 225 //
     /* 3971 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 3974 */   // Combiner Rule #162: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 3974 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 3977 */ // Label 254: @3977
     /* 3977 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(3998), // Rule ID 55 //
     /* 3982 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 3985 */   // MIs[0] dst
     /* 3985 */   // No operand predicates
     /* 3985 */   // MIs[0] x
     /* 3985 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 3989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 3993 */   // MIs[1] src
     /* 3993 */   // No operand predicates
     /* 3993 */   // MIs[1] a
     /* 3993 */   // No operand predicates
     /* 3993 */   // MIs[0] b
     /* 3993 */   // No operand predicates
     /* 3993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 3995 */   // Combiner Rule #53: sext_inreg_of_sext_inreg
     /* 3995 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 3998 */ // Label 255: @3998
     /* 3998 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(4009), // Rule ID 172 //
     /* 4003 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 4006 */   // MIs[0] dst
     /* 4006 */   // No operand predicates
     /* 4006 */   // MIs[0] src
     /* 4006 */   // No operand predicates
     /* 4006 */   // MIs[0] imm
     /* 4006 */   // No operand predicates
     /* 4006 */   // Combiner Rule #130: sext_inreg_to_zext_inreg
     /* 4006 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 4009 */ // Label 256: @4009
     /* 4009 */ GIM_Reject,
     /* 4010 */ // Label 29: @4010
     /* 4010 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(4021), // Rule ID 171 //
     /* 4015 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 4018 */   // Combiner Rule #129: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 4018 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 4021 */ // Label 257: @4021
     /* 4021 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(4032), // Rule ID 255 //
     /* 4026 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 4029 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 4029 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 4032 */ // Label 258: @4032
     /* 4032 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(4053), // Rule ID 56 //
     /* 4037 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 4040 */   // MIs[0] root
     /* 4040 */   // No operand predicates
     /* 4040 */   // MIs[0] select
     /* 4040 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 4048 */   // MIs[1] cond
     /* 4048 */   // No operand predicates
     /* 4048 */   // MIs[1] true
     /* 4048 */   // No operand predicates
     /* 4048 */   // MIs[1] false
     /* 4048 */   // No operand predicates
     /* 4048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4050 */   // Combiner Rule #54: select_of_zext
     /* 4050 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 4053 */ // Label 259: @4053
     /* 4053 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(4074), // Rule ID 49 //
     /* 4058 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 4061 */   // MIs[0] root
     /* 4061 */   // No operand predicates
     /* 4061 */   // MIs[0] second
     /* 4061 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 4069 */   // MIs[1] src
     /* 4069 */   // No operand predicates
     /* 4069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4071 */   // Combiner Rule #47: zext_of_anyext
     /* 4071 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4074 */ // Label 260: @4074
     /* 4074 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(4101), // Rule ID 342 //
     /* 4079 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 4082 */   // MIs[0] root
     /* 4082 */   // No operand predicates
     /* 4082 */   // MIs[0] src
     /* 4082 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4086 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 4090 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 4096 */   // MIs[1] x
     /* 4096 */   // No operand predicates
     /* 4096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4098 */   // Combiner Rule #197: zext_trunc
     /* 4098 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 4101 */ // Label 261: @4101
     /* 4101 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(4122), // Rule ID 48 //
     /* 4106 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 4109 */   // MIs[0] root
     /* 4109 */   // No operand predicates
     /* 4109 */   // MIs[0] second
     /* 4109 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 4117 */   // MIs[1] src
     /* 4117 */   // No operand predicates
     /* 4117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4119 */   // Combiner Rule #46: zext_of_zext
     /* 4119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 4122 */ // Label 262: @4122
     /* 4122 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(4139), // Rule ID 343 //
     /* 4127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 4130 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 4136 */   // MIs[0] root
     /* 4136 */   // No operand predicates
     /* 4136 */   // MIs[0] x
     /* 4136 */   // No operand predicates
     /* 4136 */   // Combiner Rule #198: nneg_zext
     /* 4136 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 4139 */ // Label 263: @4139
     /* 4139 */ GIM_Reject,
     /* 4140 */ // Label 30: @4140
     /* 4140 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(4151), // Rule ID 80 //
     /* 4145 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 4148 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 4148 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 4151 */ // Label 264: @4151
     /* 4151 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(4162), // Rule ID 83 //
     /* 4156 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4159 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 4159 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4162 */ // Label 265: @4162
     /* 4162 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(4173), // Rule ID 116 //
     /* 4167 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4170 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 4170 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4173 */ // Label 266: @4173
     /* 4173 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(4184), // Rule ID 200 //
     /* 4178 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4181 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 4181 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4184 */ // Label 267: @4184
     /* 4184 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(4195), // Rule ID 205 //
     /* 4189 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4192 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 4192 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4195 */ // Label 268: @4195
     /* 4195 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(4206), // Rule ID 224 //
     /* 4200 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 4203 */   // Combiner Rule #161: commute_shift; wip_match_opcode 'G_SHL'
     /* 4203 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 4206 */ // Label 269: @4206
     /* 4206 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(4217), // Rule ID 238 //
     /* 4211 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4214 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 4214 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4217 */ // Label 270: @4217
     /* 4217 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(4228), // Rule ID 291 //
     /* 4222 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4225 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 4225 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4228 */ // Label 271: @4228
     /* 4228 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(4263), // Rule ID 41 //
     /* 4233 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 4236 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 4242 */   // MIs[0] root
     /* 4242 */   // No operand predicates
     /* 4242 */   // MIs[0] left
     /* 4242 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 4250 */   // MIs[1] imm
     /* 4250 */   // No operand predicates
     /* 4250 */   // MIs[0] x
     /* 4250 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 4254 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 4258 */   // MIs[2] imm1
     /* 4258 */   // No operand predicates
     /* 4258 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 4260 */   // Combiner Rule #39: shl_of_vscale
     /* 4260 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 4263 */ // Label 272: @4263
     /* 4263 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(4286), // Rule ID 108 //
     /* 4268 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4271 */   // MIs[0] dst
     /* 4271 */   // No operand predicates
     /* 4271 */   // MIs[0] lhs
     /* 4271 */   // No operand predicates
     /* 4271 */   // MIs[0] Operand 2
     /* 4271 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4275 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4280 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 4280 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4285 */   GIR_EraseRootFromParent_Done,
     /* 4286 */ // Label 273: @4286
     /* 4286 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(4297), // Rule ID 145 //
     /* 4291 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4294 */   // MIs[0] root
     /* 4294 */   // No operand predicates
     /* 4294 */   // MIs[0] mi.shifted
     /* 4294 */   // No operand predicates
     /* 4294 */   // MIs[0] mi.amt
     /* 4294 */   // No operand predicates
     /* 4294 */   // Combiner Rule #105: shifts_too_big @ [mi[0]]
     /* 4294 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4297 */ // Label 274: @4297
     /* 4297 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(4308), // Rule ID 161 //
     /* 4302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 4305 */   // MIs[0] dst
     /* 4305 */   // No operand predicates
     /* 4305 */   // MIs[0] src0
     /* 4305 */   // No operand predicates
     /* 4305 */   // MIs[0] src1
     /* 4305 */   // No operand predicates
     /* 4305 */   // Combiner Rule #119: reduce_shl_of_extend
     /* 4305 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 4308 */ // Label 275: @4308
     /* 4308 */ GIM_Reject,
     /* 4309 */ // Label 31: @4309
     /* 4309 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(4320), // Rule ID 85 //
     /* 4314 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4317 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 4317 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4320 */ // Label 276: @4320
     /* 4320 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(4331), // Rule ID 117 //
     /* 4325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4328 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 4328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4331 */ // Label 277: @4331
     /* 4331 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(4342), // Rule ID 202 //
     /* 4336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4339 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 4339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4342 */ // Label 278: @4342
     /* 4342 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(4353), // Rule ID 207 //
     /* 4347 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4350 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 4350 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4353 */ // Label 279: @4353
     /* 4353 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(4364), // Rule ID 228 //
     /* 4358 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4361 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 4361 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4364 */ // Label 280: @4364
     /* 4364 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(4375), // Rule ID 230 //
     /* 4369 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4372 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 4372 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4375 */ // Label 281: @4375
     /* 4375 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(4386), // Rule ID 235 //
     /* 4380 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4383 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 4383 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4386 */ // Label 282: @4386
     /* 4386 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(4397), // Rule ID 289 //
     /* 4391 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4394 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 4394 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4397 */ // Label 283: @4397
     /* 4397 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(4420), // Rule ID 110 //
     /* 4402 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4405 */   // MIs[0] dst
     /* 4405 */   // No operand predicates
     /* 4405 */   // MIs[0] lhs
     /* 4405 */   // No operand predicates
     /* 4405 */   // MIs[0] Operand 2
     /* 4405 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4409 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4414 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 4414 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4419 */   GIR_EraseRootFromParent_Done,
     /* 4420 */ // Label 284: @4420
     /* 4420 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(4431), // Rule ID 147 //
     /* 4425 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4428 */   // MIs[0] root
     /* 4428 */   // No operand predicates
     /* 4428 */   // MIs[0] mi.shifted
     /* 4428 */   // No operand predicates
     /* 4428 */   // MIs[0] mi.amt
     /* 4428 */   // No operand predicates
     /* 4428 */   // Combiner Rule #105: shifts_too_big @ [mi[2]]
     /* 4428 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4431 */ // Label 285: @4431
     /* 4431 */ GIM_Reject,
     /* 4432 */ // Label 32: @4432
     /* 4432 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(4443), // Rule ID 84 //
     /* 4437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 4440 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 4440 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 4443 */ // Label 286: @4443
     /* 4443 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(4454), // Rule ID 118 //
     /* 4448 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 4451 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 4451 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 4454 */ // Label 287: @4454
     /* 4454 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(4465), // Rule ID 158 //
     /* 4459 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 4462 */   // Combiner Rule #116: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 4462 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 4465 */ // Label 288: @4465
     /* 4465 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(4476), // Rule ID 201 //
     /* 4470 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 4473 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 4473 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 4476 */ // Label 289: @4476
     /* 4476 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(4487), // Rule ID 206 //
     /* 4481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 4484 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 4484 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 4487 */ // Label 290: @4487
     /* 4487 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(4498), // Rule ID 227 //
     /* 4492 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 4495 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 4495 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 4498 */ // Label 291: @4498
     /* 4498 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(4509), // Rule ID 229 //
     /* 4503 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 4506 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 4506 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 4509 */ // Label 292: @4509
     /* 4509 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(4520), // Rule ID 234 //
     /* 4514 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 4517 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 4517 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 4520 */ // Label 293: @4520
     /* 4520 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(4531), // Rule ID 290 //
     /* 4525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 4528 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 4528 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 4531 */ // Label 294: @4531
     /* 4531 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(4554), // Rule ID 109 //
     /* 4536 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4539 */   // MIs[0] dst
     /* 4539 */   // No operand predicates
     /* 4539 */   // MIs[0] lhs
     /* 4539 */   // No operand predicates
     /* 4539 */   // MIs[0] Operand 2
     /* 4539 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4543 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4548 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 4548 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4553 */   GIR_EraseRootFromParent_Done,
     /* 4554 */ // Label 295: @4554
     /* 4554 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(4565), // Rule ID 146 //
     /* 4559 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 4562 */   // MIs[0] root
     /* 4562 */   // No operand predicates
     /* 4562 */   // MIs[0] mi.shifted
     /* 4562 */   // No operand predicates
     /* 4562 */   // MIs[0] mi.amt
     /* 4562 */   // No operand predicates
     /* 4562 */   // Combiner Rule #105: shifts_too_big @ [mi[1]]
     /* 4562 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 4565 */ // Label 296: @4565
     /* 4565 */ GIM_Reject,
     /* 4566 */ // Label 33: @4566
     /* 4566 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(4577), // Rule ID 216 //
     /* 4571 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4574 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 4574 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4577 */ // Label 297: @4577
     /* 4577 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(4588), // Rule ID 220 //
     /* 4582 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4585 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 4585 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4588 */ // Label 298: @4588
     /* 4588 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(4608), // Rule ID 219 //
     /* 4593 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 4596 */   // MIs[0] x
     /* 4596 */   // No operand predicates
     /* 4596 */   // MIs[0] y
     /* 4596 */   // No operand predicates
     /* 4596 */   // MIs[0] z
     /* 4596 */   // No operand predicates
     /* 4596 */   // MIs[0] Operand 3
     /* 4596 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4600 */   // Combiner Rule #157: funnel_shift_left_zero
     /* 4600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4603 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4605 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 4607 */   GIR_EraseRootFromParent_Done,
     /* 4608 */ // Label 299: @4608
     /* 4608 */ GIM_Reject,
     /* 4609 */ // Label 34: @4609
     /* 4609 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(4620), // Rule ID 217 //
     /* 4614 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 4617 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 4617 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 4620 */ // Label 300: @4620
     /* 4620 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(4631), // Rule ID 221 //
     /* 4625 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 4628 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 4628 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 4631 */ // Label 301: @4631
     /* 4631 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(4651), // Rule ID 218 //
     /* 4636 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 4639 */   // MIs[0] x
     /* 4639 */   // No operand predicates
     /* 4639 */   // MIs[0] y
     /* 4639 */   // No operand predicates
     /* 4639 */   // MIs[0] z
     /* 4639 */   // No operand predicates
     /* 4639 */   // MIs[0] Operand 3
     /* 4639 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 4643 */   // Combiner Rule #156: funnel_shift_right_zero
     /* 4643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 4646 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 4648 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 4650 */   GIR_EraseRootFromParent_Done,
     /* 4651 */ // Label 302: @4651
     /* 4651 */ GIM_Reject,
     /* 4652 */ // Label 35: @4652
     /* 4652 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(4675), // Rule ID 113 //
     /* 4657 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4660 */   // MIs[0] dst
     /* 4660 */   // No operand predicates
     /* 4660 */   // MIs[0] lhs
     /* 4660 */   // No operand predicates
     /* 4660 */   // MIs[0] Operand 2
     /* 4660 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4664 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4669 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 4669 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4674 */   GIR_EraseRootFromParent_Done,
     /* 4675 */ // Label 303: @4675
     /* 4675 */ GIM_Reject,
     /* 4676 */ // Label 36: @4676
     /* 4676 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(4699), // Rule ID 112 //
     /* 4681 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 4684 */   // MIs[0] dst
     /* 4684 */   // No operand predicates
     /* 4684 */   // MIs[0] lhs
     /* 4684 */   // No operand predicates
     /* 4684 */   // MIs[0] Operand 2
     /* 4684 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 4688 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4693 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 4693 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 4698 */   GIR_EraseRootFromParent_Done,
     /* 4699 */ // Label 304: @4699
     /* 4699 */ GIM_Reject,
     /* 4700 */ // Label 37: @4700
     /* 4700 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(4711), // Rule ID 153 //
     /* 4705 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 4708 */   // Combiner Rule #111: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 4708 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 4711 */ // Label 305: @4711
     /* 4711 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(4722), // Rule ID 154 //
     /* 4716 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 4719 */   // Combiner Rule #112: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 4719 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 4722 */ // Label 306: @4722
     /* 4722 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(4733), // Rule ID 157 //
     /* 4727 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 4730 */   // Combiner Rule #115: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 4730 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 4733 */ // Label 307: @4733
     /* 4733 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(4744), // Rule ID 151 //
     /* 4738 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 4741 */   // MIs[0] root
     /* 4741 */   // No operand predicates
     /* 4741 */   // MIs[0] pred
     /* 4741 */   // No operand predicates
     /* 4741 */   // MIs[0] lhs
     /* 4741 */   // No operand predicates
     /* 4741 */   // MIs[0] rhs
     /* 4741 */   // No operand predicates
     /* 4741 */   // Combiner Rule #109: canonicalize_icmp
     /* 4741 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 4744 */ // Label 308: @4744
     /* 4744 */ GIM_Reject,
     /* 4745 */ // Label 38: @4745
     /* 4745 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(4756), // Rule ID 152 //
     /* 4750 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 4753 */   // MIs[0] root
     /* 4753 */   // No operand predicates
     /* 4753 */   // MIs[0] pred
     /* 4753 */   // No operand predicates
     /* 4753 */   // MIs[0] lhs
     /* 4753 */   // No operand predicates
     /* 4753 */   // MIs[0] rhs
     /* 4753 */   // No operand predicates
     /* 4753 */   // Combiner Rule #110: canonicalize_fcmp
     /* 4753 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 4756 */ // Label 309: @4756
     /* 4756 */ GIM_Reject,
     /* 4757 */ // Label 39: @4757
     /* 4757 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(4768), // Rule ID 103 //
     /* 4762 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 4765 */   // Combiner Rule #83: select_same_val; wip_match_opcode 'G_SELECT'
     /* 4765 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 4768 */ // Label 310: @4768
     /* 4768 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(4779), // Rule ID 164 //
     /* 4773 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 4776 */   // Combiner Rule #122: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 4776 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 4779 */ // Label 311: @4779
     /* 4779 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(4790), // Rule ID 166 //
     /* 4784 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 4787 */   // Combiner Rule #124: match_selects; wip_match_opcode 'G_SELECT'
     /* 4787 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 4790 */ // Label 312: @4790
     /* 4790 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(4801), // Rule ID 306 //
     /* 4795 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 4798 */   // Combiner Rule #188: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 4798 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 4801 */ // Label 313: @4801
     /* 4801 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(4822), // Rule ID 165 //
     /* 4806 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 4809 */   // MIs[0] root
     /* 4809 */   // No operand predicates
     /* 4809 */   // MIs[0] tst
     /* 4809 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 4817 */   // MIs[1] tst1
     /* 4817 */   // No operand predicates
     /* 4817 */   // MIs[1] a
     /* 4817 */   // No operand predicates
     /* 4817 */   // MIs[1] b
     /* 4817 */   // No operand predicates
     /* 4817 */   // MIs[0] x
     /* 4817 */   // No operand predicates
     /* 4817 */   // MIs[0] y
     /* 4817 */   // No operand predicates
     /* 4817 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4819 */   // Combiner Rule #123: select_to_iminmax
     /* 4819 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 4822 */ // Label 314: @4822
     /* 4822 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(4851), // Rule ID 163 //
     /* 4827 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 4830 */   // MIs[0] dst
     /* 4830 */   // No operand predicates
     /* 4830 */   // MIs[0] undef
     /* 4830 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 4834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 4838 */   // MIs[0] x
     /* 4838 */   // No operand predicates
     /* 4838 */   // MIs[0] y
     /* 4838 */   // No operand predicates
     /* 4838 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 4845 */   // Combiner Rule #121: select_undef_cmp
     /* 4845 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 4850 */   GIR_EraseRootFromParent_Done,
     /* 4851 */ // Label 315: @4851
     /* 4851 */ GIM_Reject,
     /* 4852 */ // Label 40: @4852
     /* 4852 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(4863), // Rule ID 317 //
     /* 4857 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 4860 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 4860 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 4863 */ // Label 316: @4863
     /* 4863 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(4874), // Rule ID 358 //
     /* 4868 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 4871 */   // Combiner Rule #212: match_addos; wip_match_opcode 'G_UADDO'
     /* 4871 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4874 */ // Label 317: @4874
     /* 4874 */ GIM_Reject,
     /* 4875 */ // Label 41: @4875
     /* 4875 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(4886), // Rule ID 189 //
     /* 4880 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4883 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 4883 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4886 */ // Label 318: @4886
     /* 4886 */ GIM_Reject,
     /* 4887 */ // Label 42: @4887
     /* 4887 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(4898), // Rule ID 360 //
     /* 4892 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 4895 */   // Combiner Rule #213: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 4895 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 4898 */ // Label 319: @4898
     /* 4898 */ GIM_Reject,
     /* 4899 */ // Label 43: @4899
     /* 4899 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(4910), // Rule ID 191 //
     /* 4904 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4907 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 4907 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4910 */ // Label 320: @4910
     /* 4910 */ GIM_Reject,
     /* 4911 */ // Label 44: @4911
     /* 4911 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(4922), // Rule ID 318 //
     /* 4916 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 4919 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 4919 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 4922 */ // Label 321: @4922
     /* 4922 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(4933), // Rule ID 357 //
     /* 4927 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 4930 */   // Combiner Rule #212: match_addos; wip_match_opcode 'G_SADDO'
     /* 4930 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 4933 */ // Label 322: @4933
     /* 4933 */ GIM_Reject,
     /* 4934 */ // Label 45: @4934
     /* 4934 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(4945), // Rule ID 190 //
     /* 4939 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4942 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 4942 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4945 */ // Label 323: @4945
     /* 4945 */ GIM_Reject,
     /* 4946 */ // Label 46: @4946
     /* 4946 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(4957), // Rule ID 359 //
     /* 4951 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 4954 */   // Combiner Rule #213: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 4954 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 4957 */ // Label 324: @4957
     /* 4957 */ GIM_Reject,
     /* 4958 */ // Label 47: @4958
     /* 4958 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(4969), // Rule ID 192 //
     /* 4963 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 4966 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 4966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 4969 */ // Label 325: @4969
     /* 4969 */ GIM_Reject,
     /* 4970 */ // Label 48: @4970
     /* 4970 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(4981), // Rule ID 185 //
     /* 4975 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 4978 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 4978 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 4981 */ // Label 326: @4981
     /* 4981 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(4992), // Rule ID 187 //
     /* 4986 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 4989 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 4989 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 4992 */ // Label 327: @4992
     /* 4992 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(5003), // Rule ID 319 //
     /* 4997 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5000 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 5000 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5003 */ // Label 328: @5003
     /* 5003 */ GIM_Reject,
     /* 5004 */ // Label 49: @5004
     /* 5004 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(5015), // Rule ID 186 //
     /* 5009 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 5012 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 5012 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 5015 */ // Label 329: @5015
     /* 5015 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(5026), // Rule ID 188 //
     /* 5020 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 5023 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 5023 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 5026 */ // Label 330: @5026
     /* 5026 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(5037), // Rule ID 320 //
     /* 5031 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5034 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 5034 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5037 */ // Label 331: @5037
     /* 5037 */ GIM_Reject,
     /* 5038 */ // Label 50: @5038
     /* 5038 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(5049), // Rule ID 263 //
     /* 5043 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 5046 */   // Combiner Rule #175: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 5046 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 5049 */ // Label 332: @5049
     /* 5049 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(5060), // Rule ID 321 //
     /* 5054 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5057 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 5057 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5060 */ // Label 333: @5060
     /* 5060 */ GIM_Reject,
     /* 5061 */ // Label 51: @5061
     /* 5061 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(5072), // Rule ID 322 //
     /* 5066 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5069 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 5069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5072 */ // Label 334: @5072
     /* 5072 */ GIM_Reject,
     /* 5073 */ // Label 52: @5073
     /* 5073 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(5084), // Rule ID 323 //
     /* 5078 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5081 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 5081 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5084 */ // Label 335: @5084
     /* 5084 */ GIM_Reject,
     /* 5085 */ // Label 53: @5085
     /* 5085 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(5096), // Rule ID 324 //
     /* 5090 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5093 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 5093 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5096 */ // Label 336: @5096
     /* 5096 */ GIM_Reject,
     /* 5097 */ // Label 54: @5097
     /* 5097 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(5108), // Rule ID 204 //
     /* 5102 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5105 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 5105 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5108 */ // Label 337: @5108
     /* 5108 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(5119), // Rule ID 208 //
     /* 5113 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5116 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 5116 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5119 */ // Label 338: @5119
     /* 5119 */ GIM_Reject,
     /* 5120 */ // Label 55: @5120
     /* 5120 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(5131), // Rule ID 203 //
     /* 5125 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 5128 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5128 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 5131 */ // Label 339: @5131
     /* 5131 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(5142), // Rule ID 209 //
     /* 5136 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 5139 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 5139 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 5142 */ // Label 340: @5142
     /* 5142 */ GIM_Reject,
     /* 5143 */ // Label 56: @5143
     /* 5143 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(5154), // Rule ID 325 //
     /* 5148 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5151 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 5151 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5154 */ // Label 341: @5154
     /* 5154 */ GIM_Reject,
     /* 5155 */ // Label 57: @5155
     /* 5155 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(5166), // Rule ID 326 //
     /* 5160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5163 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 5163 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5166 */ // Label 342: @5166
     /* 5166 */ GIM_Reject,
     /* 5167 */ // Label 58: @5167
     /* 5167 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(5178), // Rule ID 327 //
     /* 5172 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5175 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 5175 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5178 */ // Label 343: @5178
     /* 5178 */ GIM_Reject,
     /* 5179 */ // Label 59: @5179
     /* 5179 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(5190), // Rule ID 328 //
     /* 5184 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 5187 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 5187 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 5190 */ // Label 344: @5190
     /* 5190 */ GIM_Reject,
     /* 5191 */ // Label 60: @5191
     /* 5191 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(5202), // Rule ID 249 //
     /* 5196 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5199 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 5199 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5202 */ // Label 345: @5202
     /* 5202 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(5213), // Rule ID 264 //
     /* 5207 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5210 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 5210 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5213 */ // Label 346: @5213
     /* 5213 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(5224), // Rule ID 271 //
     /* 5218 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 5221 */   // Combiner Rule #178: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5221 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 5224 */ // Label 347: @5224
     /* 5224 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(5235), // Rule ID 272 //
     /* 5229 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 5232 */   // Combiner Rule #179: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5232 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 5235 */ // Label 348: @5235
     /* 5235 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(5246), // Rule ID 273 //
     /* 5240 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 5243 */   // Combiner Rule #180: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5243 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 5246 */ // Label 349: @5246
     /* 5246 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(5257), // Rule ID 274 //
     /* 5251 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 5254 */   // Combiner Rule #181: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 5254 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 5257 */ // Label 350: @5257
     /* 5257 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(5268), // Rule ID 297 //
     /* 5262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5265 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 5265 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5268 */ // Label 351: @5268
     /* 5268 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(5279), // Rule ID 329 //
     /* 5273 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5276 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 5276 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5279 */ // Label 352: @5279
     /* 5279 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(5302), // Rule ID 138 //
     /* 5284 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 5287 */   // MIs[0] dst
     /* 5287 */   // No operand predicates
     /* 5287 */   // MIs[0] x
     /* 5287 */   // No operand predicates
     /* 5287 */   // MIs[0] y
     /* 5287 */   // No operand predicates
     /* 5287 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 5291 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5296 */   // Combiner Rule #100: right_identity_neg_zero_fp
     /* 5296 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5301 */   GIR_EraseRootFromParent_Done,
     /* 5302 */ // Label 353: @5302
     /* 5302 */ GIM_Reject,
     /* 5303 */ // Label 61: @5303
     /* 5303 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(5314), // Rule ID 250 //
     /* 5308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5311 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 5311 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5314 */ // Label 354: @5314
     /* 5314 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(5325), // Rule ID 265 //
     /* 5319 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5322 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 5322 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5325 */ // Label 355: @5325
     /* 5325 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(5336), // Rule ID 275 //
     /* 5330 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 5333 */   // Combiner Rule #182: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5333 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 5336 */ // Label 356: @5336
     /* 5336 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(5347), // Rule ID 276 //
     /* 5341 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 5344 */   // Combiner Rule #183: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5344 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 5347 */ // Label 357: @5347
     /* 5347 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(5358), // Rule ID 277 //
     /* 5352 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 5355 */   // Combiner Rule #184: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5355 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 5358 */ // Label 358: @5358
     /* 5358 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(5369), // Rule ID 278 //
     /* 5363 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 5366 */   // Combiner Rule #185: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 5366 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 5369 */ // Label 359: @5369
     /* 5369 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(5380), // Rule ID 298 //
     /* 5374 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5377 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 5377 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5380 */ // Label 360: @5380
     /* 5380 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(5391), // Rule ID 307 //
     /* 5385 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 5388 */   // Combiner Rule #189: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 5388 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 5391 */ // Label 361: @5391
     /* 5391 */ GIM_Reject,
     /* 5392 */ // Label 62: @5392
     /* 5392 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(5403), // Rule ID 251 //
     /* 5397 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5400 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 5400 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5403 */ // Label 362: @5403
     /* 5403 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(5414), // Rule ID 266 //
     /* 5408 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5411 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 5411 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5414 */ // Label 363: @5414
     /* 5414 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(5425), // Rule ID 296 //
     /* 5419 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5422 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 5422 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5425 */ // Label 364: @5425
     /* 5425 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(5436), // Rule ID 330 //
     /* 5430 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5433 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 5433 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5436 */ // Label 365: @5436
     /* 5436 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(5459), // Rule ID 129 //
     /* 5441 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 5444 */   // MIs[0] dst
     /* 5444 */   // No operand predicates
     /* 5444 */   // MIs[0] x
     /* 5444 */   // No operand predicates
     /* 5444 */   // MIs[0] y
     /* 5444 */   // No operand predicates
     /* 5444 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 5448 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5453 */   // Combiner Rule #93: right_identity_one_fp
     /* 5453 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5458 */   GIR_EraseRootFromParent_Done,
     /* 5459 */ // Label 366: @5459
     /* 5459 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(5479), // Rule ID 139 //
     /* 5464 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 5467 */   // MIs[0] dst
     /* 5467 */   // No operand predicates
     /* 5467 */   // MIs[0] x
     /* 5467 */   // No operand predicates
     /* 5467 */   // MIs[0] y
     /* 5467 */   // No operand predicates
     /* 5467 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 5471 */   // Combiner Rule #101: right_identity_neg_one_fp
     /* 5471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5474 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5476 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 5478 */   GIR_EraseRootFromParent_Done,
     /* 5479 */ // Label 367: @5479
     /* 5479 */ GIM_Reject,
     /* 5480 */ // Label 63: @5480
     /* 5480 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(5491), // Rule ID 254 //
     /* 5485 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5488 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 5488 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5491 */ // Label 368: @5491
     /* 5491 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(5502), // Rule ID 269 //
     /* 5496 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5499 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 5499 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5502 */ // Label 369: @5502
     /* 5502 */ GIM_Reject,
     /* 5503 */ // Label 64: @5503
     /* 5503 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(5514), // Rule ID 253 //
     /* 5508 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 5511 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 5511 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 5514 */ // Label 370: @5514
     /* 5514 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(5525), // Rule ID 268 //
     /* 5519 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5522 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 5522 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5525 */ // Label 371: @5525
     /* 5525 */ GIM_Reject,
     /* 5526 */ // Label 65: @5526
     /* 5526 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(5537), // Rule ID 252 //
     /* 5531 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 5534 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 5534 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 5537 */ // Label 372: @5537
     /* 5537 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(5548), // Rule ID 267 //
     /* 5542 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 5545 */   // Combiner Rule #176: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 5545 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 5548 */ // Label 373: @5548
     /* 5548 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(5559), // Rule ID 299 //
     /* 5553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5556 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 5556 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5559 */ // Label 374: @5559
     /* 5559 */ GIM_Reject,
     /* 5560 */ // Label 66: @5560
     /* 5560 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(5571), // Rule ID 300 //
     /* 5565 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5568 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 5568 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5571 */ // Label 375: @5571
     /* 5571 */ GIM_Reject,
     /* 5572 */ // Label 67: @5572
     /* 5572 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(5593), // Rule ID 197 //
     /* 5577 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 5580 */   // MIs[0] dst
     /* 5580 */   // No operand predicates
     /* 5580 */   // MIs[0] float
     /* 5580 */   // No operand predicates
     /* 5580 */   // MIs[0] int
     /* 5580 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 5584 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 5588 */   // MIs[1] imm
     /* 5588 */   // No operand predicates
     /* 5588 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5590 */   // Combiner Rule #147: expand_const_fpowi
     /* 5590 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 5593 */ // Label 376: @5593
     /* 5593 */ GIM_Reject,
     /* 5594 */ // Label 68: @5594
     /* 5594 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(5615), // Rule ID 179 //
     /* 5599 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 5602 */   // MIs[0] dst
     /* 5602 */   // No operand predicates
     /* 5602 */   // MIs[0] src0
     /* 5602 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5610 */   // MIs[1] cst
     /* 5610 */   // No operand predicates
     /* 5610 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5612 */   // Combiner Rule #137: constant_fold_flog2
     /* 5612 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5615 */ // Label 377: @5615
     /* 5615 */ GIM_Reject,
     /* 5616 */ // Label 69: @5616
     /* 5616 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(5637), // Rule ID 176 //
     /* 5621 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 5624 */   // MIs[0] dst
     /* 5624 */   // No operand predicates
     /* 5624 */   // MIs[0] src0
     /* 5624 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5632 */   // MIs[1] cst
     /* 5632 */   // No operand predicates
     /* 5632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5634 */   // Combiner Rule #134: constant_fold_fneg
     /* 5634 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5637 */ // Label 378: @5637
     /* 5637 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(5666), // Rule ID 127 //
     /* 5642 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 5645 */   // MIs[0] dst
     /* 5645 */   // No operand predicates
     /* 5645 */   // MIs[0] t
     /* 5645 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5649 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5653 */   // MIs[1] src
     /* 5653 */   // No operand predicates
     /* 5653 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5658 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5660 */   // Combiner Rule #91: fneg_fneg_fold
     /* 5660 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 5665 */   GIR_EraseRootFromParent_Done,
     /* 5666 */ // Label 379: @5666
     /* 5666 */ GIM_Reject,
     /* 5667 */ // Label 70: @5667
     /* 5667 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(5688), // Rule ID 180 //
     /* 5672 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 5675 */   // MIs[0] dst
     /* 5675 */   // No operand predicates
     /* 5675 */   // MIs[0] src0
     /* 5675 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5679 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5683 */   // MIs[1] cst
     /* 5683 */   // No operand predicates
     /* 5683 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5685 */   // Combiner Rule #138: constant_fold_fptrunc
     /* 5685 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5688 */ // Label 380: @5688
     /* 5688 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(5709), // Rule ID 137 //
     /* 5693 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 5696 */   // MIs[0] dst
     /* 5696 */   // No operand predicates
     /* 5696 */   // MIs[0] src1
     /* 5696 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 5704 */   // MIs[1] src0
     /* 5704 */   // No operand predicates
     /* 5704 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5706 */   // Combiner Rule #99: fptrunc_fpext_fold
     /* 5706 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 5709 */ // Label 381: @5709
     /* 5709 */ GIM_Reject,
     /* 5710 */ // Label 71: @5710
     /* 5710 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(5731), // Rule ID 92 //
     /* 5715 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 5718 */   // MIs[0] dst
     /* 5718 */   // No operand predicates
     /* 5718 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5718 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5726 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5728 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 5728 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 5731 */ // Label 382: @5731
     /* 5731 */ GIM_Reject,
     /* 5732 */ // Label 72: @5732
     /* 5732 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(5753), // Rule ID 93 //
     /* 5737 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 5740 */   // MIs[0] dst
     /* 5740 */   // No operand predicates
     /* 5740 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 5740 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 5748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5750 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 5750 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 5753 */ // Label 383: @5753
     /* 5753 */ GIM_Reject,
     /* 5754 */ // Label 73: @5754
     /* 5754 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(5765), // Rule ID 76 //
     /* 5759 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 5762 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 5762 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 5765 */ // Label 384: @5765
     /* 5765 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(5780), // Rule ID 181 //
     /* 5770 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 5773 */   // MIs[0] dst
     /* 5773 */   // No operand predicates
     /* 5773 */   // MIs[0] Operand 1
     /* 5773 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5777 */   // Combiner Rule #139: itof_const_zero_fold_si
     /* 5777 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 5780 */ // Label 385: @5780
     /* 5780 */ GIM_Reject,
     /* 5781 */ // Label 74: @5781
     /* 5781 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(5792), // Rule ID 75 //
     /* 5786 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 5789 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 5789 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 5792 */ // Label 386: @5792
     /* 5792 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(5807), // Rule ID 182 //
     /* 5797 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 5800 */   // MIs[0] dst
     /* 5800 */   // No operand predicates
     /* 5800 */   // MIs[0] Operand 1
     /* 5800 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 5804 */   // Combiner Rule #140: itof_const_zero_fold_ui
     /* 5804 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 5807 */ // Label 387: @5807
     /* 5807 */ GIM_Reject,
     /* 5808 */ // Label 75: @5808
     /* 5808 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(5837), // Rule ID 19 //
     /* 5813 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5816 */   // MIs[0] dst
     /* 5816 */   // No operand predicates
     /* 5816 */   // MIs[0] src
     /* 5816 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5824 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5824 */   // No operand predicates
     /* 5824 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5831 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 5831 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5836 */   GIR_EraseRootFromParent_Done,
     /* 5837 */ // Label 388: @5837
     /* 5837 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(5858), // Rule ID 177 //
     /* 5842 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 5845 */   // MIs[0] dst
     /* 5845 */   // No operand predicates
     /* 5845 */   // MIs[0] src0
     /* 5845 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 5853 */   // MIs[1] cst
     /* 5853 */   // No operand predicates
     /* 5853 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5855 */   // Combiner Rule #135: constant_fold_fabs
     /* 5855 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 5858 */ // Label 389: @5858
     /* 5858 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(5886), // Rule ID 258 //
     /* 5863 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 5866 */   // MIs[0] dst
     /* 5866 */   // No operand predicates
     /* 5866 */   // MIs[0] tmp
     /* 5866 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 5874 */   // MIs[1] x
     /* 5874 */   // No operand predicates
     /* 5874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5876 */   // Combiner Rule #170: fabs_fneg_fold
     /* 5876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 5879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 5881 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 5885 */   GIR_EraseRootFromParent_Done,
     /* 5886 */ // Label 390: @5886
     /* 5886 */ GIM_Reject,
     /* 5887 */ // Label 76: @5887
     /* 5887 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(5916), // Rule ID 20 //
     /* 5892 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 5895 */   // MIs[0] dst
     /* 5895 */   // No operand predicates
     /* 5895 */   // MIs[0] src
     /* 5895 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 5899 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 5903 */   // MIs[1] __idempotent_prop_match_0.x
     /* 5903 */   // No operand predicates
     /* 5903 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5908 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 5910 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 5910 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 5915 */   GIR_EraseRootFromParent_Done,
     /* 5916 */ // Label 391: @5916
     /* 5916 */ GIM_Reject,
     /* 5917 */ // Label 77: @5917
     /* 5917 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(5928), // Rule ID 193 //
     /* 5922 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 5925 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 5925 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5928 */ // Label 392: @5928
     /* 5928 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(5939), // Rule ID 301 //
     /* 5933 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5936 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 5936 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5939 */ // Label 393: @5939
     /* 5939 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(5950), // Rule ID 331 //
     /* 5944 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5947 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 5947 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5950 */ // Label 394: @5950
     /* 5950 */ GIM_Reject,
     /* 5951 */ // Label 78: @5951
     /* 5951 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(5962), // Rule ID 194 //
     /* 5956 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 5959 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 5959 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 5962 */ // Label 395: @5962
     /* 5962 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(5973), // Rule ID 302 //
     /* 5967 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 5970 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 5970 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 5973 */ // Label 396: @5973
     /* 5973 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(5984), // Rule ID 332 //
     /* 5978 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5981 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 5981 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5984 */ // Label 397: @5984
     /* 5984 */ GIM_Reject,
     /* 5985 */ // Label 79: @5985
     /* 5985 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(5996), // Rule ID 333 //
     /* 5990 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 5993 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 5993 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 5996 */ // Label 398: @5996
     /* 5996 */ GIM_Reject,
     /* 5997 */ // Label 80: @5997
     /* 5997 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(6008), // Rule ID 334 //
     /* 6002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6005 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 6005 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6008 */ // Label 399: @6008
     /* 6008 */ GIM_Reject,
     /* 6009 */ // Label 81: @6009
     /* 6009 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(6020), // Rule ID 195 //
     /* 6014 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6017 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 6017 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6020 */ // Label 400: @6020
     /* 6020 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(6031), // Rule ID 303 //
     /* 6025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6028 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 6028 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6031 */ // Label 401: @6031
     /* 6031 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(6042), // Rule ID 335 //
     /* 6036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6039 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 6039 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6042 */ // Label 402: @6042
     /* 6042 */ GIM_Reject,
     /* 6043 */ // Label 82: @6043
     /* 6043 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(6054), // Rule ID 196 //
     /* 6048 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 6051 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 6051 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 6054 */ // Label 403: @6054
     /* 6054 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(6065), // Rule ID 304 //
     /* 6059 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6062 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 6062 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6065 */ // Label 404: @6065
     /* 6065 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(6076), // Rule ID 336 //
     /* 6070 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 6073 */   // Combiner Rule #191: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 6073 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 6076 */ // Label 405: @6076
     /* 6076 */ GIM_Reject,
     /* 6077 */ // Label 83: @6077
     /* 6077 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(6088), // Rule ID 148 //
     /* 6082 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 6085 */   // Combiner Rule #106: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 6085 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 6088 */ // Label 406: @6088
     /* 6088 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(6099), // Rule ID 150 //
     /* 6093 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 6096 */   // Combiner Rule #108: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 6096 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 6099 */ // Label 407: @6099
     /* 6099 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(6110), // Rule ID 183 //
     /* 6104 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 6107 */   // Combiner Rule #141: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 6107 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 6110 */ // Label 408: @6110
     /* 6110 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(6121), // Rule ID 199 //
     /* 6115 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 6118 */   // Combiner Rule #149: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 6118 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 6121 */ // Label 409: @6121
     /* 6121 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(6132), // Rule ID 232 //
     /* 6126 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6129 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 6129 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6132 */ // Label 410: @6132
     /* 6132 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(6143), // Rule ID 281 //
     /* 6137 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6140 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 6140 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6143 */ // Label 411: @6143
     /* 6143 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(6166), // Rule ID 111 //
     /* 6148 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 6151 */   // MIs[0] dst
     /* 6151 */   // No operand predicates
     /* 6151 */   // MIs[0] lhs
     /* 6151 */   // No operand predicates
     /* 6151 */   // MIs[0] Operand 2
     /* 6151 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 6155 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6160 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 6160 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6165 */   GIR_EraseRootFromParent_Done,
     /* 6166 */ // Label 412: @6166
     /* 6166 */ GIM_Reject,
     /* 6167 */ // Label 84: @6167
     /* 6167 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(6178), // Rule ID 245 //
     /* 6172 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6175 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 6175 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6178 */ // Label 413: @6178
     /* 6178 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(6189), // Rule ID 292 //
     /* 6183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6186 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 6186 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6189 */ // Label 414: @6189
     /* 6189 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(6200), // Rule ID 313 //
     /* 6194 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6197 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 6197 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6200 */ // Label 415: @6200
     /* 6200 */ GIM_Reject,
     /* 6201 */ // Label 85: @6201
     /* 6201 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(6212), // Rule ID 246 //
     /* 6206 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6209 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 6209 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6212 */ // Label 416: @6212
     /* 6212 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(6223), // Rule ID 293 //
     /* 6217 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6220 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 6220 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6223 */ // Label 417: @6223
     /* 6223 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(6234), // Rule ID 314 //
     /* 6228 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6231 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 6231 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6234 */ // Label 418: @6234
     /* 6234 */ GIM_Reject,
     /* 6235 */ // Label 86: @6235
     /* 6235 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(6246), // Rule ID 247 //
     /* 6240 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6243 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 6243 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6246 */ // Label 419: @6246
     /* 6246 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(6257), // Rule ID 294 //
     /* 6251 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6254 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 6254 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6257 */ // Label 420: @6257
     /* 6257 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(6268), // Rule ID 315 //
     /* 6262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6265 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 6265 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6268 */ // Label 421: @6268
     /* 6268 */ GIM_Reject,
     /* 6269 */ // Label 87: @6269
     /* 6269 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(6280), // Rule ID 248 //
     /* 6274 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 6277 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 6277 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 6280 */ // Label 422: @6280
     /* 6280 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(6291), // Rule ID 295 //
     /* 6285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 6288 */   // Combiner Rule #186: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 6288 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 6291 */ // Label 423: @6291
     /* 6291 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(6302), // Rule ID 316 //
     /* 6296 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 6299 */   // Combiner Rule #190: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 6299 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 6302 */ // Label 424: @6302
     /* 6302 */ GIM_Reject,
     /* 6303 */ // Label 88: @6303
     /* 6303 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(6314), // Rule ID 86 //
     /* 6308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 6311 */   // Combiner Rule #76: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 6311 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 6314 */ // Label 425: @6314
     /* 6314 */ GIM_Reject,
     /* 6315 */ // Label 89: @6315
     /* 6315 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(6326), // Rule ID 175 //
     /* 6320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 6323 */   // Combiner Rule #133: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 6323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 6326 */ // Label 426: @6326
     /* 6326 */ GIM_Reject,
     /* 6327 */ // Label 90: @6327
     /* 6327 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(6338), // Rule ID 26 //
     /* 6332 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 6335 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6335 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 6338 */ // Label 427: @6338
     /* 6338 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(6349), // Rule ID 67 //
     /* 6343 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 6346 */   // Combiner Rule #65: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6346 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 6349 */ // Label 428: @6349
     /* 6349 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(6360), // Rule ID 101 //
     /* 6354 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6357 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 6357 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6360 */ // Label 429: @6360
     /* 6360 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(6399), // Rule ID 38 //
     /* 6365 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 6368 */   // MIs[0] root
     /* 6368 */   // No operand predicates
     /* 6368 */   // MIs[0] src
     /* 6368 */   // No operand predicates
     /* 6368 */   // MIs[0] elt
     /* 6368 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6372 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 6376 */   // MIs[1] src
     /* 6376 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 6381 */   // MIs[1] idx
     /* 6381 */   // No operand predicates
     /* 6381 */   // MIs[0] idx
     /* 6381 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 6386 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6393 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 6393 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6398 */   GIR_EraseRootFromParent_Done,
     /* 6399 */ // Label 430: @6399
     /* 6399 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(6432), // Rule ID 24 //
     /* 6404 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 6407 */   // MIs[0] root
     /* 6407 */   // No operand predicates
     /* 6407 */   // MIs[0] src
     /* 6407 */   // No operand predicates
     /* 6407 */   // MIs[0] elt
     /* 6407 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6415 */   // MIs[0] idx
     /* 6415 */   // No operand predicates
     /* 6415 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 6419 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6426 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 6426 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 6431 */   GIR_EraseRootFromParent_Done,
     /* 6432 */ // Label 431: @6432
     /* 6432 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(6456), // Rule ID 23 //
     /* 6437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 6440 */   // MIs[0] root
     /* 6440 */   // No operand predicates
     /* 6440 */   // MIs[0] src
     /* 6440 */   // No operand predicates
     /* 6440 */   // MIs[0] elt
     /* 6440 */   // No operand predicates
     /* 6440 */   // MIs[0] idx
     /* 6440 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 6444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6450 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 6450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6453 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6455 */   GIR_EraseRootFromParent_Done,
     /* 6456 */ // Label 432: @6456
     /* 6456 */ GIM_Reject,
     /* 6457 */ // Label 91: @6457
     /* 6457 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(6468), // Rule ID 25 //
     /* 6462 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 6465 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6465 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 6468 */ // Label 433: @6468
     /* 6468 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(6479), // Rule ID 68 //
     /* 6473 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 6476 */   // Combiner Rule #66: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6476 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 6479 */ // Label 434: @6479
     /* 6479 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(6490), // Rule ID 74 //
     /* 6484 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 6487 */   // Combiner Rule #70: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6487 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 6490 */ // Label 435: @6490
     /* 6490 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(6501), // Rule ID 102 //
     /* 6495 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 6498 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 6498 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 6501 */ // Label 436: @6501
     /* 6501 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(6525), // Rule ID 36 //
     /* 6506 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 6509 */   // MIs[0] root
     /* 6509 */   // No operand predicates
     /* 6509 */   // MIs[0] src
     /* 6509 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6513 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6517 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 6520 */   // MIs[1] x
     /* 6520 */   // No operand predicates
     /* 6520 */   // MIs[1] y
     /* 6520 */   // No operand predicates
     /* 6520 */   // MIs[1] z
     /* 6520 */   // No operand predicates
     /* 6520 */   // MIs[1] a
     /* 6520 */   // No operand predicates
     /* 6520 */   // MIs[1] b
     /* 6520 */   // No operand predicates
     /* 6520 */   // MIs[1] c
     /* 6520 */   // No operand predicates
     /* 6520 */   // MIs[1] d
     /* 6520 */   // No operand predicates
     /* 6520 */   // MIs[1] e
     /* 6520 */   // No operand predicates
     /* 6520 */   // MIs[0] idx
     /* 6520 */   // No operand predicates
     /* 6520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6522 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 6522 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6525 */ // Label 437: @6525
     /* 6525 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(6549), // Rule ID 35 //
     /* 6530 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 6533 */   // MIs[0] root
     /* 6533 */   // No operand predicates
     /* 6533 */   // MIs[0] src
     /* 6533 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6541 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 6544 */   // MIs[1] x
     /* 6544 */   // No operand predicates
     /* 6544 */   // MIs[1] y
     /* 6544 */   // No operand predicates
     /* 6544 */   // MIs[1] z
     /* 6544 */   // No operand predicates
     /* 6544 */   // MIs[1] a
     /* 6544 */   // No operand predicates
     /* 6544 */   // MIs[1] b
     /* 6544 */   // No operand predicates
     /* 6544 */   // MIs[1] c
     /* 6544 */   // No operand predicates
     /* 6544 */   // MIs[1] d
     /* 6544 */   // No operand predicates
     /* 6544 */   // MIs[0] idx
     /* 6544 */   // No operand predicates
     /* 6544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6546 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 6546 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6549 */ // Label 438: @6549
     /* 6549 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(6573), // Rule ID 34 //
     /* 6554 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 6557 */   // MIs[0] root
     /* 6557 */   // No operand predicates
     /* 6557 */   // MIs[0] src
     /* 6557 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6565 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 6568 */   // MIs[1] x
     /* 6568 */   // No operand predicates
     /* 6568 */   // MIs[1] y
     /* 6568 */   // No operand predicates
     /* 6568 */   // MIs[1] z
     /* 6568 */   // No operand predicates
     /* 6568 */   // MIs[1] a
     /* 6568 */   // No operand predicates
     /* 6568 */   // MIs[1] b
     /* 6568 */   // No operand predicates
     /* 6568 */   // MIs[1] c
     /* 6568 */   // No operand predicates
     /* 6568 */   // MIs[0] idx
     /* 6568 */   // No operand predicates
     /* 6568 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6570 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 6570 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6573 */ // Label 439: @6573
     /* 6573 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(6597), // Rule ID 33 //
     /* 6578 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 6581 */   // MIs[0] root
     /* 6581 */   // No operand predicates
     /* 6581 */   // MIs[0] src
     /* 6581 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6589 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 6592 */   // MIs[1] x
     /* 6592 */   // No operand predicates
     /* 6592 */   // MIs[1] y
     /* 6592 */   // No operand predicates
     /* 6592 */   // MIs[1] z
     /* 6592 */   // No operand predicates
     /* 6592 */   // MIs[1] a
     /* 6592 */   // No operand predicates
     /* 6592 */   // MIs[1] b
     /* 6592 */   // No operand predicates
     /* 6592 */   // MIs[0] idx
     /* 6592 */   // No operand predicates
     /* 6592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6594 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 6594 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6597 */ // Label 440: @6597
     /* 6597 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(6621), // Rule ID 32 //
     /* 6602 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 6605 */   // MIs[0] root
     /* 6605 */   // No operand predicates
     /* 6605 */   // MIs[0] src
     /* 6605 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6609 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6613 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 6616 */   // MIs[1] x
     /* 6616 */   // No operand predicates
     /* 6616 */   // MIs[1] y
     /* 6616 */   // No operand predicates
     /* 6616 */   // MIs[1] z
     /* 6616 */   // No operand predicates
     /* 6616 */   // MIs[1] a
     /* 6616 */   // No operand predicates
     /* 6616 */   // MIs[0] idx
     /* 6616 */   // No operand predicates
     /* 6616 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6618 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 6618 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6621 */ // Label 441: @6621
     /* 6621 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(6645), // Rule ID 31 //
     /* 6626 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 6629 */   // MIs[0] root
     /* 6629 */   // No operand predicates
     /* 6629 */   // MIs[0] src
     /* 6629 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6637 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 6640 */   // MIs[1] x
     /* 6640 */   // No operand predicates
     /* 6640 */   // MIs[1] y
     /* 6640 */   // No operand predicates
     /* 6640 */   // MIs[1] z
     /* 6640 */   // No operand predicates
     /* 6640 */   // MIs[0] idx
     /* 6640 */   // No operand predicates
     /* 6640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6642 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 6642 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6645 */ // Label 442: @6645
     /* 6645 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(6679), // Rule ID 27 //
     /* 6650 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 6653 */   // MIs[0] root
     /* 6653 */   // No operand predicates
     /* 6653 */   // MIs[0] src
     /* 6653 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6661 */   // MIs[1] x
     /* 6661 */   // No operand predicates
     /* 6661 */   // MIs[1] value
     /* 6661 */   // No operand predicates
     /* 6661 */   // MIs[1] idx
     /* 6661 */   // No operand predicates
     /* 6661 */   // MIs[0] idx
     /* 6661 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 6666 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6671 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6673 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 6673 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 6678 */   GIR_EraseRootFromParent_Done,
     /* 6679 */ // Label 443: @6679
     /* 6679 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(6700), // Rule ID 28 //
     /* 6684 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 6687 */   // MIs[0] root
     /* 6687 */   // No operand predicates
     /* 6687 */   // MIs[0] src
     /* 6687 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6691 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 6695 */   // MIs[1] x
     /* 6695 */   // No operand predicates
     /* 6695 */   // MIs[1] value
     /* 6695 */   // No operand predicates
     /* 6695 */   // MIs[1] idx2
     /* 6695 */   // No operand predicates
     /* 6695 */   // MIs[0] idx1
     /* 6695 */   // No operand predicates
     /* 6695 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6697 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 6697 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 6700 */ // Label 444: @6700
     /* 6700 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(6729), // Rule ID 37 //
     /* 6705 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 6708 */   // MIs[0] root
     /* 6708 */   // No operand predicates
     /* 6708 */   // MIs[0] src
     /* 6708 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 6716 */   // MIs[1] src1
     /* 6716 */   // No operand predicates
     /* 6716 */   // MIs[1] src2
     /* 6716 */   // No operand predicates
     /* 6716 */   // MIs[1] mask
     /* 6716 */   // No operand predicates
     /* 6716 */   // MIs[0] idx
     /* 6716 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6720 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6724 */   // MIs[2] imm
     /* 6724 */   // No operand predicates
     /* 6724 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6726 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 6726 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 6729 */ // Label 445: @6729
     /* 6729 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(6753), // Rule ID 30 //
     /* 6734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 6737 */   // MIs[0] root
     /* 6737 */   // No operand predicates
     /* 6737 */   // MIs[0] src
     /* 6737 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6741 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 6745 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 6748 */   // MIs[1] x
     /* 6748 */   // No operand predicates
     /* 6748 */   // MIs[1] y
     /* 6748 */   // No operand predicates
     /* 6748 */   // MIs[0] idx
     /* 6748 */   // No operand predicates
     /* 6748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6750 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 6750 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 6753 */ // Label 446: @6753
     /* 6753 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(6785), // Rule ID 29 //
     /* 6758 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 6761 */   // MIs[0] root
     /* 6761 */   // No operand predicates
     /* 6761 */   // MIs[0] src
     /* 6761 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 6769 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 6772 */   // MIs[1] unused
     /* 6772 */   // No operand predicates
     /* 6772 */   // MIs[0] idx
     /* 6772 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 6776 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 6780 */   // MIs[2] imm
     /* 6780 */   // No operand predicates
     /* 6780 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6782 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 6782 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 6785 */ // Label 447: @6785
     /* 6785 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(6809), // Rule ID 21 //
     /* 6790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 6793 */   // MIs[0] root
     /* 6793 */   // No operand predicates
     /* 6793 */   // MIs[0] vector
     /* 6793 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6801 */   // MIs[0] idx
     /* 6801 */   // No operand predicates
     /* 6801 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6803 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 6803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6806 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6808 */   GIR_EraseRootFromParent_Done,
     /* 6809 */ // Label 448: @6809
     /* 6809 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(6833), // Rule ID 22 //
     /* 6814 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 6817 */   // MIs[0] root
     /* 6817 */   // No operand predicates
     /* 6817 */   // MIs[0] vector
     /* 6817 */   // No operand predicates
     /* 6817 */   // MIs[0] idx
     /* 6817 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6821 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6825 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6827 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 6827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6830 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 6832 */   GIR_EraseRootFromParent_Done,
     /* 6833 */ // Label 449: @6833
     /* 6833 */ GIM_Reject,
     /* 6834 */ // Label 92: @6834
     /* 6834 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(6845), // Rule ID 97 //
     /* 6839 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 6842 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6842 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 6845 */ // Label 450: @6845
     /* 6845 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(6856), // Rule ID 99 //
     /* 6850 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 6853 */   // Combiner Rule #80: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6853 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 6856 */ // Label 451: @6856
     /* 6856 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(6867), // Rule ID 344 //
     /* 6861 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 6864 */   // Combiner Rule #199: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6864 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 6867 */ // Label 452: @6867
     /* 6867 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(6878), // Rule ID 346 //
     /* 6872 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 6875 */   // Combiner Rule #201: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 6875 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 6878 */ // Label 453: @6878
     /* 6878 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(6899), // Rule ID 345 //
     /* 6883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 6886 */   // MIs[0] root
     /* 6886 */   // No operand predicates
     /* 6886 */   // MIs[0] src1
     /* 6886 */   // No operand predicates
     /* 6886 */   // MIs[0] undef
     /* 6886 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 6890 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 6894 */   // MIs[0] mask
     /* 6894 */   // No operand predicates
     /* 6894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 6896 */   // Combiner Rule #200: combine_shuffle_undef_rhs
     /* 6896 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 6899 */ // Label 454: @6899
     /* 6899 */ GIM_Reject,
     /* 6900 */ // Label 93: @6900
     /* 6900 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(6944), // Rule ID 223 //
     /* 6905 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 6908 */   // MIs[0] d
     /* 6908 */   // No operand predicates
     /* 6908 */   // MIs[0] src
     /* 6908 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6916 */   // MIs[1] rev
     /* 6916 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6920 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6924 */   // MIs[2] val
     /* 6924 */   // No operand predicates
     /* 6924 */   // MIs[1] amt
     /* 6924 */   // No operand predicates
     /* 6924 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 6928 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6930 */   // Combiner Rule #160: bitreverse_lshr
     /* 6930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6933 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6935 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 6939 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 6943 */   GIR_EraseRootFromParent_Done,
     /* 6944 */ // Label 455: @6944
     /* 6944 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(6988), // Rule ID 222 //
     /* 6949 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 6952 */   // MIs[0] d
     /* 6952 */   // No operand predicates
     /* 6952 */   // MIs[0] src
     /* 6952 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 6956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 6960 */   // MIs[1] rev
     /* 6960 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 6964 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 6968 */   // MIs[2] val
     /* 6968 */   // No operand predicates
     /* 6968 */   // MIs[1] amt
     /* 6968 */   // No operand predicates
     /* 6968 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 6972 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 6974 */   // Combiner Rule #159: bitreverse_shl
     /* 6974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 6977 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 6979 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 6983 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 6987 */   GIR_EraseRootFromParent_Done,
     /* 6988 */ // Label 456: @6988
     /* 6988 */ GIM_Reject,
     /* 6989 */ // Label 94: @6989
     /* 6989 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(7010), // Rule ID 178 //
     /* 6994 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 6997 */   // MIs[0] dst
     /* 6997 */   // No operand predicates
     /* 6997 */   // MIs[0] src0
     /* 6997 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 7001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 7005 */   // MIs[1] cst
     /* 7005 */   // No operand predicates
     /* 7005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 7007 */   // Combiner Rule #136: constant_fold_fsqrt
     /* 7007 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 7010 */ // Label 457: @7010
     /* 7010 */ GIM_Reject,
     /* 7011 */ // Label 95: @7011
     /* 7011 */ GIM_Reject,
     /* 7012 */ }; // Size: 7012 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

